(**********************************************************************

    :Program.    Cache
    :Contents.   An- und Ausschalten des Prozessorcaches
    :Author.     Steffen Reith
    :Address.    Hessenstr. 64, D-8700 Wrzburg
    :Phone.      0931/281859
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga A+L V4.096d
    :System.     $$Date: 05-06-1991  22:36:18
    :System.     $$CompilerRuns #13#
    :History.    V1.0

**********************************************************************)
IMPLEMENTATION MODULE Cache;

(*$ LargeVars:=FALSE StackParms:=FALSE Volatile:=FALSE *)
(*$ StackChk:=FALSE RangeChk:=FALSE OverflowChk:=FALSE
    NilChk:=FALSE CaseChk:=FALSE *)

FROM ExecD  IMPORT execBase,AttnFlags,AttnFlagSet;
FROM ExecL  IMPORT SuperState,UserState,Permit,Forbid;
FROM SYSTEM IMPORT ASSEMBLE,ADDRESS;

IMPORT R;

VAR OldState:RECORD
              Data,Inst:BOOLEAN
             END;

PROCEDURE AskProzessorType():AttnFlagSet;

BEGIN
 RETURN execBase^.attnFlags
END AskProzessorType;

PROCEDURE AskDataCache():BOOLEAN;

VAR P:AttnFlagSet;
    OldStack:ADDRESS;
    DataOn:BOOLEAN;

BEGIN
 P:=AskProzessorType();
 IF (m68030 IN P) OR (m68040 IN P) THEN
  Forbid();
  OldStack:=SuperState();

  ASSEMBLE(

   MOVEC CACR,D0

   BTST #8,D0
   BEQ.S NoData
   MOVE.B #-1,DataOn(A5) (* DataOn ist TRUE *)
   BRA.S Weiter1
   NoData:
   MOVE.B #0,DataOn(A5)  (* DataOn ist FALSE *)
   Weiter1:
  END);

  UserState(OldStack);
  Permit();

  RETURN DataOn
 ELSE
  RETURN FALSE
 END;
END AskDataCache;

PROCEDURE AskInstCache():BOOLEAN;

VAR P:AttnFlagSet;
    OldStack:ADDRESS;
    InstOn:BOOLEAN;

BEGIN
 P:=AskProzessorType();
 IF (m68020 IN P) OR (m68030 IN P) OR (m68040 IN P) THEN
  Forbid();
  OldStack:=SuperState();

  ASSEMBLE(

   MOVEC CACR,D0

   BTST #0,D0
   BEQ.S NoInst
   MOVE.B #-1,InstOn(A5) (* DataOn ist TRUE *)
   BRA.S Weiter2
   NoInst:
   MOVE.B #0,InstOn(A5)  (* DataOn ist FALSE *)
   Weiter2:
  END);

  UserState(OldStack);
  Permit();

  RETURN InstOn
 ELSE
  RETURN FALSE
 END;
END AskInstCache;

PROCEDURE SetDataCache(On:BOOLEAN);

VAR P:AttnFlagSet;
    OldStack:ADDRESS;

BEGIN
 P:=AskProzessorType();
 IF (m68030 IN P) OR (m68040 IN P) THEN
  Forbid();
  OldStack:=SuperState();

  ASSEMBLE(

   MOVEC CACR,D0

   TST.B On(A5)
   BEQ Off
   BSET #8,D0
   BRA.S Set
   Off:
   BCLR #8,D0
   Set:
   MOVEC D0,CACR

  END);

  UserState(OldStack);
  Permit();
 END;
END SetDataCache;

PROCEDURE SetInstCache(On:BOOLEAN);

VAR P:AttnFlagSet;
    OldStack:ADDRESS;

BEGIN
 P:=AskProzessorType();
 IF (m68020 IN P) OR (m68030 IN P) OR (m68040 IN P) THEN
  Forbid();
  OldStack:=SuperState();

  ASSEMBLE(

   MOVEC CACR,D0

   TST.B On(A5)
   BEQ Off
   BSET #0,D0
   BRA.S Set
   Off:
   BCLR #0,D0
   Set:
   MOVEC D0,CACR

  END);

  UserState(OldStack);
  Permit();
 END;
END SetInstCache;


BEGIN
 OldState.Data:=AskDataCache();
 OldState.Inst:=AskInstCache();
 CLOSE
 SetDataCache(OldState.Data);
 SetInstCache(OldState.Inst)
END Cache.