(* ------------------------------------------------------------------------
  :Program.       DateSupport.mod
  :Author.        Ingo Goldak
  :Address.       Hohenzollerndamm 8, 1000 Berlin 31
  :Phone.         030 / 883 74 77
  :Copyright.     PD
  :Language.      Modula-2
  :Translator.    M2Amiga 4.0d
  :History.       v1.0 Ingo 20-Okt-91
  :Contents.      PROCEDUREs zur Verarbeitung von Jahres-/Monats-Daten
------------------------------------------------------------------------ *)
IMPLEMENTATION MODULE DateSupport;

FROM SYSTEM IMPORT ADR;
FROM IntuitionL IMPORT CurrentTime;
FROM Conversions IMPORT ValToStr;
FROM String IMPORT Copy,Concat,ConcatChar;


CONST StartYear = 1978;
      DaysInYear = 365;
      SecondsInDay = 86400;
      DaysInFourYears = (4*DaysInYear)+1;


PROCEDURE CurrentDate(VAR day,month,year:CARDINAL);

VAR seconds,microseconds:LONGCARD;

BEGIN
  CurrentTime(ADR(seconds),ADR(microseconds));
  SecondsToDayMonthYear(seconds,day,month,year);
END CurrentDate;


PROCEDURE SecondsToDayMonthYear(seconds:LONGCARD;
                                VAR day,month,year:CARDINAL);

CONST January  =31;
      (* February is variable ! *)
      March    =31;
      April    =30;
      May      =31;
      June     =30;
      July     =31;
      August   =31;
      September=30;
      October  =31;
      November =30;
      December =31;

VAR Days,FourYears,Years,Remain:CARDINAL;
    February:CARDINAL;

BEGIN
  Days:=seconds DIV SecondsInDay;
  FourYears:=Days DIV DaysInFourYears;
  Years:=(Days MOD DaysInFourYears) DIV DaysInYear;
  Remain:=(Days MOD DaysInFourYears) MOD DaysInYear;
  IF Years=3
  THEN
    IF Remain>0
    THEN
      DEC(Remain);
    ELSE
      Remain:=365;
      Years:=2;
    END; (* IF *)
  END; (* IF *)
  year:=StartYear+(4*FourYears)+Years;
  IF ((year MOD 4)=0)
  THEN
    February:=29;
  ELSE
    February:=28;
  END; (* IF *)
  month:=1;
  INC(Remain);
  IF Remain<=January
  THEN
    day:=Remain;
  ELSE
    DEC(Remain,January);
    INC(month);
    IF Remain<=February
    THEN
      day:=Remain;
    ELSE
      DEC(Remain,February);
      INC(month);
      IF Remain<=March
      THEN
        day:=Remain;
      ELSE
        DEC(Remain,March);
        INC(month);
        IF Remain<=April
        THEN
          day:=Remain;
        ELSE
          DEC(Remain,April);
          INC(month);
          IF Remain<=May
          THEN
            day:=Remain;
          ELSE
            DEC(Remain,May);
            INC(month);
            IF Remain<=June
            THEN
              day:=Remain;
            ELSE
              DEC(Remain,June);
              INC(month);
              IF Remain<=July
              THEN
                day:=Remain;
              ELSE
                DEC(Remain,July);
                INC(month);
                IF Remain<=August
                THEN
                  day:=Remain;
                ELSE
                  DEC(Remain,August);
                  INC(month);
                  IF Remain<=September
                  THEN
                    day:=Remain;
                  ELSE
                    DEC(Remain,September);
                    INC(month);
                    IF Remain<=October
                    THEN
                      day:=Remain;
                    ELSE
                      DEC(Remain,October);
                      INC(month);
                      IF Remain<=November
                      THEN
                        day:=Remain;
                      ELSE
                        DEC(Remain,November);
                        INC(month);
                        IF Remain<=December
                        THEN
                          day:=Remain;
                        ELSE
HALT;
                          DEC(Remain,December);
                          INC(month);
                        END; (* IF December *)
                      END; (* IF November *)
                    END; (* IF October *)
                  END; (* IF September *)
                END; (* IF August *)
              END; (* IF July *)
            END; (* IF June *)
          END; (* IF May *)
        END; (* IF April *)
      END; (* IF March *)
    END; (* IF February *)
  END; (* IF January *)
END SecondsToDayMonthYear;


PROCEDURE DayMonthYearToSeconds(day,month,year:CARDINAL;
                                VAR seconds:LONGCARD);

VAR yearDays,monthDays,fourYears:LONGCARD;
    leap:BOOLEAN;

BEGIN
  IF year<StartYear
  THEN
    seconds:=0;
  ELSE
    DEC(year,StartYear);
    fourYears:=year DIV 4;
    year:=year MOD 4;
    leap:=(year=0);
    yearDays:=(fourYears*DaysInFourYears)+(year*DaysInYear);
    CASE month OF
      1 : monthDays:=0;
    | 2 : monthDays:=31;
    | 3 : IF leap
          THEN
            monthDays:=60;
          ELSE
            monthDays:=59;
          END; (* IF *)
    | 4 : IF leap
          THEN
            monthDays:=91;
          ELSE
            monthDays:=90;
          END; (* IF *)
    | 5 : IF leap
          THEN
            monthDays:=121;
          ELSE
            monthDays:=120;
          END; (* IF *)
    | 6 : IF leap
          THEN
            monthDays:=152;
          ELSE
            monthDays:=151;
          END; (* IF *)
    | 7 : IF leap
          THEN
            monthDays:=182;
          ELSE
            monthDays:=181;
          END; (* IF *)
    | 8 : IF leap
          THEN
            monthDays:=213;
          ELSE
            monthDays:=212;
          END; (* IF *)
    | 9 : IF leap
          THEN
            monthDays:=244;
          ELSE
            monthDays:=243;
          END; (* IF *)
    |10 : IF leap
          THEN
            monthDays:=274;
          ELSE
            monthDays:=273;
          END; (* IF *)
    |11 : IF leap
          THEN
            monthDays:=305;
          ELSE
            monthDays:=304;
          END; (* IF *)
    |12 : IF leap
          THEN
            monthDays:=335;
          ELSE
            monthDays:=334;
          END; (* IF *)
    ELSE
    END; (* CASE *)
    seconds:=(yearDays+monthDays+day-1)*SecondsInDay;
  END; (* IF *)
END DayMonthYearToSeconds;


PROCEDURE FormatDate(day,month,year:CARDINAL;
                     FillChar:CHAR;
                     Mode:MonthMode;
                     LongYear:BOOLEAN;
                     VAR Datum:ARRAY OF CHAR);

VAR Day:ARRAY [0..2] OF CHAR;
    Month:ARRAY [0..10] OF CHAR;
    Year:ARRAY [0..4] OF CHAR;
    error:BOOLEAN;

BEGIN
  ValToStr(day,FALSE,Day,10,2,'0',error);
  CASE Mode OF
    number : ValToStr(month,FALSE,Month,10,2,'0',error);
  | Gthree : CASE month OF
               1 : Month:="Jan";
             | 2 : Month:="Feb";
             | 3 : Month:="Mr";
             | 4 : Month:="Apr";
             | 5 : Month:="Mai";
             | 6 : Month:="Jun";
             | 7 : Month:="Jul";
             | 8 : Month:="Aug";
             | 9 : Month:="Sep";
             |10 : Month:="Okt";
             |11 : Month:="Nov";
             |12 : Month:="Dez";
             ELSE
             END; (* CASE *)
  | Ethree : CASE month OF
               1 : Month:="Jan";
             | 2 : Month:="Feb";
             | 3 : Month:="Mar";
             | 4 : Month:="Apr";
             | 5 : Month:="May";
             | 6 : Month:="Jun";
             | 7 : Month:="Jul";
             | 8 : Month:="Aug";
             | 9 : Month:="Sep";
             |10 : Month:="Oct";
             |11 : Month:="Nov";
             |12 : Month:="Dec";
             ELSE
             END; (* CASE *)
  | Glong  : CASE month OF
               1 : Month:="Januar";
             | 2 : Month:="Februar";
             | 3 : Month:="Mrz";
             | 4 : Month:="April";
             | 5 : Month:="Mai";
             | 6 : Month:="Juni";
             | 7 : Month:="Juli";
             | 8 : Month:="August";
             | 9 : Month:="September";
             |10 : Month:="Oktober";
             |11 : Month:="November";
             |12 : Month:="Dezember";
             ELSE
             END; (* CASE *)
  | Elong  : CASE month OF
               1 : Month:="January";
             | 2 : Month:="February";
             | 3 : Month:="March";
             | 4 : Month:="April";
             | 5 : Month:="May";
             | 6 : Month:="June";
             | 7 : Month:="July";
             | 8 : Month:="August";
             | 9 : Month:="September";
             |10 : Month:="October";
             |11 : Month:="November";
             |12 : Month:="December";
             ELSE
             END; (* CASE *)
  END; (* CASE Mode *)
  IF LongYear
  THEN
    ValToStr(year,FALSE,Year,10,4,'0',error);
  ELSE
    ValToStr((year MOD 100),FALSE,Year,10,2,'0',error);
  END; (* IF *)
  Copy(Datum,Day);
  ConcatChar(Datum,FillChar);
  Concat(Datum,Month);
  ConcatChar(Datum,FillChar);
  Concat(Datum,Year);
END FormatDate;


END DateSupport.
