(* ------------------------------------------------------------------------
  :Program.     Test.mod
  :Contents.    Test-Programm fr STRINGs
  :Author.      Uwe Zaeh
  :Address.     Steiner Str. 17
  :Address.     D-(W)8543 Hilpoltstein
  :History.     10.10.91, V1.0
  :Copyright.   PD, siehe auch Dokumentation
  :Language.    Oberon
  :Translator.  Amiga-Oberon V2.0
  :Remark.      importiert das Modul STRING
------------------------------------------------------------------------ *)

MODULE Test;

IMPORT S:STRING,
       so: Strings,
       io,
       NoGuru;


CONST sl = 60;
      vl = 60;

VAR stat, vol: S.STRING;
    aoc: ARRAY 80 OF CHAR;
    d: BOOLEAN;
    nr: LONGINT;
    c: CHAR;
    stelle: INTEGER;
    erg: INTEGER;


PROCEDURE ReadVol();   (* immer in vol lesen *)
BEGIN
 io.ReadString(aoc);
 S.AOCToSTRING(aoc, vol);
END ReadVol;



PROCEDURE WriteStat();   (* immer aus stat schreiben *)
BEGIN
 S.STRINGToAOC(stat, aoc);
 io.WriteString(aoc); io.WriteLn;
END WriteStat;



PROCEDURE Copy();
BEGIN
 io.WriteString("String: "); ReadVol();
 S.Copy(stat, vol);
END Copy;


PROCEDURE Compare();
BEGIN
 io.WriteString("mit String: "); ReadVol();
 erg := S.Compare(stat, vol);
 io.WriteString("Ergebnis: "); io.WriteInt(erg,1); io.WriteLn;
END Compare;


PROCEDURE Length();
BEGIN
 io.WriteString("Lnge: ");
 io.WriteInt(S.Length(stat),1);
 io.WriteLn;
END Length;


PROCEDURE MaxLen();
BEGIN
 io.WriteString("MaxLnge: ");
 io.WriteInt(S.MaxLen(stat),1);
 io.WriteLn;
END MaxLen;


PROCEDURE Erase();
BEGIN
 S.Erase(stat);
END Erase;


PROCEDURE Prepend();
BEGIN
 io.WriteString("String: "); ReadVol();
 S.Prepend(stat, vol);
END Prepend;


PROCEDURE Append();
BEGIN
 io.WriteString("String: "); ReadVol();
 S.Append(stat, vol);
END Append;


PROCEDURE PrependChar();
BEGIN
 io.WriteString("Char: "); io.Read(c);
 S.PrependChar(stat, c);
END PrependChar;


PROCEDURE AppendChar();
BEGIN
 io.WriteString("Char: "); io.Read(c);
 S.AppendChar(stat, c);
END AppendChar;


PROCEDURE Menue();
BEGIN
 io.WriteString("Bitte whlen:"); io.WriteLn; io.WriteLn;
 io.WriteString("0. Men"); io.WriteLn;
 io.WriteString("1. Copy");  io.WriteLn;
 io.WriteString("2. Compare"); io.WriteLn;
 io.WriteString("3. Length"); io.WriteLn;
 io.WriteString("4. MaxLen"); io.WriteLn;
 io.WriteString("5. Prepend"); io.WriteLn;
 io.WriteString("6. Append"); io.WriteLn;
 io.WriteString("7. PrependChar"); io.WriteLn;
 io.WriteString("8. AppendChar"); io.WriteLn;
 io.WriteString("9. Erase"); io.WriteLn;

 io.WriteString("-1 --> ENDE"); io.WriteLn;
 io.WriteLn;
END Menue;


BEGIN

 vol := S.Create(sl);
 stat := S.Create(vl);
 IF (vol # NIL) AND (stat # NIL) THEN
  io.WriteLn; io.WriteString("Testprogramm zu STRING - V1.0 Sept. 91  Uwe Zaeh"); io.WriteLn;
  io.WriteLn;
  Menue();
  REPEAT
   io.WriteString("> ");

   REPEAT
    d := io.ReadInt(nr);
   UNTIL ((nr <= 11) AND (nr >= -1));

   IF nr # -1 THEN
     CASE nr OF
          0: Menue(); |
          1: Copy(); |
          2: Compare(); |
          3: Length(); |
          4: MaxLen(); |
          5: Prepend(); |
          6: Append(); |
          7: PrependChar(); |
          8: AppendChar(); |
          9: Erase; |
     END;
   END;
  io.WriteString("Akt. Inhalt: "); WriteStat();
  io.WriteLn;

  UNTIL nr = -1;

 END;
 IF vol # NIL THEN S.Forget(vol) END;
 IF stat # NIL THEN S.Forget(stat) END;

END Test.
