(**********************************************************************

:Program.    WBFarben

:Copyright.  "freely distributable"

:Author.     Thomas Ansorge

:Address.    Dinkelackerring 55, W-6730 Neustadt, Deutschland

:Language.   Modula-2

:Translator. M2Amiga V4.0 (deutsch)

:Imports.    OFont.OpenFont, kann notfalls durch GraphicsL.OpenFont
:Imports.       ersetzt werden.

:History.    Version 2.8 vom 01.11.1991

:Update.     2.0 vom 13.06.1990: erste lauffhige Version,
:Update.         m2c V3.3d, verffentlicht auf AMOK#40
:Update.     2.1 vom 20.01.1991: um SetWindowTitles ergnzt,
:Update.         m2c V3.32 und M2Optimize
:Update.     2.2 vom 27.01.1991: Fenster pat sich dem Screenfont an
:Update.     2.3 vom 28.04.1991: Fenster ist nun vllig immun gegen
:Update.         System- und Screenfont, nachdem ein Anpassen nicht
:Update.         befriedigend realisiert werden konnte.
:Update.     2.4 vom 01.05.1991: erweitert um ein Men zur Auswahl
:Update.         der Original-Farben
:Update.     2.5 vom 23.05.1991: ab jetzt M2Amiga V4.0
:Update.     2.6 vom 18.07 1991: x/y-Position des Fensters beim
:Update.         ffnen kann angegeben werden
:Update.     2.7 vom 23.07.1991: erweitert um ein vom Benutzer zu
:Update.         definierendes "Anwender"-Men
:Update.     2.8 vom 01.11.1991: Eine Reihe ungeklrter Gurus ist
:Update.         ENDLICH aufgeklrt, der Fehler beseitigt!
:Update.         zweite verffentlichte Version.

:Contents.   zum schnellen Wechseln der Workbenchfarbe, z. Bsp. 
:Contents.   WBench 1.3 <-> WBench 2.0 (derzeit ja brandaktuell!)

**********************************************************************)

MODULE WBFarben;

FROM Arguments IMPORT GetArg, NumArgs;

FROM Arts IMPORT Assert;

FROM ASCII IMPORT eol, nul;

FROM Conversions IMPORT StrToVal, ValToStr;

FROM ExecL IMPORT WaitPort, GetMsg, ReplyMsg;

FROM FileSystem IMPORT Close, File, Lookup, ReadChar, Response;

FROM GraphicsD IMPORT FontFlags, FontFlagSet, FontStyles, FontStyleSet, jam2,
   TextAttr, TextAttrPtr, TextFontPtr, ViewModes, ViewModeSet, ViewPort;

FROM GraphicsL IMPORT CloseFont, Draw, Move, RectFill, SetAPen, TextLength;

FROM IntuiMacros IMPORT ItemNum, MenuNum;

FROM IntuitionD IMPORT ActivationFlags, ActivationFlagSet, boolGadget,
   Border, Gadget, GadgetFlags, GadgetFlagSet, GadgetPtr, IDCMPFlags,
   IDCMPFlagSet, IntuiMessage, IntuiMessagePtr, IntuiText, IntuiTextPtr,
   Menu, MenuItem, MenuItemFlags, MenuItemFlagSet, NewWindow, Preferences,
   Screen, ScreenPtr, ScreenFlags, ScreenFlagSet, Window, WindowFlags,
   WindowFlagSet, WindowPtr;

FROM IntuitionL IMPORT ClearMenuStrip, CloseWindow, GetDefPrefs, GetPrefs,
   OpenWindow, PrintIText, RefreshGList, SetMenuStrip, SetPrefs,
   SetWindowTitles;

FROM OFont IMPORT OpenFont;

FROM String IMPORT Copy;

FROM SYSTEM IMPORT ADR, BITSET, LONGSET;

(* ---------------------------------------------------------------------- *)

CONST GText1 = " Anwender ";
      GText2 = " Original ";

      FTitel = "WBFarben";
      STitel = "WBFarben  1991 Thomas Ansorge";

      FName    = "topaz.font";
      FGroesse = 8;

      M0Text  = "Original-Gadget:";
      MI0Text = "WBench 1.1 - 1.3";
      HK0Text = "1 ";
      MI1Text = "WBench 2.0      ";
      HK1Text = "2 ";
      MI2Text = "Default-Farben  ";
      HK2Text = "d ";

      M1Text  = "Anwender-Gadget:";
      MI3Text = MI2Text;

      AnwenderMax = 32;

TYPE TInhalt = RECORD
                  Name  : ARRAY [0..16] OF CHAR;
                  SCut  : CHAR;
                  Farben: ARRAY [0..3] OF CARDINAL;
               END (* RECORD *);

VAR (* das Fenster mit den Gadgets *)
    NeuesFenster: NewWindow;
    Fenster     : WindowPtr;
    ITitel      : IntuiText;
    ISpace      : IntuiText;

    (* der Font *)
    Attr: TextAttr;
    Font: TextFontPtr;

    (* der Nachrichtenport *)
    Nachricht: IntuiMessagePtr;
    Flags    : IDCMPFlagSet;
    Adresse  : GadgetPtr;
    Nummer   : INTEGER;

    (* die Gadgets *)
    Original,
    Anwender     : Gadget;
    OriginalText,
    AnwenderText : IntuiText;
    Rahmen       : Border;
    Ecken        : ARRAY [0..9] OF INTEGER;

    (* das Men *)
    Menue     : ARRAY [0..1] OF Menu;
    MenueItem1: ARRAY [0..2] OF MenuItem;
    MenueItem2: ARRAY [1..AnwenderMax + 1] OF MenuItem;
    MenueText1: ARRAY [0..3] OF IntuiText;
    MenueText2: ARRAY [1..AnwenderMax + 1] OF IntuiText;
    INummer,
    MNummer,
    MCode     : CARDINAL;
    M0Breite,
    M1Breite  : INTEGER;
    HKBreite  : INTEGER;

    (* globale Variable fr das Anwender-Gadget *)
    Zeile   : ARRAY [1..AnwenderMax], [0..35] OF CHAR;

    (* die Farben *)
    Farben: ARRAY [0..1], [0..3] OF CARDINAL;
    Backup: ARRAY [0..1], [0..3] OF CARDINAL;

    (* der Preferences-Record *)
    Prefs: Preferences;

    (* Argumente beim Aufruf *)
    Argument  : ARRAY [0..4] OF CHAR;
    Laenge    : INTEGER;
    Vorzeichen: BOOLEAN;

    (* Datei *)
    Inhalt: ARRAY [1..AnwenderMax] OF TInhalt;

    (* diverses *)
    Anzahl: INTEGER; (* zuerst fr NumArgs (), dann fr die Anzahl der    *)
       (* Anwender-Farben in der cnf-Datei                                *)
    i     : LONGINT;
    Erfolg: BOOLEAN;

(* ---------------------------------------------------------------------- *)

PROCEDURE InitMenue ();

   (* initialisiert das Men, fast alle Variablen sind global *)

   VAR i     : CARDINAL;

   (* ------------------------------------------------------------------- *)

   PROCEDURE Parser (): CARDINAL;

      (* liest die Datei ein und untersucht sie auf Fehler *)

      (* Bitte lachen Sie nicht ber meinen Parser. Es ist mein erster    *)
      (* und ich bin froh, da er berhaupt luft!                        *)

      (* ---------------------------------------------------------------- *)

      CONST CNFDefaultName = "S:WBFarben.cnf";

      TYPE Modi = (MName, MSCut, MFarbe0, MFarbe1, MFarbe2, MFarbe3);

      VAR (* die Datei *)
          CNFName: ARRAY [0..80] OF CHAR;
          Datei  : File;
          Zeichen: CHAR; (* jeweils eingelesenes Zeichen *)

          (* interpretieren *)
          Farbe : ARRAY [0..3] OF CHAR;
          FCode : LONGINT;
          Fehler: BOOLEAN;
          Modus : Modi;
          n     : [1..AnwenderMax + 1];
          Nummer: [0..3];

          (* diverses *)
          i       : CARDINAL;
          VZeichen: BOOLEAN;
          LZeichen: CHAR;

      (* ---------------------------------------------------------------- *)

      PROCEDURE Hex (VAR Ch: CHAR): BOOLEAN;

         (* ermittelt, ob Ch eine gltige Hex-Ziffer ist *)

         (* ------------------------------------------------------------- *)

         BEGIN (* Funktion Hex *)

         Ch := CAP (Ch);

         IF ((Ch >= "0") AND (Ch <= "9")) OR
            ((Ch >= "A") AND (Ch <= "F")) THEN
            RETURN TRUE;
         ELSE
            RETURN FALSE;
         END (* IF *);
      END Hex (* Funktion *);

      (* ---------------------------------------------------------------- *)

      PROCEDURE LiesZeile (Datei  : File;
                           Zeichen: CHAR ): BOOLEAN;

         (* liest im Fehlerfalle die Zeile fertig ohne sie zu bearbeiten  *)
         (* und gibe TRUE (fr Fehler aufgetreten) zurck                 *)

         VAR Muell   : CHAR;

         (* ------------------------------------------------------------- *)

         BEGIN (* Prozedur Lieszeile *)

         REPEAT
            ReadChar (Datei, Muell);
         UNTIL (Muell = eol) OR (Datei.eof);

         Zeichen := Muell;

         RETURN TRUE;
      END LiesZeile (* Prozedur *);

      (* ---------------------------------------------------------------- *)

      BEGIN (* Funktion Parser *)

      CNFName := "";
      Copy (CNFName, CNFDefaultName);
      
      Lookup (Datei, CNFName, 256, FALSE);

      IF Datei.res # done THEN
         RETURN 1;
      END (* IF Datei *);

      (* Datei Zeichen fr Zeichen einlesen und interpretieren *)

      n := 1;

      REPEAT
         Fehler := FALSE;
         i := 0;
         Inhalt [n].SCut := nul;
         LZeichen := nul;
         Modus := MIN (Modi);

         REPEAT
            ReadChar (Datei, Zeichen);

            IF NOT Datei.eof THEN
               IF (Zeichen = eol) AND (LZeichen # "|") THEN
                  Fehler := TRUE;
               ELSE (* IF (Zeichen *)
                  LZeichen := Zeichen;
               END (* IF (Zeichen *);

               IF (Zeichen # eol) THEN
                  IF Zeichen # "|" THEN
                     CASE Modus OF
                        |MName  : Inhalt [n].Name [i] := Zeichen;
                                  INC (i);

                                  IF i > 16 THEN
                                     (* Fehler: Name zu lang *)
                                     Fehler := LiesZeile (Datei, Zeichen);
                                  END (* IF i *);

                        |MSCut  : IF Inhalt [n].SCut = nul THEN
                                     Inhalt [n].SCut := Zeichen;
                                  ELSE (* IF Inhalt *)
                                     Fehler := LiesZeile (Datei, Zeichen);
                                  END (* IF Inhalt *);

                        |MFarbe0: Nummer := 0;

                                  IF Hex (Zeichen) AND (i < 3) THEN
                                     Farbe [i] := Zeichen;
                                     INC (i);
                                  ELSE (* IF Hex *)
                                     Fehler := LiesZeile (Datei, Zeichen);
                                  END (* IF Hex *);

                        |MFarbe1: Nummer := 1;

                                  IF Hex (Zeichen) AND (i < 3) THEN
                                     Farbe [i] := Zeichen;
                                     INC (i);
                                  ELSE (* IF Hex *)
                                     Fehler := LiesZeile (Datei, Zeichen);
                                  END (* IF Hex *);

                        |MFarbe2: Nummer := 2;

                                  IF Hex (Zeichen) AND (i < 3) THEN
                                     Farbe [i] := Zeichen;
                                     INC (i);
                                  ELSE (* IF Hex *)
                                     Fehler := LiesZeile (Datei, Zeichen);
                                  END (* IF Hex *);

                        |MFarbe3: Nummer := 3;

                                  IF Hex (Zeichen) AND (i < 3) THEN
                                     Farbe [i] := Zeichen;
                                     INC (i);
                                  ELSE (* IF Hex *)
                                     Fehler := LiesZeile (Datei, Zeichen);
                                  END (* IF Hex *);

                     ELSE (* CASE Modus *)
                        Assert (FALSE, ADR ("INTERN: Parser: CASE Modus OF"));
                     END (* CASE Modus *);
                  ELSE (* IF Zeichen # "|" *)
                     IF Modus = MName THEN
                        Inhalt [n].Name [i] := nul;
                        i := 0;
                     ELSIF (Modus >= MFarbe0) AND (Modus <= MFarbe3) THEN
                        IF i = 0 THEN
                           Fehler := LiesZeile (Datei, Zeichen);
                        ELSE (* IF i = 0 *)
                           Farbe [i] := nul;

                           VZeichen := FALSE;
                           StrToVal (Farbe, FCode, VZeichen, 16, Fehler);
                           Inhalt [n].Farben [Nummer] := CARDINAL (FCode);

                           i := 0;
                        END (* IF i *);
                     ELSIF Modus = MAX (Modi) THEN
                        Fehler := LiesZeile (Datei, Zeichen);
                        Fehler := FALSE;
                     END (* IF Modus *);

                     IF Modus = MAX (Modi) THEN
                        Modus := MIN (Modi);
                     ELSE (* IF Modus *)
                        INC (Modus);
                     END (* IF Modus *);
                  END (* IF Zeichen *);
               END (* IF (Zeichen *);
            END (* IF NOT Datei.eof *);
         UNTIL Fehler OR (Zeichen = eol) OR Datei.eof;

         IF (n = AnwenderMax - 1) AND NOT Fehler THEN
            Datei.eof := TRUE; (* Einlesen beenden *)
         END (* IF n *);

         IF NOT Datei.eof AND (Nummer = 3) AND NOT Fehler THEN
            INC (n);
         END (* IF NOT Fehler *);
      UNTIL Datei.eof;

      Close (Datei);

      RETURN n;
   END Parser (* Funktion *);

   (* ------------------------------------------------------------------- *)

   PROCEDURE SetBits (Anzahl: CARDINAL;
                      i     : CARDINAL): LONGSET;

      (* fr mutualExclude *)

      VAR LSet: LONGSET;
          j   : CARDINAL;

      (* ---------------------------------------------------------------- *)

      BEGIN (* Funktion SetBits *)

      LSet := LONGSET {};

      FOR j := 0 TO Anzahl DO
         IF j # (i - 1) THEN
            (* Bit setzen *)
            CASE j OF
               | 0: INCL (LSet,  0);
               | 1: INCL (LSet,  1);
               | 2: INCL (LSet,  2);
               | 3: INCL (LSet,  3);
               | 4: INCL (LSet,  4);
               | 5: INCL (LSet,  5);
               | 6: INCL (LSet,  6);
               | 7: INCL (LSet,  7);
               | 8: INCL (LSet,  8);
               | 9: INCL (LSet,  9);
               |10: INCL (LSet, 10);
               |11: INCL (LSet, 11);
               |12: INCL (LSet, 12);
               |13: INCL (LSet, 13);
               |14: INCL (LSet, 14);
               |15: INCL (LSet, 15);
               |16: INCL (LSet, 16);
               |17: INCL (LSet, 17);
               |18: INCL (LSet, 18);
               |19: INCL (LSet, 19);
               |20: INCL (LSet, 20);
               |21: INCL (LSet, 21);
               |22: INCL (LSet, 22);
               |23: INCL (LSet, 23);
               |24: INCL (LSet, 24);
               |25: INCL (LSet, 25);
               |26: INCL (LSet, 26);
               |27: INCL (LSet, 27);
               |28: INCL (LSet, 28);
               |29: INCL (LSet, 29);
               |30: INCL (LSet, 30);
               |31: INCL (LSet, 31);
            END (* CASE j *);
         END (* IF i *);
      END (* FOR j *);

      RETURN LSet;
   END SetBits (* Funktion *);

   (* ------------------------------------------------------------------- *)

   BEGIN (* InitMen *)

   (* Breite von Original errechnen *)

   M0Breite := TextLength (ADR (Fenster^.wScreen^.rastPort),
                           ADR (MI0Text), 16);

   IF TextLength (ADR (Fenster^.wScreen^.rastPort), ADR (MI1Text), 16) >
      M0Breite THEN
      M0Breite := TextLength (ADR (Fenster^.wScreen^.rastPort),
                              ADR (MI1Text), 16);
   END (* IF *);

   IF TextLength (ADR (Fenster^.wScreen^.rastPort), ADR (MI2Text), 16) >
      M0Breite THEN
      M0Breite := TextLength (ADR (Fenster^.wScreen^.rastPort),
                              ADR (MI2Text), 16);
   END (* IF *);

   HKBreite := TextLength (ADR (Fenster^.wScreen^.rastPort),
                           ADR (HK0Text), 1);

   IF TextLength (ADR (Fenster^.wScreen^.rastPort), ADR (HK1Text), 1) >
      HKBreite THEN
      HKBreite := TextLength (ADR (Fenster^.wScreen^.rastPort),
                              ADR (HK1Text), 1);
   END (* IF *);

   IF TextLength (ADR (Fenster^.wScreen^.rastPort), ADR (HK2Text), 1) >
      HKBreite THEN
      HKBreite := TextLength (ADR (Fenster^.wScreen^.rastPort),
                              ADR (HK2Text), 1);
   END (* IF *);

   M0Breite := M0Breite + HKBreite;
   M1Breite := M0Breite;

   WITH MenueText1 [2] DO
      frontPen := 0;
      backPen := 1;
      drawMode := jam2;
      leftEdge := 20;
      topEdge := 2;
      iTextFont := NIL;
      iText := ADR (MI2Text);
      nextText := NIL;
   END (* WITH MenueText1 [2] *);

   MenueText1 [1] := MenueText1 [2];
   MenueText1 [1].iText := ADR (MI1Text);

   MenueText1 [0] := MenueText1 [1];
   MenueText1 [0].iText := ADR (MI0Text);

   WITH MenueItem1 [2] DO
      nextItem := NIL;
      leftEdge := 0;
      topEdge := 2 * (Prefs.fontHeight + 4);
      width := M0Breite + 52;
      height := Prefs.fontHeight + 4;
      flags := MenuItemFlagSet {checkIt, itemText, itemEnabled, commSeq,
                                highBox, menuToggled};
      mutualExclude := LONGSET {0, 1};
      itemFill := ADR (MenueText1 [2]);
      selectFill := NIL;
      command := "d";
      subItem := NIL;
      nextSelect := 0;
   END (* WITH MenueItem1 [2] *);

   MenueItem1 [1] := MenueItem1 [2];

   WITH MenueItem1 [1] DO
      nextItem := ADR (MenueItem1 [2]);
      topEdge := Prefs.fontHeight + 4;
      mutualExclude := LONGSET {0, 2};
      itemFill := ADR (MenueText1 [1]);
      command := "2";
   END (* WITH MenueItem1 [1] *);

   MenueItem1 [0] := MenueItem1 [1];

   WITH MenueItem1 [0] DO
      nextItem := ADR (MenueItem1 [1]);
      topEdge := 0;
      mutualExclude := LONGSET {1, 2};
      itemFill := ADR (MenueText1 [0]);
      command := "1";
   END (* WITH MenueItem1 [0] *);

   WITH Menue [0] DO
      nextMenu := NIL;
      leftEdge := 0;
      topEdge := 0;
      width := TextLength (ADR (Fenster^.wScreen^.rastPort),
                           ADR (M0Text), 16) + 4;
      height := 10;
      flags := BITSET {0};
      menuName := ADR (M0Text);
      firstItem := ADR (MenueItem1 [0]);
   END (* WITH Menue [0] *);

   (* Anwender-Men *)

   Anzahl := Parser () - 1;

   FOR i := 1 TO Anzahl DO
      WITH MenueText2 [i] DO
         frontPen := 0;
         backPen := 1;
         drawMode := jam2;
         leftEdge := 20;
         topEdge := 2;
         iTextFont := NIL;
         iText := ADR (Inhalt [i].Name);
         nextText := NIL;
      END (* WITH MenueText2 [i] *);

      WITH MenueItem2 [i] DO
         nextItem := NIL;
         leftEdge := 0;
         topEdge := (i - 1) * (Prefs.fontHeight + 4);
         width := M1Breite + 52;
         height := Prefs.fontHeight + 4;
         flags := MenuItemFlagSet {checkIt, itemText, itemEnabled, highBox,
            menuToggled};
         mutualExclude := SetBits (Anzahl, i);
         itemFill := ADR (MenueText2 [i]);
         selectFill := NIL;

         IF Inhalt [i].SCut # nul THEN
            command := Inhalt [i].SCut;
            INCL (flags, commSeq);
         ELSE (* IF Inhalt *)
            command := " ";
         END (* IF Inhalt *);

         subItem := NIL;
         nextSelect := 0;
      END (* WITH MenueItem2 [i] *);

      IF i # 1 THEN
         MenueItem2 [i - 1].nextItem := ADR (MenueItem2 [i]);
      END (* IF i *);
   END (* FOR i *);

   (* das Default-Item *)

   IF Anzahl >= 1 THEN
      i := Anzahl + 1;

      WITH MenueText2 [i] DO
         frontPen := 0;
         backPen := 1;
         drawMode := jam2;
         leftEdge := 20;
         topEdge := 2;
         iTextFont := NIL;
         iText := ADR (MI2Text);
         nextText := NIL;
      END (* WITH MenueText2 [i] *);

      WITH MenueItem2 [i] DO
         nextItem := NIL;
         leftEdge := 1;
         topEdge := (i - 1) * (Prefs.fontHeight + 4);
         width := M1Breite + 52;
         height := Prefs.fontHeight + 4;
         flags := MenuItemFlagSet {checkIt, itemText, itemEnabled, highBox,
            menuToggled, commSeq};
         mutualExclude := SetBits (Anzahl, i);
         itemFill := ADR (MenueText2 [i]);
         selectFill := NIL;
         command := "e";
         subItem := NIL;
         nextSelect := 0;
      END (* WITH MenuItem2 [i] *);

      MenueItem2 [i - 1].nextItem := ADR (MenueItem2 [i]);

      WITH Menue [1] DO
         nextMenu := NIL;
         leftEdge := Menue [0].width + 4;
         topEdge := 0;
         width := TextLength (ADR (Fenster^.wScreen^.rastPort),
                              ADR (M1Text), 16) + 4;
         height := 10;
         flags := BITSET {0};
         menuName := ADR (M1Text);
         firstItem := ADR (MenueItem2 [1]);
      END (* WITH Menue [1] *);

      Menue [0].nextMenu := ADR (Menue [1]);
   END (* IF Anzahl *);
END InitMenue (* Prozedur *);

(* ---------------------------------------------------------------------- *)
(* ---------------------------------------------------------------------- *)

BEGIN (* Modul WBFarben *)

Fenster := NIL;
Font := NIL;

(* Anzahl der Argumente holen *)

Anzahl := NumArgs ();

(* der Font *)

WITH Attr DO
   name := ADR (FName);
   ySize := FGroesse;
   style := FontStyleSet {};
   flags := FontFlagSet {};
END (* WITH Attr *);

Font := OpenFont (ADR (Attr));

(* Fenster *)

WITH ITitel DO
   frontPen := 0;
   backPen := 1;
   drawMode := jam2;
   leftEdge := 30;
   topEdge := 1;
   iTextFont := ADR (Attr);
   iText := ADR (FTitel);
   nextText := NIL;
END (* WITH ITitel *);

WITH ISpace DO
   frontPen := 0;
   backPen := 1;
   drawMode := jam2;
   leftEdge := 33;
   topEdge := 1;
   iTextFont := ADR (Attr);
   iText := ADR ("        ");
   nextText := ADR (ITitel);
END (* WITH ISpace *);

(* Farben merken *)
GetDefPrefs (ADR (Prefs), SIZE (Prefs));

WITH Prefs DO
   Farben [0, 0] := color0;
   Backup [0, 0] := color0;
   Farben [0, 1] := color1;
   Backup [0, 1] := color1;
   Farben [0, 2] := color2;
   Backup [0, 2] := color2;
   Farben [0, 3] := color3;
   Backup [0, 3] := color3;
END (* With Prefs *);

(* aktuelle Farben aus dem Preferences-Record *)
GetPrefs (ADR (Prefs), SIZE (Prefs));

WITH Prefs DO
   Farben [1, 0] := color0;
   Backup [1, 0] := color0;
   Farben [1, 1] := color1;
   Backup [1, 1] := color1;
   Farben [1, 2] := color2;
   Backup [1, 2] := color2;
   Farben [1, 3] := color3;
   Backup [1, 3] := color3;
END (* With Prefs *);

(* Fenster mit Gadgets initialisieren und ffnen *)

(* ALaenge >= OLaenge ! *)

Ecken [0] :=  0;   Ecken [1] := 0;
Ecken [2] := 81;   Ecken [3] := 0;
Ecken [4] := 81;   Ecken [5] := 9;
Ecken [6] :=  0;   Ecken [7] := 9;
Ecken [8] :=  0;   Ecken [9] := 0;

WITH Rahmen DO
   leftEdge := -1;
   topEdge := -1;
   frontPen := 3;
   backPen := 0;
   drawMode := jam2;
   count := 5;
   xy := ADR (Ecken);
   nextBorder := NIL;
END (* With Rahmen *);

WITH AnwenderText DO
   frontPen := 1;
   backPen := 0;
   drawMode := jam2;
   leftEdge := 0;
   topEdge := 0;
   iTextFont := ADR (Attr);
   iText := ADR (GText1);
   nextText := NIL;
END (* With AnwenderText *);

OriginalText := AnwenderText;
OriginalText.iText := ADR (GText2);

WITH Anwender DO
   nextGadget := NIL;
   leftEdge := 93;
   topEdge := 12;
   width := 80;
   height := 8;
   flags := GadgetFlagSet {gadgHBox};
   activation := ActivationFlagSet {relVerify};
   gadgetType := boolGadget;
   gadgetRender := ADR (Rahmen);
   selectRender := NIL;
   gadgetText := ADR (AnwenderText);
   mutualExclude := LONGSET {};
   specialInfo := NIL;
   gadgetID := 1;
   userData := NIL;
END (* With Anwender *);

Original := Anwender;

WITH Original DO
   nextGadget := ADR (Anwender);
   leftEdge := 5;
   gadgetText := ADR (OriginalText);
   gadgetID := 0;
END (* With Original *);

WITH NeuesFenster DO
   IF Anzahl < 1 THEN
      leftEdge := 0;
   ELSE
      Laenge := 4;
      GetArg (1, Argument, Laenge);
      StrToVal (Argument, i, Vorzeichen, 10, Erfolg);

      IF NOT Erfolg THEN
         leftEdge := INTEGER (i);
      ELSE
         leftEdge := 0;
      END (* IF NOT Erfolg *);
   END (* IF Anzahl *);

   IF Anzahl < 2 THEN
      topEdge := 11;
   ELSE
      Laenge := 4;
      GetArg (2, Argument, Laenge);
      StrToVal (Argument, i, Vorzeichen, 10, Erfolg);

      IF NOT Erfolg THEN
         topEdge := INTEGER (i);
      ELSE
         topEdge := 11;
      END (* IF NOT Erfolg *);
   END (* IF Anzahl *);

   width := 178;
   height := 23;
   detailPen := 0;
   blockPen := 1;
   idcmpFlags := IDCMPFlagSet {gadgetUp, closeWindow, newPrefs,
                               activeWindow, inactiveWindow, menuPick};
   flags := WindowFlagSet {windowDrag, windowDepth, windowClose,
                           activate};
   firstGadget := ADR (Original);
   checkMark := NIL;
   title := NIL;
   screen := NIL;
   bitMap := NIL;
   minWidth := width;
   minHeight := height;
   maxWidth := width;
   maxHeight := height;
   type := ScreenFlagSet {wbenchScreen};
END (* With NeuesFenster *);

Fenster := OpenWindow (NeuesFenster);

Assert (Fenster # NIL, ADR ("konnte Fenster nicht ffnen!"));

SetWindowTitles (Fenster, NIL, ADR (STitel));

PrintIText (Fenster^.rPort, ADR (ISpace), 0, 0);
SetAPen (Fenster^.rPort, 0);
RectFill (Fenster^.rPort, 2, 10, 174, 21);
SetAPen (Fenster^.rPort, 1);
Move (Fenster^.rPort,   0, 22);
Draw (Fenster^.rPort, 177, 22);
RefreshGList (ADR (Original), Fenster, NIL, 2);

(* Men *)

InitMenue ();

INCL (MenueItem1 [2].flags, checked);
INCL (MenueItem2 [Anzahl + 1].flags, checked);
Erfolg := SetMenuStrip (Fenster, ADR (Menue));

(* auf Nachricht warten und reagieren *)

REPEAT
   WaitPort (Fenster^.userPort);
   Nachricht := GetMsg (Fenster^.userPort);

   IF Nachricht # NIL THEN
      Flags := Nachricht^.class;
      Adresse := Nachricht^.iAddress;
      MCode := Nachricht^.code;
      ReplyMsg (Nachricht);

      IF newPrefs IN Flags THEN
         (* neue WB-Farben eingestellt *)
         GetPrefs (ADR (Prefs), SIZE (Prefs));

         WITH Prefs DO
            IF NOT (((color0 = Farben [0, 0]) AND
                     (color1 = Farben [0, 1]) AND
                     (color2 = Farben [0, 2]) AND
                     (color3 = Farben [0, 3])    ) OR
                    ((color0 = Farben [1, 0]) AND
                     (color1 = Farben [1, 1]) AND
                     (color2 = Farben [1, 2]) AND
                     (color3 = Farben [1, 3])    )   )THEN
               (* Programm hat sich nicht selbst benachrichtigt *)
               Backup [1, 0] :=  color0;
               Backup [1, 1] :=  color1;
               Backup [1, 2] :=  color2;
               Backup [1, 3] :=  color3;

               IF checked IN MenueItem2 [Anzahl + 1].flags THEN
                  Farben [1, 0] := color0;
                  Farben [1, 1] := color1;
                  Farben [1, 2] := color2;
                  Farben [1, 3] := color3;
               END (* IF checked *);
            END (* IF NOT *);
         END (* With Prefs *);

         PrintIText (Fenster^.rPort, ADR (ISpace), 0, 0);
         SetAPen (Fenster^.rPort, 0);
         RectFill (Fenster^.rPort, 2, 10, 174, 21);
         SetAPen (Fenster^.rPort, 1);
         Move (Fenster^.rPort,   0, 22);
         Draw (Fenster^.rPort, 177, 22);
         RefreshGList (ADR (Original), Fenster, NIL, 2);
      END (* If newPrefs *);

      IF gadgetUp IN Flags THEN
         (* neue Farben ber Preferences-Record einstellen *)
         IF Adresse # NIL THEN
            Nummer := Adresse^.gadgetID;

            WITH Prefs DO
               color0 := Farben [Nummer, 0];
               color1 := Farben [Nummer, 1];
               color2 := Farben [Nummer, 2];
               color3 := Farben [Nummer, 3];
            END (* With Prefs *);

            SetPrefs (ADR (Prefs), SIZE (Prefs), TRUE);
         END (* If Adresse *);
      END (* If gadgetUp *);

      IF menuPick IN Flags THEN
         MNummer := MenuNum (MCode);
         INummer := ItemNum (MCode);

         CASE MNummer OF
            |0: (* Original-Men *)
                CASE INummer OF
                   |0: (* WBench 1.1 - 1.3 *)
                       Farben [0, 0] := 90;
                       Farben [0, 1] := 4095;
                       Farben [0, 2] := 2;
                       Farben [0, 3] := 3968;

                   |1: (* WBench 2.0 *)
                       Farben [0, 0] := 2730;
                       Farben [0, 1] := 0;
                       Farben [0, 2] := 4095;
                       Farben [0, 3] := 1657;

                   |2: (* Default-Farben *)
                       Farben [0, 0] := Backup [0, 0];
                       Farben [0, 1] := Backup [0, 1];
                       Farben [0, 2] := Backup [0, 2];
                       Farben [0, 3] := Backup [0, 3];

                ELSE (* CASE INummer *)
                   (* kein Item angewhlt *)
                END (* CASE INummer *);

            |1: (* Anwender-Men *)
                IF INummer = CARDINAL (Anzahl) THEN
                   (* Default-Anwenderfarben *)
                   Farben [1, 0] := Backup [1, 0];
                   Farben [1, 1] := Backup [1, 1];
                   Farben [1, 2] := Backup [1, 2];
                   Farben [1, 3] := Backup [1, 3];

                ELSE (* IF INummer *)
                   Farben [1, 0] := Inhalt [INummer + 1].Farben [0];
                   Farben [1, 1] := Inhalt [INummer + 1].Farben [1];
                   Farben [1, 2] := Inhalt [INummer + 1].Farben [2];
                   Farben [1, 3] := Inhalt [INummer + 1].Farben [3];
                END (* IF INummer *);
         ELSE (* CASE MNummer *)
            (* kein Men angewhlt *)
         END (* CASE MNummer *);
      END (* IF menuPick *);

      IF activeWindow IN Flags THEN
         PrintIText (Fenster^.rPort, ADR (ISpace), 0, 0);
         SetAPen (Fenster^.rPort, 0);
         RectFill (Fenster^.rPort, 2, 10, 174, 21);
         SetAPen (Fenster^.rPort, 1);
         Move (Fenster^.rPort,   0, 22);
         Draw (Fenster^.rPort, 177, 22);
         RefreshGList (ADR (Original), Fenster, NIL, 2);
      END (* IF activeWindow *);

      IF inactiveWindow IN Flags THEN
         SetAPen (Fenster^.rPort, 0);
         RectFill (Fenster^.rPort, 2, 10, 174, 21);
         SetAPen (Fenster^.rPort, 1);
         Move (Fenster^.rPort,   0, 22);
         Draw (Fenster^.rPort, 177, 22);
         RefreshGList (ADR (Original), Fenster, NIL, 2);
      END (* IF inactiveWindow *);
   END (* If Nachricht *);
UNTIL closeWindow IN Flags;

CLOSE;

IF Fenster # NIL THEN
   CloseWindow (Fenster);
   Fenster := NIL;
END (* If Fenster *);

IF Font # NIL THEN
   CloseFont (Font);
   Font := NIL;
END (* IF Font *);

END WBFarben (* Modul *).
