MODULE KMTest;

IMPORT KeyMaster;
IMPORT RSA;


VAR
 publicA,privateA,publicB,privateB: RSA.Key;
 krd: KeyMaster.KeyRequestData;
 km: KeyMaster.KeyMessage;
 cA,cB: KeyMaster.Certificate;
 kmB: KeyMaster.Dirty;
 sizeB: INTEGER;
 dm1,dm2: KeyMaster.DupMSG;
 dmd1,dmd2: KeyMaster.Dirty;



BEGIN
 (* schluesselpaar fuer teilnehmer a erzeugen (nur zum test) *)
 RSA.CreateKeys(publicA,privateA);
 KeyMaster.AddPublicKey(1,publicA);

 (* schluesselpaar fuer teilnehmer b erzeugen (nur zum test) *)
 RSA.CreateKeys(publicB,privateB);
 KeyMaster.AddPublicKey(2,publicB);

 (* keyrequestdata erzeugen (nur zum test) *)
 krd.source:=1;
 krd.dest:=2;
 KeyMaster.MakeStamp(krd.stamp);

 (* keymessagedata zusammenstellen lassen *)
 KeyMaster.DoKeyMessage(krd,km);

 KeyMaster.DecodeKeyMessageA(km,privateA,KeyMaster.centralPublic,cA,kmB,sizeB);
 KeyMaster.DecodeKeyMessageB(kmB,privateB,KeyMaster.centralPublic,cB);
 KeyMaster.DumpInts("certA decodiert:",ADR(cA),SIZE(cA));
 KeyMaster.DumpInts("certB decodiert:",ADR(cB),SIZE(cB));


 KeyMaster.BuildDupMSG(1,publicA,privateA,publicB,dmd1);
 KeyMaster.BuildDupMSG(1,publicA,privateB,publicA,dmd2);
 KeyMaster.DecodeDupMSG(publicA,privateB,dmd1,dm1);
 KeyMaster.DecodeDupMSG(publicB,privateA,dmd2,dm2);
 KeyMaster.DumpInts("dm1 decodiert:",ADR(dm1),SIZE(dm1));
 KeyMaster.DumpInts("dm2 decodiert:",ADR(dm2),SIZE(dm2));
END KMTest.