(* Diese Programm testet die komplexen Rechenroutinen der LongMathLib
   ( EulerPhi = Eulersche Phifunktion) und
   ( Berle    = Berlekampalgorithmus )
*)
MODULE TestLib;

FROM LongMathLib IMPORT Berle,EulerPhi;
FROM MathLong    IMPORT LONG,AllocNum,FreeNum,Mult,Mod,PowMod,NStellen;
FROM LongInOut   IMPORT WriteLONG,ReadLONG;
FROM InOut       IMPORT WriteString,WriteLn,WriteInt;

VAR a,b,c,d:LONG;

BEGIN

 a:=AllocNum();
 IF a=NIL THEN
  WriteString('Fehler ');WriteLn;
  HALT
 END;

 b:=AllocNum();
 IF b=NIL THEN
  WriteString('Fehler ');WriteLn;
  HALT
 END;

 c:=AllocNum();
 IF c=NIL THEN
  WriteString('Fehler ');WriteLn;
  HALT
 END;

 d:=AllocNum();
 IF d=NIL THEN
  WriteString('Fehler ');WriteLn;
  HALT
 END;

 WriteString('Sie haben ');WriteInt(NStellen(),0);WriteString(' Stellen zur Verfgung');WriteLn;

 WriteString('Geben Sie eine Zahl ein ');ReadLONG(a);
 WriteString('Geben Sie eine Zahl ein ');ReadLONG(b);

 WriteString('Euler Start');WriteLn;
 EulerPhi(a,b,c);
 WriteString('Euler Stop');WriteLn;
 WriteLONG(c);WriteLn;

 WriteString('Start des Algorithmus (Berle)');WriteLn;
 Berle(a,b,c,d);
 WriteString('Ende des Algorithmus (Berle)');WriteLn;

 WriteString('Inverses ');WriteLONG(c);WriteLn;
 WriteString('ggT ');WriteLONG(d);WriteLn;

 Mult(a,c,a);Mod(a,b,a);
 WriteString('A * Inverses := ');WriteLONG(a);WriteLn;

 FreeNum(a);FreeNum(b);FreeNum(c);FreeNum(d);

END TestLib.
