(*************************************************************************

:Program.    EdApplDefs.mod
:Contents.   Applications-Definitions for AmokEd
:Author.     Hartmut Goebel
:Language.   Oberon
:Translator. Amiga Oberon Complier V2.00
:History.    V1.0 09 Mar 1991, Hartmut Goebel [hG]
:History.    V1.1 07 Jul 1991, [hG] + ExtentedPingPong
:History.    V1.2 07 Jul 1991, [hG] + some constants
:Date.       14 Nov 1991 12:47:57

*************************************************************************)

MODULE EdApplDefs;

IMPORT
  rx: Rexx,
  s: SYSTEM;

CONST
  (*
   * Type AEd0 is deal with like an normal ARexx-Msg, so
   * no ApplOnly-Commands
   *)
  idAEd0* = s.VAL(s.ADDRESS,"AEd0"); (* can't use ApplOnly-Commands! *)
  idAEd1* = s.VAL(s.ADDRESS,"AEd1");

  (*  the ID has to be set in RexxMsg->LN_NAME, so AmokEd can check if
   *  it is an ApplMessage and of which type
   *
   *  Type AEd0 passes only ONE Argument to AEd which must be a StingPtr
   *
   *  Type AEd1 passes an StringPtr in arg[0] and the arguments, if
   *  any, in the next arg[x] slot(s). If there is enough room for
   *  other commands and their arguments, the next slots can be used.
   *  See Domukentation for further details.
   *)

CONST
  (*
   *  number of arguments, an application needs to know
   *  to notify itself to AmokEd correctly
   *)
  numNotifyArgsAEd0* = 1; (* only Portname of AmokEd *)
  numNotifyArgsAEd1* = 1; (* only Portname of AmokEd *)

  (*
   *  Text for which the Msg is should be written in slot arg[TextSlot]
   *)
  TextSlot* = rx.maxRMArg;

  (*
   *  This is the last slot where an argument or command can be passed,
   *  because the next slot is TextSlot!
   *
   *  By use of FillRexxMsg(), count must not be more than maxAMArg
   *)
  maxAMArg* = rx.maxRMArg-1;


(*------ Extented PingPong -----------*)

CONST
  NumExtPingPong* = 256;

TYPE
  XPingPong* = ARRAY NumExtPingPong OF STRUCT
    line*: LONGINT;
    pos*: INTEGER;
  END;
  XPingPongPtr* = POINTER TO XPingPong;

END EdApplDefs.

