(*************************************************************************

:Program.    EdApplSub.mod
:Contents.   ApplicationSupportCommands for AmokEd
:Author.     Hartmut Goebel
:Language.   Oberon
:Translator. Amiga Oberon Compiler V2.13
:History.    V1.0, 07 Jul 1991 Hartmut Goebel [hG]
:History.    V1.1, 12 Oct 1991 [hG]: +ErrorCodes
:Date.       07 Jan 1992 18:06:56

*************************************************************************)

MODULE EdApplSub;

IMPORT
  e: Exec,
  eAD: EdApplDefs,
  edE: EdErrors,
  edG: EdGlobalVars,
  edM: EdMovement,
  s  : SYSTEM;


PROCEDURE dXClrPing*;
BEGIN
  edG.Text.ExtPingPong := NIL;
END dXClrPing;


PROCEDURE dXPing*;
BEGIN
  IF edG.Arg[0] # NIL THEN
    edG.Text.ExtPingPong := s.VAL(eAD.XPingPongPtr,edG.Arg[0]);
  ELSE
    edG.Result := edE.invalidArgument;
    edG.Rc := edE.cmdFailed;
  END;
END dXPing;


PROCEDURE dXPong*;
VAR
  arg: INTEGER;
  (* $ClearVars- *)
BEGIN
  (* $ClearVars= *)
  arg := SHORT(s.VAL(LONGINT,edG.Arg[0]));
  IF edG.Text.ExtPingPong = NIL THEN
    edG.Result := edE.noXPPField;
  ELSIF arg >= eAD.NumExtPingPong THEN
    edG.Result := edE.invalidArgument;
  ELSIF edG.Text.ExtPingPong[arg].line < 0 THEN
    edG.Result := edE.XPPPosNotDefined;
  ELSIF (edG.Text.ExtPingPong[arg].line > edG.Text.numberOfLines) THEN
    edG.Result := edE.XPPPosOutOfRange;
  ELSE
    edG.Text.pos := edG.Text.ExtPingPong[arg].pos;
    edM.JumpToLine(edG.Text.ExtPingPong[arg].line);
    RETURN;
  END;
  edG.Rc := edE.cmdFailed;
END dXPong;

END EdApplSub.

