(*************************************************************************

:Program.    Env.mod
:Contents.   Shows contents of all dos environment variables
:Author.     Hartmut Goebel [hG]
:Address.    Aufseplatz 5, D-8500 Nrnberg 40
:Copyright.  Public Domain
:Language.   Oberon
:Translator. Amiga Oberon V2.00
:History.    V1.0, date [hG]
:Date.       28 Oct 1991 12:24:26

:Support.    <Hinweis auf von anderen bernomene Programmteile/Ideen>
:Imports.    <Importierte Module auer dem Standardumfang des Compilers>
:Bugs.       <bekannte Fehler>

:Remark.     needs AmigaDos 2.0
:Usage.      <Usage zB. fr CLI-Befehl>

*************************************************************************)


MODULE Env;

IMPORT
  asc: ASCII,
  d: Dos,
  e: Exec,
  io,
  (*lst: Lists,*)
  s: SYSTEM;
  (*slst: SortedLists;*)

TYPE
  EnvVarPtr = POINTER TO EnvVar;
  EnvVar = RECORD (*(lst.List)*)
    name: ARRAY 30 OF CHAR;
    contents: e.STRING;
  END;

VAR
  FileInfo: d.FileInfoBlock;
  Lock: d.FileLockPtr;
  Env: EnvVar(*Ptr*);
  b, Sort: BOOLEAN;

BEGIN
  IF d.dos.lib.version < 36 THEN
    io.WriteString("I need at least AmigaDos 2.0\n");
    HALT(20);
  END;
  Lock := d.Lock("ENV:",d.sharedLock);
  IF Lock = NIL THEN
    HALT(20);
  END;
  (*NEW(Env);*)
  b := d.Examine(Lock,FileInfo);
  REPEAT
    b := d.ExNext(Lock,FileInfo);
    IF b AND (FileInfo.dirEntryType < 0) THEN
      (*
      IF Sort THEN
        IF d.GetVar(FileInfo.fileName,Env.contents,
                    s.SIZE(e.STRING),LONGSET{}) > 0 THEN
          Env.name := FielInfo.fileName^;
          NEW(Env);
        END;
      ELS*)
      IF d.GetVar(FileInfo.fileName,Env.contents,
                    s.SIZE(e.STRING),LONGSET{}) > 0 THEN
        io.WriteString(FileInfo.fileName);
        io.Write(asc.ht);
        io.WriteString(Env.contents);
        io.WriteLn;
      END;
    END;
  UNTIL (~b) AND (d.IoErr() = d.noMoreEntries);

END Env.

