(*---------------------------------------------------------------------------
  :Program.    BobEdi.mod
  :Contents.   Editieren von Bobs und Sprites
  :Author.     Frank Lmker
  :Copyright.  FreeWare, siehe Dok-File
  :Language.   Modula-2
  :Translator. M2Amiga V4.0d
  :Support.    kreis (Ellipse) und ausmalen (Fill) von Axel Lmker
  :Imports.    IntuiSupport 1.1.1 [Christian Stiens]
  :Imports.    BobEdiG, BobHelp, BobDisk, InitBMap [Frank Lmker]
  :History.    V1.0, [Frank Lmker] 26-Dez-91
  :Bugs.       keine bekannt
---------------------------------------------------------------------------*)

MODULE BobEdi;

(*$ LargeVars:=FALSE StackParms:=FALSE StackChk:=FALSE EntryClear:=FALSE
    NilChk:=FALSE RangeChk:=FALSE OverflowChk:=FALSE *)

FROM IntuitionD IMPORT ScreenPtr,IDCMPFlagSet,IDCMPFlags,WindowFlagSet,
      WindowFlags,WindowPtr,IntuiMessage,selectDown,selectUp,
      menuDown,menuUp,GadgetPtr,ActivationFlagSet,
      ActivationFlags,StringInfo,PropInfo,PropInfoFlagSet,PropInfoFlags;
FROM IntuitionL IMPORT CloseScreen,CloseWindow,DrawImage,RemoveGadget,
      ActivateGadget,ModifyIDCMP,ModifyProp,RefreshGList,RefreshGadgets;
FROM GraphicsD  IMPORT RastPortPtr,BitMap,DrawModes,DrawModeSet,ViewModeSet;
FROM GraphicsL  IMPORT SetAPen,SetBPen,LoadRGB4,WritePixel,ReadPixel,
      DrawEllipse,RectFill,SetRast,ClipBlit,BltBitMap,SetDrMd,
      GetRGB4,SetRGB4,BltPattern;
FROM ExecL IMPORT WaitPort;
FROM DosL IMPORT Delay;
FROM MathTrans IMPORT Sqrt;
FROM SYSTEM IMPORT ADR,ASSEMBLE,ADDRESS,SHIFT;
FROM Arts IMPORT Assert;
FROM Heap IMPORT AllocMem,Available;
FROM Conversions IMPORT ValToStr;
FROM Arguments IMPORT NumArgs,GetArg;
FROM IntuiSupport IMPORT CreateScreenA,CreateWindowA,GetIMes,stdGadg,stdActv,
        CreateStrGadget,CreateBoolGadget,CreatePropGadget,autoBorder;
FROM InitBMap IMPORT InitBit,FreeBit;
FROM BobEdiG IMPORT BobBed,Pfeil16,PfeilH,PfeilR,PfeilHg,PfeilRg,logo;
FROM BobHelp IMPORT mittex,mittey,Mkleinx,Mkleiny,maxbreite,maxbilder,
      prefsname,RasterG,  REAL,Tpunkte,bildptr,Tfarben,Tgrenzen,TgrenzG,
      str70,str10,str2,pstr2,    myscreen,rp,mywin,nachwin,helpbit,bilder,
      anzbilder,kleinx,kleiny,xbreite,ybreite,Lkor,    Farben,box,line,
      Print,PrintVal,PrintLong,rahmen,bin,fehler,frage,drawraster,lupe,
      checkgads,getCol,raster,loadEinstell,setEinstell;
FROM BobDisk IMPORT load,disk;

VAR imes:IntuiMessage;
    kords:POINTER TO ARRAY [1..33],[1..4] OF INTEGER;

PROCEDURE koordinaten; (*$ EntryExitCode:=FALSE *)
BEGIN  (* Schlie       PfeilH           PfeilR           Nummer *)
  ASSEMBLE (
    DC.W 310,4,318,12, 298,131,306,141, 298,161,306,171, 293,145,312,157,
      (* Farben         Farbanzeige      ^              v*)
         3,228,223,240, 228,227,251,241, 253,60,269,76, 253,78,269,94,
         235,69,251,85, 271,69,287,85,(* < > *)
         235,98,251,114, 253,98,269,114, 271,98,287,114,
         235,116,251,132, 253,116,269,132, 271,116,287,132,
         235,134,251,150, 253,134,269,150, 271,134,287,150,
         235,152,251,168, 253,152,269,168, 271,152,287,168,
         235,170,251,186, 253,170,269,186, 271,170,287,186,
         235,188,251,204, 253,188,269,204, 271,188,287,204,
         235,206,251,222, 253,206,269,222, 271,206,287,222,
         295,69,311,85, 235,60,287,222 (* Pfeil16 Bedienfeld komplett*)
  END);
END koordinaten;

PROCEDURE rette (bildnr:INTEGER);
VAR err:LONGCARD;
BEGIN
  err:=BltBitMap (rp^.bitMap,kleinx,kleiny+11,ADR(bilder^[bildnr]),0,0,
                  xbreite,ybreite,192,255,NIL);
END rette;

PROCEDURE aufbau;
BEGIN
  myscreen:=CreateScreenA(ADR("Bob-Edi 1.0, Logic Artists,F.Lmker"),325,256,
                         5,ViewModeSet{});
  mywin:=CreateWindowA (NIL,0,11,325,245,myscreen,NIL,
            WindowFlagSet{borderless,backDrop,activate,rmbTrap},
            IDCMPFlagSet{mouseButtons});
  rp:=mywin^.rPort;
  LoadRGB4 (ADR(myscreen^.viewPort),ADR(Farben),32);
  SetRast (rp,2); SetBPen (rp,2);
  kords:=ADR(koordinaten);
  DrawImage (rp,ADR(BobBed),kords^[33,1],kords^[33,2]);
  DrawImage (rp,ADR(Pfeil16),kords^[32,1],kords^[32,2]);   (* Pfeil16 *)
  DrawImage (rp,ADR(PfeilH),kords^[2,1],kords^[2,2]);
  DrawImage (rp,ADR(PfeilR),kords^[3,1],kords^[3,2]);
  rahmen (kords^[6,1],kords^[6,2],kords^[6,3],kords^[6,4],FALSE);(*Farbanzeig*)
  rahmen (kords^[1,1],kords^[1,2],kords^[1,3],kords^[1,4],FALSE);   (* Quit *)
  rahmen (kords^[1,1]+3,kords^[1,2]+3,kords^[1,3]-3,kords^[1,4]-3,FALSE);
  rahmen (kords^[4,1],kords^[4,2],kords^[4,3],kords^[4,4],TRUE); (*Bildnummer*)
  PrintVal (1,kords^[4,1]+2,kords^[4,4]-3,2,1);      (* Bildnummer *)
  SetAPen (rp,16);                                   (* Farben *)
  RectFill (rp,kords^[6,1]+1,kords^[6,2]+1,kords^[6,3]-1,kords^[6,4]-1);
  SetAPen (rp,17);
  RectFill (rp,kords^[6,1]+7,kords^[6,2]+4,kords^[6,3]-7,kords^[6,4]-4);
  rahmen (kords^[20,1],kords^[20,2],kords^[20,3],kords^[20,4],TRUE); (* Stift*)
  box (16,227,28,241,4);  (* farbeV *)
  Print (1,255,237,2,ADR("x:"));
  Print (1,291,237,2,ADR("y:"));
END aufbau;

PROCEDURE loeschen (farbe,bildnr:INTEGER;ganz:BOOLEAN);
VAR nr:INTEGER;
    err:LONGCARD;
BEGIN
  SetAPen (rp,farbe);
  RectFill (rp,mittex,mittey,mittex+49,mittey+49);
  RectFill (rp,Lkor.xmin,Lkor.ymin,Lkor.xmax,Lkor.ymax);
  RectFill(rp,kleinx,kleiny,kleinx+xbreite-1,kleiny+ybreite-1);
  err:=BltBitMap (rp^.bitMap,mittex,mittey+11,ADR(bilder^[bildnr]),0,0,
                  48,48,192,255,NIL);
  IF ganz THEN
    FOR nr:=1 TO anzbilder+1 DO
      err:=BltBitMap (rp^.bitMap,mittex,mittey+11,ADR(bilder^[nr]),0,0,
                      48,48,192,255,NIL);
    END;
  END;
  IF (Lkor.xmax-mittex<50) OR (Lkor.ymax-mittey<50) THEN
    SetAPen (rp,2);
    RectFill (rp,mittex,mittey,mittex+49,mittey+49);
    SetAPen (rp,farbe);
    RectFill (rp,mittex,mittey,Lkor.xmax,Lkor.ymax);
  END;
  drawraster;
END loeschen;

PROCEDURE zeigBild (altbild:INTEGER;VAR bildnr:INTEGER);
VAR err:LONGCARD;
BEGIN
  IF altbild#bildnr THEN
    rette (altbild);
    IF bildnr>anzbilder THEN bildnr:=1;
    ELSIF bildnr<1 THEN bildnr:=anzbilder; END;
    PrintVal (1,kords^[4,1]+2,kords^[4,4]-3,2,bildnr);
  END;
  err:=BltBitMap (ADR(bilder^[bildnr]),0,0,rp^.bitMap,kleinx,kleiny+11,
                  xbreite,ybreite,192,255,NIL);
  lupe;
END zeigBild;

PROCEDURE copy (bildnr:INTEGER);
VAR strgad:ARRAY [1..3] OF GadgetPtr;
    copgad,exgad:GadgetPtr;
    stinfo:POINTER TO StringInfo;
    gad:GadgetPtr;
    gadnr,nr:INTEGER;
    werte:ARRAY [1..3] OF INTEGER;
    helpstr:str2;
    err:BOOLEAN;
    err2:LONGCARD;
BEGIN
  nachwin:=CreateWindowA (NIL,mittex-73,mittey-28,147,56,myscreen,NIL,
                  WindowFlagSet{activate},IDCMPFlagSet{gadgetUp});
  rp:=nachwin^.rPort;
  ValToStr (bildnr,TRUE,helpstr,10,-2,0C,err);
  strgad[1]:=CreateStrGadget (1,39,6,24,8,3,autoBorder,stdGadg,stdActv,
                              helpstr,bildnr,nachwin);
   Print (1,9,13,3,ADR("von"));
  nr:=bildnr; INC (nr);
  IF nr>anzbilder THEN nr:=1; END;
  ValToStr (nr,TRUE,helpstr,10,-2,0C,err);
  strgad[2]:=CreateStrGadget (2,110,6,24,8,3,autoBorder,stdGadg,stdActv,
                              helpstr,nr,nachwin);
   Print (1,72,13,4,ADR("nach"));
  strgad[3]:=CreateStrGadget (3,100,21,24,8,3,autoBorder,stdGadg,stdActv,
                              "1",1,nachwin);
   Print (1,20,28,7,ADR("Anzahl:"));
  copgad:=CreateBoolGadget (4,15,41,32,8,ADR("Copy"),autoBorder,stdGadg,
                    ActivationFlagSet{relVerify},nachwin);
  exgad:=CreateBoolGadget (5,67,41,64,8,ADR("Exchange"),autoBorder,stdGadg,
                    ActivationFlagSet{relVerify},nachwin);
  RefreshGadgets (strgad[1],nachwin,NIL);
  rp:=mywin^.rPort;
  err:=ActivateGadget (strgad[1],nachwin,NIL);
  REPEAT
    GetIMes (nachwin,imes,TRUE);
    gad:=imes.iAddress; gadnr:=gad^.gadgetID;
    IF gadnr<3 THEN
      err:=ActivateGadget (strgad[gadnr+1],nachwin,NIL);
    END;
  UNTIL gadnr>3;
  FOR nr:=1 TO 3 DO
    stinfo:=strgad[nr]^.specialInfo;
    werte[nr]:=ABS(stinfo^.longInt);
    IF (werte[nr]=0) AND (nr<3) THEN werte[nr]:=1; END;
  END;
  IF gadnr=4 THEN  (* kopieren *)
    FOR nr:=0 TO (werte[3]-1) DO
      IF werte[2]+nr>anzbilder THEN werte[2]:=1-nr; END;
      IF werte[1]+nr>anzbilder THEN werte[1]:=1-nr; END;
      err2:=BltBitMap (ADR(bilder^[werte[1]+nr]),0,0,
              ADR(bilder^[werte[2]+nr]),0,0,48,48,192,255,NIL);
    END;
  ELSE             (* austauschen *)
    FOR nr:=0 TO werte[3]-1 DO
      IF werte[2]+nr>anzbilder THEN werte[2]:=1-nr; END;
      IF werte[1]+nr>anzbilder THEN werte[1]:=1-nr; END;
      err2:=BltBitMap (ADR(bilder^[werte[2]+nr]),0,0,
              ADR(helpbit),0,0,48,48,192,255,NIL);
      err2:=BltBitMap (ADR(bilder^[werte[1]+nr]),0,0,
              ADR(bilder^[werte[2]+nr]),0,0,48,48,192,255,NIL);
      err2:=BltBitMap (ADR(helpbit),0,0,
              ADR(bilder^[werte[1]+nr]),0,0,48,48,192,255,NIL);
    END;
  END;
  CloseWindow (nachwin); nachwin:=NIL;
END copy;

PROCEDURE setzeBild (VAR bildnr:INTEGER;len:INTEGER;text:ADDRESS);
VAR bildgad,okgad:GadgetPtr;
    help:str2;
    err:BOOLEAN;
    stinfo:POINTER TO StringInfo;
BEGIN
  nachwin:=CreateWindowA (NIL,mittex-len*4-22,mittey-15,len*8+45,34,
                 myscreen,NIL,WindowFlagSet{activate},IDCMPFlagSet{gadgetUp});
  rp:=nachwin^.rPort;
  Print (1,8,12,len,text);
  rp:=mywin^.rPort;
  ValToStr (bildnr,TRUE,help,10,-2,0C,err);
  bildgad:=CreateStrGadget (1,len*8+14,6,24,8,3,autoBorder,stdGadg,stdActv,
                            help,bildnr,nachwin);
  okgad:=CreateBoolGadget (2,(len*8+44) DIV 2-16,20,32,8,ADR(" OK "),
                    autoBorder,stdGadg,ActivationFlagSet{relVerify},nachwin);
  RefreshGadgets (bildgad,nachwin,NIL);
  stinfo:=bildgad^.specialInfo;
  err:=ActivateGadget (bildgad,nachwin,NIL);
  GetIMes (nachwin,imes,TRUE);
  bildnr:=stinfo^.longInt;
  CloseWindow (nachwin); nachwin:=NIL;
END setzeBild;

PROCEDURE animation (VAR grenzen:Tgrenzen;VAR mode:SHORTINT;VAR warte:BOOLEAN);
VAR xAnim,yAnim:INTEGER;

  PROCEDURE animKords; (*$ EntryExitCode:=FALSE *)
  BEGIN  (* Vor            Zurck         P.Pong        Delay *)
    ASSEMBLE (
      DC.W 40,138,92,150, 40,153,92,165, 40,168,92,180, 135,123,188,135,
        (* Start           Quit             Mode(ganz) *)
           61,190,105,202, 120,190,164,202, 37,122,95,185
    END);
  END animKords;

  PROCEDURE zeiganim (VAR nr,delay,richt:INTEGER;speed,mode:INTEGER;
                      warte:BOOLEAN);
  VAR err:LONGCARD;
  BEGIN
    DEC (delay);
    IF delay<=0 THEN
      IF mode=3 THEN
        IF (nr>=grenzen[2]) OR (nr<=grenzen[1]) THEN richt:=-richt; END;
      END;
      IF nr>grenzen[2] THEN nr:=grenzen[1+INTEGER(mode=3)];
      ELSIF nr<grenzen[1] THEN nr:=grenzen[2-INTEGER(mode=3)]; END;
      PrintVal (1,xAnim+xbreite+8,yAnim+6+ybreite DIV 2,2,nr);
      err:=BltBitMap (ADR(bilder^[nr]),0,0,rp^.bitMap,xAnim,yAnim+11,
                       xbreite,ybreite,192,255,NIL);
      INC (nr,richt);
      IF warte THEN Delay (speed); delay:=0;
               ELSE delay:=speed*speed*10; END;
    END;
  END zeiganim;

CONST anzsteps=31;
VAR xpos,ypos,wahl,
    speed,delay,richt,nr:INTEGER;
    start,err:BOOLEAN;
    speedgad:GadgetPtr;
    grenzgad:TgrenzG;
    prinfo:POINTER TO PropInfo;
    ko:POINTER TO ARRAY [1..7],[1..4] OF INTEGER;
    helpstr:str2;
    gad:GadgetPtr;

BEGIN
  box (1,1,maxbreite+1,maxbreite+1,3);
  box (2,2,maxbreite,maxbreite,4);
  SetAPen (rp,2);
  RectFill (rp,3,3,maxbreite-1,maxbreite-1);
  xAnim:=mittex-xbreite DIV 2; yAnim:=73-ybreite;
  SetAPen (rp,0);
  RectFill (rp,xAnim,yAnim,xAnim+xbreite-1,yAnim+ybreite-1);
  box (xAnim-2,yAnim-2,xAnim+xbreite+1,yAnim+ybreite+1,4);
  speedgad:=CreatePropGadget (1,mittex-anzsteps*2-3,84,anzsteps*4+6,11,
          anzsteps,0,NIL,stdGadg,ActivationFlagSet{gadgImmediate,relVerify,
          followMouse}, PropInfoFlagSet{autoKnob,freeHoriz},mywin);
  prinfo:=speedgad^.specialInfo;
  ko:=ADR(animKords);
  Print (1,mittex-32,mittey-6,8,ADR("Speed: 0"));
  Print (1,42,132,6,ADR(" Mode "));
  Print (1,ko^[1,1]+6,ko^[1,4]-3,5,ADR(" Vor "));
  Print (1,ko^[2,1]+2,ko^[2,4]-3,6,ADR("Zurck"));
  Print (1,ko^[3,1]+2,ko^[3,4]-3,6,ADR("P.Pong"));
  Print (1,ko^[4,1]+6,ko^[4,4]-3,5,ADR("Delay"));
  Print (1,ko^[5,1]+2,ko^[5,4]-3,5,ADR("Start"));
  Print (1,ko^[6,1]+6,ko^[6,4]-3,4,ADR("Quit"));
  SetAPen (rp,0);
  RectFill (rp,161,144,186,153);
  RectFill (rp,161,167,186,176);
  ValToStr (grenzen[1],TRUE,helpstr,10,-2,0C,err);
  grenzgad[1]:=CreateStrGadget (2,162,145,24,8,3,autoBorder,stdGadg,stdActv,
                                helpstr,grenzen[1],mywin);
  ValToStr (grenzen[2],TRUE,helpstr,10,-2,0C,err);
  grenzgad[2]:=CreateStrGadget (3,162,168,24,8,3,autoBorder,stdGadg,stdActv,
                                helpstr,grenzen[2],mywin);
  RefreshGadgets (speedgad,mywin,NIL);
  Print (1,135,151,3,ADR("von"));
  Print (1,135,174,3,ADR("bis"));
  rahmen (132,141,191,179,FALSE);
  Print (1,xAnim+xbreite+8,yAnim-3+ybreite DIV 2,2,ADR("Nr"));
  FOR nr:=1 TO 7 DO
    rahmen (ko^[nr,1],ko^[nr,2],ko^[nr,3],ko^[nr,4],FALSE);
  END;
  rahmen (ko^[mode,1],ko^[mode,2],ko^[mode,3],ko^[mode,4],TRUE);
  rahmen (ko^[4,1],ko^[4,2],ko^[4,3],ko^[4,4],warte);
  ModifyIDCMP (mywin,IDCMPFlagSet{mouseButtons,mouseMove,gadgetUp});
  nr:=1; speed:=0; delay:=0; richt:=1;
  start:=FALSE;
  err:=ActivateGadget (grenzgad[1],mywin,NIL);
  wahl:=0;
  REPEAT
    IF start THEN
      zeiganim (nr,delay,richt,speed,mode,warte);
    ELSE
      WaitPort (mywin^.userPort);
    END;
    GetIMes (mywin,imes,FALSE);
    IF gadgetUp IN imes.class THEN
      gad:=imes.iAddress;
      CASE gad^.gadgetID OF
         1: speed:=CARDINAL(LONGCARD(prinfo^.horizPot)*anzsteps DIV 65536);
            PrintVal(1,mittex+16,mittey-6,2,speed);
        |2..3: checkgads (grenzgad,grenzen,TRUE);
               err:=ActivateGadget (grenzgad[2-INTEGER(gad^.gadgetID=3)],
                                    mywin,NIL);
        ELSE
      END;  (* CASE gad^.gadgetID *)
    ELSIF (mouseMove IN imes.class) THEN
      speed:=CARDINAL(LONGCARD(prinfo^.horizPot)*anzsteps DIV 65536);
      PrintVal(1,mittex+16,mittey-6,2,speed);
    ELSIF (mouseButtons IN imes.class) AND (imes.code=selectDown) THEN
      xpos:=imes.mouseX; ypos:=imes.mouseY;
      wahl:=0;
      REPEAT
        INC (wahl);
      UNTIL (wahl>6) OR ((xpos>=ko^[wahl,1]) AND (ypos>=ko^[wahl,2]) AND
                         (xpos<=ko^[wahl,3]) AND (ypos<=ko^[wahl,4]));
      CASE wahl OF
        1..3: FOR xpos:=1 TO 3 DO
                rahmen (ko^[xpos,1],ko^[xpos,2],
                        ko^[xpos,3],ko^[xpos,4],xpos=wahl);
              END;
              richt:=INTEGER(wahl#2)*2-1; mode:=wahl;
        |  4: warte:=NOT warte;
              rahmen (ko^[wahl,1],ko^[wahl,2],ko^[wahl,3],ko^[wahl,4],warte);
        |5..6: start:=NOT start;
               IF wahl=6 THEN start:=TRUE; END;
               rahmen (ko^[wahl,1],ko^[wahl,2],ko^[wahl,3],ko^[wahl,4],start);
               checkgads (grenzgad,grenzen,TRUE);
        ELSE
      END;  (* CASE wahl *)
    END;  (* IF gadgetUp *)
  UNTIL wahl=6;
  ModifyIDCMP (mywin,IDCMPFlagSet{mouseButtons});
  nr:=RemoveGadget (mywin,grenzgad[1]);
  nr:=RemoveGadget (mywin,grenzgad[2]);
  nr:=RemoveGadget (mywin,speedgad);
  SetAPen (rp,2);
  RectFill (rp,1,1,maxbreite+1,maxbreite+1);
  lupe;
END animation;

PROCEDURE palette (farbe:INTEGER);
VAR farbgad:ARRAY [1..3] OF GadgetPtr;
    prinfo:POINTER TO PropInfo;
    propI:PropInfoFlagSet;
    wahl,xpos,ypos,nr:INTEGER;
    farbW,altfarben:Tfarben;
BEGIN
  nachwin:=CreateWindowA (ADR("Palette"),mittex-65,mittey-65,131,140,
         myscreen,NIL,WindowFlagSet{activate,windowDrag},
         IDCMPFlagSet{mouseButtons,gadgetUp,mouseMove});
  rp:=nachwin^.rPort;
  SetAPen (rp,2); RectFill (rp,2,10,128,138);
  SetBPen (rp,2);
  Print (1,27,18,7,ADR("R  G  B"));
  Print (1,3,26,2,ADR("15"));
  Print (1,3,104,2,ADR(" 0"));
  getCol (farbW); altfarben:=farbW;
  propI:=PropInfoFlagSet{autoKnob,freeVert};
  FOR nr:=1 TO 3 DO
    farbgad[nr]:=CreatePropGadget (nr,nr*24,22,13,80,0,16,NIL,stdGadg,
        ActivationFlagSet{gadgImmediate,relVerify,followMouse},propI,nachwin);
    ModifyProp(farbgad[nr],nachwin,NIL,propI,
               0,4369*(15-CARDINAL(farbW[farbe,nr])),0,4369);
    PrintVal(1,nr*24-3,112,2,farbW[farbe,nr]);
  END;
  RefreshGadgets (farbgad[1],nachwin,NIL);
  FOR nr:=16 TO 31 DO
    SetAPen (rp,nr);
    RectFill (rp,100+INTEGER(nr>23)*11,15+(nr MOD 8)*11,
                 109+INTEGER(nr>23)*11,24+(nr MOD 8)*11);
  END;
  box (99+INTEGER(farbe>23)*11,14+(farbe MOD 8)*11,
       110+INTEGER(farbe>23)*11,25+(farbe MOD 8)*11,4);
  Print (1,16,130,4,ADR(" OK "));
  rahmen (14,121,49,133,FALSE);
  Print (1,65,130,6,ADR("CANCEL"));
  rahmen (62,121,115,133,FALSE);
  wahl:=0;
  REPEAT
    GetIMes (nachwin,imes,TRUE);
    IF (gadgetUp IN imes.class) OR (mouseMove IN imes.class) THEN
      FOR nr:=1 TO 3 DO
        prinfo:=farbgad[nr]^.specialInfo;
        ypos:=15-INTEGER(LONGCARD(prinfo^.vertPot)*15 DIV 65535);
        PrintVal(1,nr*24-3,112,2,ypos);
        farbW[farbe,nr]:=ypos;
      END;
      SetRGB4 (ADR(myscreen^.viewPort),farbe,
               farbW[farbe,1],farbW[farbe,2],farbW[farbe,3]);
    ELSIF (mouseButtons IN imes.class) AND (imes.code=selectDown) THEN
      xpos:=imes.mouseX; ypos:=imes.mouseY;
      IF (xpos>99)AND (xpos<121) AND (ypos>15) AND (ypos<103) THEN
        box (99+INTEGER(farbe>23)*11,14+(farbe MOD 8)*11,      (* Farbleiste *)
             110+INTEGER(farbe>23)*11,25+(farbe MOD 8)*11,2);
        farbe:=(ypos-15) DIV 11+16+INTEGER(xpos>110)*8;
        box (99+INTEGER(farbe>23)*11,14+(farbe MOD 8)*11,
             110+INTEGER(farbe>23)*11,25+(farbe MOD 8)*11,4);
        FOR nr:=1 TO 3 DO
          ModifyProp(farbgad[nr],nachwin,NIL,propI,
                     0,4369*(15-CARDINAL(farbW[farbe,nr])),0,4369);
          PrintVal(1,nr*24-3,112,2,farbW[farbe,nr]);
        END;
      ELSIF (xpos>13) AND (xpos<50) AND (ypos>120) AND (ypos<134) THEN
        wahl:=1;                          (* OK *)
      ELSIF (xpos>61) AND (xpos<116) AND (ypos>120) AND (ypos<134) THEN
        wahl:=1;                          (* Cancel *)
        FOR nr:=16 TO 31 DO
          SetRGB4 (ADR(myscreen^.viewPort),nr,
               altfarben[nr,1],altfarben[nr,2],altfarben[nr,3]);
        END;
      END;  (* IF xpos>99 *)
    END;  (* IF gadgetUp *)
  UNTIL wahl#0;
  rp:=mywin^.rPort;
  CloseWindow (nachwin); nachwin:=NIL;
END palette;

PROCEDURE info;
CONST name="Bob-Edi V1.0";
VAR x,y:INTEGER;
BEGIN
  box (1,1,maxbreite+1,maxbreite+1,3);
  box (2,2,maxbreite,maxbreite,4);
  SetAPen (rp,2);
  RectFill (rp,3,3,maxbreite-1,maxbreite-1);
  DrawImage (rp,ADR(logo),18,5);
  Print (1,125,20,9,ADR("presents:"));
  SetDrMd (rp,DrawModeSet{});
  Print (1,113,31-1,12,ADR(name));
  Print (1,113,31+1,12,ADR(name));
  Print (1,113-1,31,12,ADR(name));
  Print (1,113+1,31,12,ADR(name));
  Print (0,113,31,12,ADR(name));
  Print (1,34,53,20,ADR("Program and Design :"));
  Print (1,67,63,12,ADR("Frank Lmker"));
  Print (8,67-1,62,12,ADR("Frank Lmker"));
  SetDrMd (rp,DrawModeSet{dm0});
  Print (1,18,80,24,ADR("(c) 1991 by Frank Lmker"));
  Print (1,86,102,7,ADR("Memory:"));
  Print (1,46,114,17,ADR("Chip         Fast"));
  Print (1,110,124,2,ADR("| "));
  PrintLong (1,30,124,8,Available(TRUE));
  PrintLong (1,126,124,8,Available(FALSE)-Available(TRUE));
  Print (1,74,150,10,ADR("Copyright:"));
  Print (1, 6,163,27,ADR("Freeware, kopieren erlaubt,"));
  Print (1,14,173,25,ADR("kommerzielle Nutzung ver-"));
  Print (1,30,183,21,ADR("boten, Diskettenpreis"));
  Print (1,66,193,12,ADR("maximal 5 DM"));
  REPEAT
    GetIMes (mywin,imes,TRUE);
    x:=imes.mouseX; y:=imes.mouseY;
  UNTIL (imes.code=selectDown) AND (x>2) AND (x<maxbreite) AND
                                (y>2) AND (y<maxbreite);
  SetAPen (rp,2);
  RectFill (rp,1,1,maxbreite+1,maxbreite+1);
  lupe;
END info;

(*$ StackChk:=TRUE *)
PROCEDURE setpunkt (x,y:INTEGER);
VAR err:BOOLEAN;
BEGIN
  BltPattern (rp,NIL,x*Lkor.dx+Lkor.xmin+1,y*Lkor.dy+Lkor.ymin+1,
               (x+1)*Lkor.dx+Lkor.xmin-1,(y+1)*Lkor.dy+Lkor.ymin-1,0);
  err:=WritePixel (rp,kleinx+x,kleiny+y);
END setpunkt;
(*$ POP StackChk *)

PROCEDURE setpunktClip (x,y:INTEGER);
VAR err:BOOLEAN;
BEGIN
  IF (x>=0) AND (x<xbreite) AND (y>=0)  AND (y<ybreite) THEN
    BltPattern (rp,NIL,x*Lkor.dx+Lkor.xmin+1,y*Lkor.dy+Lkor.ymin+1,
                 (x+1)*Lkor.dx+Lkor.xmin-1,(y+1)*Lkor.dy+Lkor.ymin-1,0);
    err:=WritePixel (rp,kleinx+x,kleiny+y);
  END;
END setpunktClip;

PROCEDURE schieben (richt:INTEGER);
VAR err:LONGCARD;
    kords:Tpunkte;
    nr:INTEGER;
BEGIN             (* 1^  2v  3<  4> *)
  SetAPen (rp,INTEGER(RasterG)*3);
  line (mittex,Lkor.ymin,mittex,Lkor.ymax);
  line (Lkor.xmin,mittey,Lkor.xmax,mittey);
  kords:=Lkor;
  FOR nr:=1 TO 2 DO
    WITH kords DO
      err:=BltBitMap (rp^.bitMap,xmin+INTEGER(richt=4)*(xbreite-1)*dx,
                  ymin+INTEGER(richt=2)*(ybreite-1)*dy+11,ADR(helpbit),0,0,
                  dx+(xbreite-1)*dx*INTEGER(richt<3),
                  dy+(ybreite-1)*dy*INTEGER(richt>2),192,255,NIL);
      ClipBlit (rp,xmin+INTEGER(richt=3)*dx,ymin+INTEGER(richt=1)*dy,rp,
                xmin+INTEGER(richt=4)*dx,ymin+INTEGER(richt=2)*dy,
                xbreite*dx-INTEGER(richt>2)*dx,ybreite*dy-INTEGER(richt<3)*dy,
                192);
      err:=BltBitMap (ADR(helpbit),0,0,rp^.bitMap,
                 xmin+INTEGER(richt=3)*(xbreite-1)*dx,
                 ymin+INTEGER(richt=1)*(ybreite-1)*dy+11,
                 dx+(xbreite-1)*dx*INTEGER(richt<3),
                 dy+(ybreite-1)*dy*INTEGER(richt>2),192,255,NIL);
      xmin:=kleinx; ymin:=kleiny;
      xmax:=kleinx+xbreite-1; ymax:=kleiny+ybreite-1; dx:=1; dy:=1;
    END;
  END;
  SetAPen (rp,4);
  line (mittex,Lkor.ymin,mittex,Lkor.ymax);
  line (Lkor.xmin,mittey,Lkor.xmax,mittey);
END schieben;

PROCEDURE schieben16;
VAR err:LONGCARD;
    kords:Tpunkte;
    nr:INTEGER;
BEGIN
  SetAPen (rp,INTEGER(RasterG)*3);
  line (mittex,Lkor.ymin,mittex,mittey-1);
  line (mittex,mittey+1,mittex,Lkor.ymax);
  kords:=Lkor;
  FOR nr:=1 TO 2 DO
    WITH kords DO
      err:=BltBitMap (rp^.bitMap,xmin,ymin+11,ADR(helpbit),0,0,
                  dx*16,ybreite*dy,192,255,NIL);
      ClipBlit (rp,xmin+dx*16,ymin,rp,xmin,ymin,
                (xbreite-16)*dx,ybreite*dy,192);
      err:=BltBitMap (ADR(helpbit),0,0,rp^.bitMap,xmin+(xbreite-16)*dx,
                  ymin+11,dx*16,ybreite*dy,192,255,NIL);
      xmin:=kleinx; ymin:=kleiny;
      xmax:=kleinx+xbreite-1; ymax:=kleiny+ybreite-1; dx:=1; dy:=1;
    END;
  END;
  SetAPen (rp,4);
  line (mittex,Lkor.ymin,mittex,Lkor.ymax);
END schieben16;

PROCEDURE spiegeln (vert:BOOLEAN);
VAR err:LONGCARD;
    kords:Tpunkte;
    nr,x,grenze:INTEGER;
BEGIN
  SetAPen (rp,INTEGER(RasterG)*3);
  IF vert THEN
    line (mittex,Lkor.ymin,mittex,Lkor.ymax);
    grenze:= (xbreite DIV 2)-1;
  ELSE
    line (Lkor.xmin,mittey,Lkor.xmax,mittey);
    grenze:= (ybreite DIV 2)-1;
  END;
  FOR x:=0 TO grenze DO
    kords:=Lkor;
    FOR nr:=1 TO 2 DO
      WITH kords DO
        IF vert THEN
          err:=BltBitMap (rp^.bitMap,xmin+x*dx,ymin+11,
                      ADR(helpbit),0,0,dx,ymax-ymin+1,192,255,NIL);
          err:=BltBitMap (rp^.bitMap,xmin+(xbreite-x-1)*dx,ymin+11,rp^.bitMap,
                      xmin+x*dx,ymin+11,dx,ymax-ymin+1,192,255,NIL);
          err:=BltBitMap (ADR(helpbit),0,0,rp^.bitMap,xmin+(xbreite-x-1)*dx,
                      ymin+11,dx,ymax-ymin+1,192,255,NIL);
        ELSE
          err:=BltBitMap (rp^.bitMap,xmin,ymin+x*dy+11,
                      ADR(helpbit),0,0,xmax-xmin+1,dy,192,255,NIL);
          err:=BltBitMap (rp^.bitMap,xmin,ymin+(ybreite-x-1)*dy+11,rp^.bitMap,
                      xmin,ymin+x*dy+11,xmax-xmin+1,dy,192,255,NIL);
          err:=BltBitMap (ADR(helpbit),0,0,rp^.bitMap,xmin,
                      ymin+(ybreite-x-1)*dy+11,xmax-xmin+1,dy,192,255,NIL);
        END;
        xmin:=kleinx; ymin:=kleiny;
        xmax:=kleinx+xbreite-1; ymax:=kleiny+ybreite-1; dx:=1; dy:=1;
      END;  (* WITH kords *)
    END;  (* FOR nr:= *)
  END;  (* FOR x:= *)
  SetAPen (rp,4);
  line (mittex,Lkor.ymin,mittex,Lkor.ymax);
  line (Lkor.xmin,mittey,Lkor.xmax,mittey);
END spiegeln;

PROCEDURE drehen;
VAR x,y,help,breite:INTEGER;
    err:LONGCARD;
    error:BOOLEAN;
BEGIN
  err:=BltBitMap (rp^.bitMap,kleinx,kleiny+11,rp^.bitMap,0+Lkor.xmin,
                  11+Lkor.ymin,xbreite,ybreite,192,255,NIL);
  IF xbreite>ybreite THEN breite:=ybreite;
                     ELSE breite:=xbreite; END;
  FOR x:=0 TO breite-1 DO
    FOR y:=0 TO breite-1 DO
      help:=-y+breite-1;
      IF help<breite THEN
        SetAPen (rp,ReadPixel (rp,x+Lkor.xmin,y+Lkor.ymin));
        error:=WritePixel (rp,help+kleinx,x+kleiny);
      END;
    END;
  END;
  lupe;
END drehen;

PROCEDURE getpunkt (VAR xpos,ypos:INTEGER;VAR mycode:CARDINAL):BOOLEAN;
BEGIN
  GetIMes (mywin,imes,FALSE);
  mycode:=imes.code;
  xpos:=mywin^.mouseX;
  ypos:=mywin^.mouseY;
  IF (xpos>Lkor.xmin) AND (xpos<Lkor.xmax) AND
     (ypos>Lkor.ymin) AND (ypos<Lkor.ymax) THEN
    xpos:=(xpos-Lkor.xmin-1) DIV Lkor.dx;
    ypos:=(ypos-Lkor.ymin-1) DIV Lkor.dy;
    PrintVal (1,271,237,2,xpos);
    PrintVal (1,306,237,2,ypos);
    RETURN TRUE;
  ELSE
    RETURN FALSE;
  END;
END getpunkt;

PROCEDURE punkte (farbe:INTEGER);
VAR xpos,ypos:INTEGER;
    mycode:CARDINAL;
BEGIN
  REPEAT
    IF getpunkt (xpos,ypos,mycode) THEN
      SetAPen (rp,farbe);
      setpunkt (xpos,ypos);
    END;
  UNTIL (mycode=selectUp) OR (mycode=menuUp);
END punkte;

PROCEDURE swapG (VAR xmin,ymin,xmax,ymax:INTEGER);
VAR help:INTEGER;
BEGIN
  IF xmin>xmax THEN
    help:=xmin; xmin:=xmax; xmax:=help;
  END;
  IF ymin>ymax THEN
    help:=ymin; ymin:=ymax; ymax:=help;
  END;
END swapG;

PROCEDURE linie2 (xmin,ymin,xmax,ymax:INTEGER);
VAR x:INTEGER;
    dy,korektur:REAL;
    err:BOOLEAN;

  PROCEDURE swap (min,max:INTEGER);
  VAR help:INTEGER;
  BEGIN
    IF min>max THEN
      help:=xmin; xmin:=xmax; xmax:=help;
      help:=ymin; ymin:=ymax; ymax:=help;
    END;
  END swap;

BEGIN
  korektur:=0.5;
  IF (xmin#xmax) OR (ymin#ymax) THEN
    IF ABS(xmax-xmin) >= ABS(ymax-ymin) THEN
      swap (xmin,xmax);
      dy:=REAL(ymax-ymin) / REAL(xmax-xmin);
      IF dy<0.0 THEN korektur:=-0.5; END;
      FOR x:=xmin TO xmax DO
        setpunktClip(x,INTEGER(dy*REAL(x-xmin)+korektur)+ymin);
      END;
    ELSE
      swap (ymin,ymax);
      dy:=REAL(xmax-xmin) / REAL(ymax-ymin);
      IF dy<0.0 THEN korektur:=-0.5; END;
      FOR x:=ymin TO ymax DO
        setpunktClip (INTEGER(dy*REAL(x-ymin)+korektur)+xmin,x);
      END;
    END;
  ELSE
    setpunkt (xmin,ymin);
  END;
END linie2;

PROCEDURE linie (farbe,xmin,ymin:INTEGER);
VAR help,xlup,ylup,x,y,xmax,ymax,xalt,yalt:INTEGER;
    mycode:CARDINAL;
BEGIN
  help:=1; xmax:=xmin; ymax:=ymin;
  xlup:=xmin*Lkor.dx+Lkor.xmin+Lkor.dx DIV 2;
  ylup:=ymin*Lkor.dy+Lkor.ymin+Lkor.dy DIV 2;
  REPEAT
    line (xmin+kleinx,ymin+kleiny,xmax+kleinx,ymax+kleiny);
    line (xlup,ylup,xmax*Lkor.dx+Lkor.xmin+Lkor.dx DIV 2,
                    ymax*Lkor.dy+Lkor.ymin+Lkor.dy DIV 2);
    xalt:=xmax; yalt:=ymax;
    SetDrMd (rp,DrawModeSet{dm0});
    IF getpunkt (x,y,mycode) THEN
      xmax:=x; ymax:=y;
    END;
    SetAPen (rp,help); help:=ABS(1-help);
    setpunkt (xmin,ymin);
    SetDrMd (rp,DrawModeSet{complement});
    line (xmin+kleinx,ymin+kleiny,xalt+kleinx,yalt+kleiny);
    line (xlup,ylup,xalt*Lkor.dx+Lkor.xmin+Lkor.dx DIV 2,
                    yalt*Lkor.dy+Lkor.ymin+Lkor.dy DIV 2);
  UNTIL (mycode=selectUp) OR (mycode=menuUp);
  SetDrMd (rp,DrawModeSet{dm0});
  SetAPen (rp,farbe);
  linie2 (xmin,ymin,xmax,ymax);
END linie;

PROCEDURE defrecht (VAR xmin,ymin,xmax,ymax:INTEGER);
VAR help,xlup,ylup,x,y,xalt,yalt,alt:INTEGER;
    mycode:CARDINAL;
BEGIN
  IF getpunkt (x,y,mycode) THEN xmin:=x; ymin:=y; END;
  alt:=ReadPixel (rp,kleinx+xmin,kleiny+ymin);
  help:=1; xmax:=xmin; ymax:=ymin;
  xlup:=xmin*Lkor.dx+Lkor.xmin+Lkor.dx DIV 2;
  ylup:=ymin*Lkor.dy+Lkor.ymin+Lkor.dy DIV 2;
  REPEAT
    box (xmin+kleinx,ymin+kleiny,xmax+kleinx,ymax+kleiny,0);
    box (xlup,ylup,xmax*Lkor.dx+Lkor.xmin+Lkor.dx DIV 2,
                   ymax*Lkor.dy+Lkor.ymin+Lkor.dy DIV 2,0);
    xalt:=xmax; yalt:=ymax;
    SetDrMd (rp,DrawModeSet{dm0});
    IF getpunkt (x,y,mycode) THEN
      xmax:=x; ymax:=y;
    END;
    SetAPen (rp,help); help:=ABS(1-help);
    setpunkt (xmin,ymin);
    SetDrMd (rp,DrawModeSet{complement});
    box (xmin+kleinx,ymin+kleiny,xalt+kleinx,yalt+kleiny,0);
    box (xlup,ylup,xalt*Lkor.dx+Lkor.xmin+Lkor.dx DIV 2,
                   yalt*Lkor.dy+Lkor.ymin+Lkor.dy DIV 2,0);
  UNTIL (mycode=selectUp) OR (mycode=menuUp);
  SetDrMd (rp,DrawModeSet{dm0});
  SetAPen (rp,alt); setpunkt (xmin,ymin);
  swapG (xmin,ymin,xmax,ymax);
END defrecht;

PROCEDURE rechteck (farbe,xmin,ymin:INTEGER;leer:BOOLEAN);
VAR x,y,xmax,ymax:INTEGER;
BEGIN
  defrecht (xmin,ymin,xmax,ymax);
  SetAPen (rp,farbe);
  IF leer THEN
    FOR x:=xmin TO xmax DO
      setpunkt (x,ymin);
      setpunkt (x,ymax);
    END;
    FOR y:=ymin+1 TO ymax-1 DO
      setpunkt (xmin,y);
      setpunkt (xmax,y);
    END;
  ELSE
    FOR y:=ymin TO ymax DO
      FOR x:=xmin TO xmax DO
        setpunkt (x,y);
      END;
    END;
  END;
END rechteck;

PROCEDURE kreis (farbe:INTEGER);
VAR dx,dy,xlup,ylup,xpos,ypos,xmax,ymax,xalt,yalt:INTEGER;
    mycode:CARDINAL;
    i,j,y,yold:INTEGER;

  PROCEDURE round (x:REAL):INTEGER;
  BEGIN
    IF x<0.0 THEN RETURN INTEGER(x-0.5);
             ELSE RETURN INTEGER(x+0.5); END;
  END round;

BEGIN
  xpos:=1; ypos:=1;
  IF getpunkt (dx,dy,mycode) THEN xpos:=dx; ypos:=dy; END;
  xmax:=xpos; ymax:=ypos;
  xlup:=xpos*Lkor.dx+Lkor.xmin+Lkor.dx DIV 2;
  ylup:=ypos*Lkor.dy+Lkor.ymin+Lkor.dy DIV 2;
  SetDrMd (rp,DrawModeSet{complement});
  REPEAT
    dx:=ABS(xpos-xmax); dy:=ABS(ypos-ymax);
    DrawEllipse (rp,xpos+kleinx,ypos+kleiny,dx,dy);
    box (xlup-dx*Lkor.dx,ylup-dy*Lkor.dy,xlup+dx*Lkor.dx,ylup+dy*Lkor.dy,0);
    setpunkt (xpos,ypos);
    xalt:=dx; yalt:=dy;
    SetDrMd (rp,DrawModeSet{dm0});
    IF getpunkt (dx,dy,mycode) THEN
      xmax:=dx; ymax:=dy;
    END;
    SetDrMd (rp,DrawModeSet{complement});
    DrawEllipse (rp,xpos+kleinx,ypos+kleiny,xalt,yalt);
    box (xlup-xalt*Lkor.dx,ylup-yalt*Lkor.dy,
         xlup+xalt*Lkor.dx,ylup+yalt*Lkor.dy,0);
    setpunkt (xpos,ypos);
  UNTIL (mycode=selectUp) OR (mycode=menuUp);
  SetDrMd (rp,DrawModeSet{dm0});
  dx:=ABS(xpos-xmax); dy:=ABS(ypos-ymax);
  SetAPen (rp,farbe);
  IF dx=0 THEN
    linie2 (xpos,ypos-dy,xpos,ypos+dy);
  ELSE
    yold:=0;
    FOR xmax:=-dx+1 TO 0 DO
      y:=round(REAL(dy)*Sqrt(1.0-REAL(xmax)/REAL(dx)*REAL(xmax)/REAL(dx)));
      FOR i:=yold TO y DO
        j:=xmax-1;
        IF i>yold+(y-yold) DIV 2 THEN INC (j); END;
        setpunktClip (xpos+j,ypos-i);
        setpunktClip (xpos+j,ypos+i);
        setpunktClip (xpos-j,ypos-i);
        setpunktClip (xpos-j,ypos+i);
      END;
      IF yold=y THEN
        setpunktClip (xpos+xmax,ypos-y);
        setpunktClip (xpos+xmax,ypos+y);
        setpunktClip (xpos-xmax,ypos-y);
        setpunktClip (xpos-xmax,ypos+y);
      END;
      yold:=y;
    END;
  END;
END kreis;

PROCEDURE cut (VAR cutx,cuty:INTEGER);
VAR xmax,ymax:INTEGER;
    err:LONGCARD;
BEGIN
  defrecht (cutx,cuty,xmax,ymax);
  err:=BltBitMap (rp^.bitMap,kleinx+cutx,kleiny+cuty+11,ADR(bilder^[0]),0,0,
                  xbreite,ybreite,192,255,NIL);
  cutx:=xmax-cutx+1; cuty:=ymax-cuty+1;
END cut;

PROCEDURE kleben (cutx,cuty,farbeH:INTEGER;trans:BOOLEAN);
VAR x,y,xlup,ylup,xmin,ymin,xalt,yalt,farbe:INTEGER;
    mycode:CARDINAL;
    err:LONGCARD;
BEGIN
  IF getpunkt (x,y,mycode) THEN xmin:=x; ymin:=y; END;
  xalt:=xmin; yalt:=ymin;
  SetDrMd (rp,DrawModeSet{complement});
  REPEAT
    xlup:=xmin*Lkor.dx+Lkor.xmin+Lkor.dx DIV 2;
    ylup:=ymin*Lkor.dy+Lkor.ymin+Lkor.dy DIV 2;
    err:=BltBitMap (ADR(bilder^[0]),0,0,rp^.bitMap,kleinx+xalt,kleiny+yalt+11,
                    cutx,cuty,96,255,NIL);
    box (xlup,ylup,xlup+(cutx-1)*Lkor.dx,ylup+(cuty-1)*Lkor.dy,0);
    SetDrMd (rp,DrawModeSet{dm0});
    IF getpunkt (x,y,mycode) THEN
      xmin:=x; ymin:=y;
    END;
    SetDrMd (rp,DrawModeSet{complement});
    err:=BltBitMap (ADR(bilder^[0]),0,0,rp^.bitMap,kleinx+xalt,kleiny+yalt+11,
                    cutx,cuty,96,255,NIL);
    box (xlup,ylup,xlup+(cutx-1)*Lkor.dx,ylup+(cuty-1)*Lkor.dy,0);
    xalt:=xmin; yalt:=ymin;
  UNTIL (mycode=selectUp) OR (mycode=menuUp);
  SetDrMd (rp,DrawModeSet{dm0});
  nachwin:=CreateWindowA (NIL,0,11,cutx,cuty,myscreen,NIL,
                      WindowFlagSet{borderless},IDCMPFlagSet{});
  err:=BltBitMap (ADR(bilder^[0]),0,0,nachwin^.rPort^.bitMap,
                  0,11,cutx,cuty,192,255,NIL);
  FOR x:=0 TO cutx-1 DO
    FOR y:=0 TO cuty-1 DO
      farbe:=ReadPixel(nachwin^.rPort,x,y);
      IF (NOT trans) OR (farbe#farbeH) THEN
        SetAPen (rp,farbe);
        setpunktClip (x+xmin,y+ymin);
      END;
    END;
  END;
  CloseWindow (nachwin); nachwin:=NIL;
END kleben;

PROCEDURE undo;
VAR err:LONGCARD;
BEGIN
  err:=BltBitMap (rp^.bitMap,kleinx,kleiny+11,ADR(helpbit),0,0,
                  xbreite,ybreite,192,255,NIL);
  err:=BltBitMap (ADR(bilder^[anzbilder+1]),0,0,rp^.bitMap,kleinx,kleiny+11,
                  xbreite,ybreite,192,255,NIL);
  err:=BltBitMap (ADR(helpbit),0,0,ADR(bilder^[anzbilder+1]),0,0,
                  xbreite,ybreite,192,255,NIL);
  lupe;
END undo;

PROCEDURE setfarben (farbeV,farbeH:INTEGER);
BEGIN
  SetAPen (rp,farbeH);
  RectFill (rp,kords^[6,1]+1,kords^[6,2]+1,
               kords^[6,3]-1,kords^[6,4]-1);
  SetAPen (rp,farbeV);
  RectFill (rp,kords^[6,1]+7,kords^[6,2]+4,
               kords^[6,3]-7,kords^[6,4]-4);
  box (farbeV*14-222,227,farbeV*14-210,241,4);
END setfarben;

VAR unter,y:INTEGER;

(*$ StackChk:=TRUE *)
PROCEDURE ausmalen (x:INTEGER);
VAR i:INTEGER;
BEGIN
  i:=x;
  WHILE ReadPixel (rp,kleinx+x+1,kleiny+y)=unter DO
    setpunkt (x,y);
    INC (x);
  END;
  setpunkt (x,y);
  WHILE ReadPixel (rp,kleinx+i-1,kleiny+y)=unter DO
    DEC (i);
    setpunkt (i,y);
  END;
  WHILE i<=x DO
    IF ReadPixel (rp,i+kleinx,kleiny+y-1)=unter THEN
      DEC (y); ausmalen (i); INC (y);
    END;
    IF ReadPixel (rp,i+kleinx,kleiny+y+1)=unter THEN
      INC (y); ausmalen (i); DEC (y);
    END;
    INC (i);
  END;
END ausmalen;
(*$ POP StackChk *)

PROCEDURE fill (farbe,xpos,y2:INTEGER);
BEGIN
  y:=y2;
  unter:=ReadPixel (rp,xpos+kleinx,y+kleiny);
  SetAPen (rp,farbe);
  IF ReadPixel (rp,xpos+kleinx,y+kleiny)#farbe THEN
    ausmalen (xpos);
  END;
END fill;

VAR name:str70;
    grenzen:ARRAY [1..2] OF Tgrenzen;  (* 1: Disk  2: Anim *)
    farbe,wahl,xpos,ypos,
    anzfarben,cutx,cuty,stift,farbeV,farbeH,bildnr:INTEGER;
    warte,quadrat,druecken:BOOLEAN;
    mode:SHORTINT;

BEGIN
  myscreen:=NIL; mywin:=NIL; nachwin:=NIL; bilder:=NIL;
  Assert (InitBit (helpbit,5,225,225),ADR("Zu wenig Chip-RAM !"));
  aufbau;
  loadEinstell (xbreite,ybreite,anzfarben,quadrat,druecken);
  IF druecken THEN   (* druecken=err *)
    anzfarben:=16; quadrat:=TRUE;
    xbreite:=32; ybreite:=32; RasterG:=TRUE;
  END;
  bildnr:=20;
  raster (anzfarben,quadrat);
  info; drawraster;
  setzeBild (bildnr,14,ADR("Anzahl Bilder:"));
  IF bildnr<2 THEN bildnr:=2; END;
  AllocMem (bilder,SIZE(BitMap)*(bildnr+2),TRUE);
  Assert (bilder#NIL,ADR("Zu wenig Chip-RAM !"));
  anzbilder:=0;
  REPEAT
    druecken:=InitBit (bilder^[anzbilder],5,48,48);
    INC (anzbilder);
  UNTIL (anzbilder>bildnr+1) OR (NOT druecken); (* bilder[anzbilder+1]:UNDO *)
  DEC (anzbilder,INTEGER(druecken=FALSE)+2);    (* bilder[0]:Cut,kleben *)
  IF anzbilder<bildnr THEN
    IF anzbilder>6 THEN
      FOR bildnr:=anzbilder-3 TO anzbilder+1 DO
        FreeBit (bilder^[bildnr]);
      END;
      DEC (anzbilder,5);
    END;
    Assert (anzbilder>1,ADR("Zu wenig Chip-RAM !"));
    name:="    xx Bilder  !   ";
    name[5]:=CHAR(anzbilder DIV 10 + 48);
    name[6]:=CHAR(anzbilder MOD 10 + 48);
    fehler ("Nur Speicher fr",name);
  END;
  name:=""; grenzen[1,1]:=1; grenzen[1,2]:=1;
  grenzen[2,1]:=1; grenzen[2,2]:=anzbilder;
  mode:=1; warte:=FALSE;
  farbeV:=17; farbeH:=16; bildnr:=1; stift:=20;
  cutx:=1; cuty:=1;
  loeschen (farbeH,bildnr,TRUE);
  IF NumArgs()>0 THEN
    GetArg (1,name,xpos);
    grenzen[1,2]:=anzbilder;
    load (name,grenzen[1],anzfarben);
    zeigBild (bildnr,bildnr);
    grenzen[1,2]:=1;
  END;
  wahl:=0;
  REPEAT
    GetIMes (mywin,imes,TRUE);
    IF mouseButtons IN imes.class THEN
      IF (imes.code=selectDown) OR (imes.code=menuDown) THEN
        xpos:=imes.mouseX; ypos:=imes.mouseY;
        IF (xpos>Lkor.xmin) AND (xpos<Lkor.xmax) AND
           (ypos>Lkor.ymin) AND (ypos<Lkor.ymax) THEN
          IF imes.code=selectDown THEN farbe:=farbeV;
                                  ELSE farbe:=farbeH; END;
          IF stift#26 THEN rette (anzbilder+1); END;  (* UNDO *)
          xpos:=(xpos-Lkor.xmin-1) DIV Lkor.dx;
          ypos:=(ypos-Lkor.ymin-1) DIV Lkor.dy;
          CASE stift OF
             20: punkte (farbe);
            |21: linie (farbe,xpos,ypos);
            |22: rechteck (farbe,xpos,ypos,TRUE);
            |23: rechteck (farbe,xpos,ypos,FALSE);
            |24: kreis (farbe);
            |25: fill (farbe,xpos,ypos);
            |26: cut (cutx,cuty);
                 rahmen (kords^[26,1],kords^[26,2],kords^[26,3],
                         kords^[26,4],FALSE);
                 rahmen (kords^[28,1],kords^[28,2],kords^[28,3],
                         kords^[28,4],TRUE);
                 stift:=28;
            |27: kleben (cutx,cuty,farbeH,FALSE);
            |28: kleben (cutx,cuty,farbeH,TRUE);
            ELSE
          END;
        ELSIF ((xpos>=kords^[5,1]) AND (ypos>=kords^[5,2]) AND
               (xpos<(anzfarben+16)*14-221) AND (ypos<=kords^[5,4])) THEN
          IF imes.code=selectDown THEN                      (* Farbe *)
            box (farbeV*14-222,227,farbeV*14-210,241,2);
            farbeV:=(xpos-2) DIV 14+16;
          ELSE
            farbeH:=(xpos-2) DIV 14+16;
          END;
          setfarben (farbeV,farbeH);
        ELSIF imes.code=selectDown THEN
          wahl:=0;
          REPEAT
            INC (wahl);
          UNTIL (wahl>33) OR
                ((xpos>=kords^[wahl,1]) AND (ypos>=kords^[wahl,2]) AND
                 (xpos<=kords^[wahl,3]) AND (ypos<=kords^[wahl,4]));
          IF wahl<33 THEN
            IF (wahl>6) OR (wahl=1) THEN
              rahmen (kords^[wahl,1],kords^[wahl,2],kords^[wahl,3],
                      kords^[wahl,4],TRUE);
            END;
            IF (wahl=17) OR (wahl=30) THEN
              rette (anzbilder+1);        (* UNDO *)
            END;
            druecken:=FALSE;
            CASE wahl OF
              | 1: IF frage("Programm","wirklich verlassen ?") THEN
                     wahl:=-1;
                   END;
              | 2: DrawImage (rp,ADR(PfeilHg),kords^[2,1],kords^[2,2]);
                   INC (bildnr);
                   zeigBild (bildnr-1,bildnr);
                   DrawImage (rp,ADR(PfeilH),kords^[2,1],kords^[2,2]);
              | 3: DrawImage (rp,ADR(PfeilRg),kords^[3,1],kords^[3,2]);
                   DEC (bildnr);
                   zeigBild (bildnr+1,bildnr);
                   DrawImage (rp,ADR(PfeilR),kords^[3,1],kords^[3,2]);
              | 4: xpos:=bildnr;     (* xpos=altbild *)
                   rette (bildnr);
                   setzeBild (bildnr,7,ADR("Bildnr:"));
                   zeigBild (xpos,bildnr);
              |7..10: schieben (wahl-6);
              |11: rette (bildnr);
                   disk (name,grenzen[1],bildnr,anzfarben);
              |12: rette (bildnr);
                   setEinstell (anzfarben,quadrat);
                   zeigBild (bildnr,bildnr);
                   IF farbeV>anzfarben+15 THEN farbeV:=anzfarben+15; END;
                   IF farbeH>anzfarben+15 THEN farbeH:=anzfarben+15; END;
                   setfarben (farbeV,farbeH);
              |13: info;
              |14: palette (farbeV);
              |15: rette (bildnr);
                   animation (grenzen[2],mode,warte);
              |16: rette (bildnr);
                   copy (bildnr);
                   zeigBild (bildnr,bildnr);
              |17: drehen;
              |18: spiegeln (TRUE);
              |19: spiegeln (FALSE);
              |20..28: IF stift#wahl THEN
                     rahmen (kords^[stift,1],kords^[stift,2],
                             kords^[stift,3],kords^[stift,4],FALSE);
                     stift:=wahl;
                   END;
                   druecken:=TRUE;
              |29: undo;
              |30: loeschen (farbeH,bildnr,FALSE);
              |31: IF frage ("Wirklich alle","Bilder lschen ?") THEN
                     loeschen (farbeH,bildnr,TRUE);
                   END;
              |32: schieben16;
              ELSE
            END;
            IF (wahl>6) OR (wahl=1) THEN
              rahmen (kords^[wahl,1],kords^[wahl,2],kords^[wahl,3],
                      kords^[wahl,4],druecken);
            END;
          END;  (* IF wahl<31 *)
        END;  (* IF (xpos>11) *)
      END;  (* IF imes.code *)
    END;  (* IF mouseButtons *)
  UNTIL wahl<0;
CLOSE
  IF bilder#NIL THEN
    FOR bildnr:=0 TO anzbilder+1 DO
      FreeBit (bilder^[bildnr]);
    END;
  END;
  FreeBit (helpbit);
  IF nachwin#NIL THEN CloseWindow (nachwin); nachwin:=NIL; END;
  IF mywin#NIL THEN CloseWindow (mywin); mywin:=NIL; END;
  IF myscreen#NIL THEN CloseScreen (myscreen); myscreen:=NIL; END;
END BobEdi.
