(*---------------------------------------------------------------------------
  :Program.    InitBMap.mod
  :Contents.   BitMaps initialisieren und wieder freigeben
  :Author.     Frank Lmker
  :Copyright.  FreeWare, siehe Dok-File fr Bob-Edi
  :Language.   Modula-2
  :Translator. M2Amiga V4.0d
  :History.    V1.0, [Frank Lmker] 26-Dez-91
  :Bugs.       keine bekannt
---------------------------------------------------------------------------*)

IMPLEMENTATION MODULE InitBMap;

(*$ LargeVars:=FALSE StackParms:=FALSE StackChk:=FALSE RangeChk:=FALSE
    EntryClear:=FALSE OverflowChk:=FALSE *)

FROM SYSTEM IMPORT LONGSET;
FROM GraphicsD IMPORT BitMap;
FROM GraphicsL IMPORT InitBitMap,AllocRaster,FreeRaster,BltClear;

PROCEDURE FreeBit (VAR bit:BitMap);
VAR nr:CARDINAL;
BEGIN
  nr:=0;
  REPEAT
    IF bit.planes[nr]#NIL THEN
      FreeRaster (bit.planes[nr],bit.bytesPerRow*8,bit.rows);
      bit.planes[nr]:=NIL;
    END;
    INC (nr);
  UNTIL nr>=bit.depth;
END FreeBit;

PROCEDURE InitBit (VAR bit:BitMap;dep,wi,he:INTEGER):BOOLEAN;
VAR nr:INTEGER;
BEGIN
  InitBitMap (bit,dep,wi,he);
  nr:=0;
  REPEAT
    bit.planes[nr]:=AllocRaster (bit.bytesPerRow*8,he);
    IF bit.planes[nr]#NIL THEN
      BltClear (bit.planes[nr],LONGCARD(bit.bytesPerRow)*bit.rows,LONGSET{});
    ELSE
      FreeBit (bit); RETURN FALSE;
    END;
    INC (nr);
  UNTIL nr>=dep;
  RETURN TRUE;
END InitBit;

END InitBMap.
