(*---------------------------------------------------------------------------
  :Program.    TestBobEdi
  :Contents.   zeigt animiertes Sprite als Demo fr BobEdi
  :Author.     Frank Lmker
  :Copyright.  FreeWare, siehe Dok-File fr BobEdi
  :Language.   Modula-2
  :Translator. M2Amiga V4.0d
  :Imports.    IntuiSupport 1.1.1 [Christian Stiens]
  :History.    V1.0, [Frank Lmker] 21-Nov-91
  :Bugs.       keine bekannt
---------------------------------------------------------------------------*)

MODULE TestBobEdi;
(*$ ChipCODE:=TRUE *)

FROM IntuitionD IMPORT ScreenPtr,WindowPtr,IntuiMessagePtr,WindowFlagSet,
      WindowFlags,IDCMPFlagSet,IDCMPFlags;
FROM IntuitionL IMPORT CloseScreen,CloseWindow;
FROM GraphicsD IMPORT SimpleSprite,ViewModeSet;
FROM GraphicsL IMPORT GetSprite,MoveSprite,ChangeSprite,FreeSprite,LoadRGB4,
      WaitTOF;
FROM ExecL IMPORT GetMsg,ReplyMsg;
FROM SYSTEM IMPORT ADR,ASSEMBLE;
FROM IntuiSupport IMPORT CreateScreenA,CreateWindowA;

PROCEDURE daten; (*$ EntryExitCode:=FALSE *)
BEGIN
  (* Daten erstellt mit BobEdi V1.0 *)
  (* Bilder:  5  Breite: 16  Hhe: 32  Tiefe: 4 *)
  ASSEMBLE (
    DC.W   (* Bild:  1.1 *)
  (* Plane: 1      2 *)
         $0000, $0000,
         $0000, $FFFF,
         $7FFE, $FFFF,
         $400E, $C7EF,
         $4006, $C627,
         $4002, $C623,
         $4002, $C7E3,
         $4002, $C003,
         $4E5A, $C1E3,
         $4E2A, $C173,
         $4C52, $C2BB,
         $4C6A, $C293,
         $48FA, $C503,
         $41FA, $CA03,
         $4002, $C003,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $0000, $FFFF,
         $0000, $0000,
  (* Bild:  1.2 *)
  (* Plane: 3      4 *)
         $0000, $0080,
         $FFFF, $FFFF,
         $FFFF, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $FFFF, $8001,
         $F187, $8061,
         $F147, $80B1,
         $F287, $8139,
         $F287, $8111,
         $F507, $8201,
         $EA07, $8401,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $C707,
         $FFFF, $FFEF,
         $FFFF, $FFFF,
         $FFFF, $FFFF,
         $0000, $0000,
  (* Bild:  2.1 *)
  (* Plane: 1      2 *)
         $0000, $0000,
         $0000, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $400E, $C7EF,
         $4006, $C627,
         $4002, $C623,
         $4002, $C7E3,
         $4002, $C003,
         $4E5A, $C1E3,
         $4E2A, $C173,
         $4C52, $C2BB,
         $4C6A, $C293,
         $48FA, $C503,
         $41FA, $CA03,
         $4002, $C003,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $0000, $FFFF,
         $0000, $0000,
  (* Bild:  2.2 *)
  (* Plane: 3      4 *)
         $0000, $0080,
         $FFFF, $FFFF,
         $FFFF, $8001,
         $FFFF, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $FFFF, $8001,
         $F187, $8061,
         $F147, $80B1,
         $F287, $8139,
         $F287, $8111,
         $F507, $8201,
         $EA07, $8401,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $C707,
         $FFFF, $FFEF,
         $FFFF, $FFFF,
         $FFFF, $FFFF,
         $0000, $0000,
  (* Bild:  3.1 *)
  (* Plane: 1      2 *)
         $0000, $0000,
         $0000, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $400E, $C7EF,
         $4006, $C627,
         $4002, $C623,
         $4002, $C7E3,
         $4002, $C003,
         $4E5A, $C1E3,
         $4E2A, $C173,
         $4C52, $C2BB,
         $4C6A, $C293,
         $48FA, $C503,
         $41FA, $CA03,
         $4002, $C003,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $0000, $FFFF,
         $0000, $0000,
  (* Bild:  3.2 *)
  (* Plane: 3      4 *)
         $0000, $0080,
         $FFFF, $FFFF,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $FFFF, $8001,
         $F187, $8061,
         $F147, $80B1,
         $F287, $8139,
         $F287, $8111,
         $F507, $8201,
         $EA07, $8401,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $C707,
         $FFFF, $FFEF,
         $FFFF, $FFFF,
         $FFFF, $FFFF,
         $0000, $0000,
  (* Bild:  4.1 *)
  (* Plane: 1      2 *)
         $0000, $0000,
         $0000, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $400E, $C7EF,
         $4006, $C627,
         $4002, $C623,
         $4002, $C7E3,
         $4002, $C003,
         $4E5A, $C1E3,
         $4E2A, $C173,
         $4C52, $C2BB,
         $4C6A, $C293,
         $48FA, $C503,
         $41FA, $CA03,
         $4002, $C003,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $0000, $FFFF,
         $0000, $0000,
  (* Bild:  4.2 *)
  (* Plane: 3      4 *)
         $0000, $0080,
         $FFFF, $FFFF,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $FFFF, $8001,
         $F187, $8061,
         $F147, $80B1,
         $F287, $8139,
         $F287, $8111,
         $F507, $8201,
         $EA07, $8401,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $C707,
         $FFFF, $FFEF,
         $FFFF, $FFFF,
         $FFFF, $FFFF,
         $0000, $0000,
  (* Bild:  5.1 *)
  (* Plane: 1      2 *)
         $0000, $0000,
         $0000, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $400E, $C7EF,
         $4006, $C627,
         $4002, $C623,
         $6002, $E7E3,
         $6006, $E007,
         $6656, $E1E7,
         $6C26, $E2F7,
         $4C5E, $C2A7,
         $48FA, $C503,
         $41FA, $CA03,
         $4002, $C003,
         $7FFE, $FFFF,
         $7FFE, $FFFF,
         $0000, $FFFF,
         $0000, $0000,
  (* Bild:  5.2 *)
  (* Plane: 3      4 *)
         $0000, $0080,
         $FFFF, $FFFF,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $FFFF, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $F81F, $8001,
         $FFFF, $8001,
         $F98F, $8061,
         $F28F, $8171,
         $F287, $8121,
         $F507, $8201,
         $EA07, $8401,
         $FFFF, $C003,
         $FFFF, $FFEF,
         $FFFF, $FFFF,
         $FFFF, $FFFF,
         $0000, $0000
  END);
END daten;

PROCEDURE farben; (*$ EntryExitCode:=FALSE *)
BEGIN
  (* Farben *)
  ASSEMBLE (
    DC.W $0000, $0FFF, $0000, $0000, $0000, $0000, $0000, $0000,
         $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000,
         $0000, $0FFF, $0F00, $00F0, $056F, $0FF0, $0F0F, $00FF,
         $0555, $0AAA, $0A00, $00A0, $000A, $0AA0, $0A0A, $0963
  END);
END farben;

VAR myscreen:ScreenPtr;
    mywin:WindowPtr;
    Datptr:POINTER TO ARRAY [1..5],[1..2],[1..2*34] OF INTEGER;
    mySprite,mySprite2:SimpleSprite;
    richt,bildnr,nr:INTEGER;
    msg: IntuiMessagePtr;
BEGIN
  myscreen:=NIL; mywin:=NIL;
  Datptr:=ADR(daten);
  WITH mySprite DO
    posctldata:=Datptr;
    height:=32;
    x:=40; y:=80;
    num:=-1;
  END;
  WITH mySprite2 DO
    posctldata:=ADR(Datptr^[1,2]);
    height:=32;
    x:=40; y:=80;
    num:=-1;
  END;
  IF GetSprite(ADR(mySprite),2)=2 THEN
    IF GetSprite(ADR(mySprite2),3)=3 THEN
      myscreen:=CreateScreenA (ADR("BobEdi-Test    ednE ->"),320,256,1,
                               ViewModeSet{});
      LoadRGB4 (ADR(myscreen^.viewPort),ADR(farben),32);
      mywin:=CreateWindowA (ADR("<- Ende"),180,0,75,10,myscreen,NIL,
              WindowFlagSet{activate,windowClose},IDCMPFlagSet{closeWindow});
      bildnr:=1; richt:=1; nr:=0;
      REPEAT
        MoveSprite (NIL,ADR(mySprite),myscreen^.mouseX+16,myscreen^.mouseY);
        INC (nr);
        WaitTOF;
        IF nr=3 THEN
          nr:=0;
          INC (bildnr,richt);
          IF (bildnr>=5) OR (bildnr<=1) THEN richt:=-richt; END;
          ChangeSprite(NIL,ADR(mySprite),ADR(Datptr^[bildnr,1]));
          ChangeSprite(NIL,ADR(mySprite2),ADR(Datptr^[bildnr,2]));
        END;
        msg:=GetMsg(mywin^.userPort);
      UNTIL msg#NIL;
      ReplyMsg(msg)
    END;
  END;
CLOSE
  IF mywin#NIL THEN CloseWindow (mywin); mywin:=NIL; END;
  IF myscreen#NIL THEN CloseScreen (myscreen); myscreen:=NIL; END;
  IF mySprite.num#-1 THEN FreeSprite (mySprite.num); mySprite.num:=-1; END;
  IF mySprite2.num#-1 THEN FreeSprite (mySprite2.num); mySprite2.num:=-1; END;
END TestBobEdi.
