/* Tests the direct variable interface    */
/* Assumes WShell is available; if not,   */
/* issue "run vartestC" separately        */

a.1 = "Just a test"

if left(address(),4) ~== "WSH_"  /* WShell host?   */
   then signal SendComm          /* guess not ...  */

if ~show('Ports','VarTest') then /* vartest started?  */
   do
   'runwsh vartestC'             /* launch host       */
   'waitforport VarTest'         /* wait for host     */
   if rc ~= 0 then do
      say "Couldn't start VarTest host"
      exit 20
      end
   end

SendComm:   /* send a command to the VarTest host */
say 'Before command status='status 'a.1='a.1 'a.2='a.2
address 'VarTest' 'The first command'
say 'After  command status='status 'a.1='a.1 'a.2='a.2
say

say "Before test storage=" storage()
call TestMem

/* send the 'CLOSE' command' */
address 'VarTest' close
exit

TestMem: procedure
/* Test for memory usage */
do for 10
   address 'VarTest' 'Test command'
   say "After test storage=" storage()
   end
