(* ------------------------------------------------------------------------
   :Program.      KHTime
   :Contents.     Proceduren zum Umgange mit DateStamp.
   :Author.       Klaus Hlawaty.
   :Address.      Waldhof
   :Address.      3579 Schrecksbach
   :History.      v1.0 - 20.Nov.90
   :History.      v1.1 - 16.Nov.91: Oberon v2.13
   :Copyright.    PD
   :Language.     Oberon
   :Translator.   OBERON v2.13 / OLink v2.13d
------------------------------------------------------------------------ *)
MODULE KHTime;

IMPORT Dos;

TYPE
   TTime* = RECORD
               Hour*    :LONGINT;   (* Stunden                    *)
               Minute*  :LONGINT;   (* Minuten                    *)
               Second*  :LONGINT;   (* Secunden                   *)
               Tick*    :LONGINT;   (* Ticks = 1/50tel Sekunde    *)
               ATicks*  :LONGINT;   (* Komplette Uhrzeit in Ticks *)
            END (* Record *);       (*  z.B.: fr Zeitvergleiche  *)


PROCEDURE GetTime*(VAR Time : TTime);
(* ------------------------------------------------------------------------
   :Input.
   :Output.    Uhrzeit im TTime-Format.
------------------------------------------------------------------------ *)

VAR
   DV : Dos.Date;

BEGIN
   Dos.DateStamp(DV);
   Time.Hour   := DV.minute DIV 60;
   Time.Minute := DV.minute MOD 60;
   Time.Second := DV.tick DIV 50;
   Time.Tick   := DV.tick MOD 50;
   Time.ATicks := DV.tick + (DV.minute * 3000);
END GetTime;

BEGIN (* Hauptprogram *)
END KHTime.

