(* :History. 18.10.91 --- 0.2 --- new levelformat for new game pushem *)
MODULE LevelConvert;


FROM Arts IMPORT
  Assert;

IMPORT d : Definitions;

FROM DosD IMPORT
  FileHandlePtr,readWrite;

FROM DosL IMPORT
  Close,Open,Read;

FROM InOut IMPORT
  WriteLn,WriteString;

FROM LevelLoader IMPORT
  SetMode,LevelNumber,SaveLevel;

FROM SYSTEM IMPORT
  ADR;


TYPE
  LevelFile = RECORD
                oldMode       : d.Modes;
                oldField      : d.Playfield;
                oldMan        : ARRAY d.Modes OF RECORD
                                                 x   : [0..d.MaxX];
                                                 y   : [0..d.MaxY];
                                                 dir : d.Direction;
                                               END;
                oldDests      : d.Dests;
                oldReadyDests : d.Dests;
                oldHighScore  : ARRAY [0..4] OF RECORD
                                                  name  : d.NameString;
                                                  steps : ARRAY[0..3] OF CHAR;
                                                  moves : INTEGER;
                                                  time  : ARRAY[0..4] OF CHAR;
                                                  mins  : SHORTCARD;
                                                  secs  : SHORTCARD;
                                                END;
              END;
  LevelFileName = ARRAY[0..79] OF CHAR;


VAR
  oldLevel : LevelFile;
  newLevel : d.LevelFile;
  j        : d.Modes;
  i        : LevelNumber;
  newName  : d.NameString;
  x        : INTEGER;
  fh       : FileHandlePtr;
  MaxLevel : LevelNumber;
  CurrentMode : d.Modes;


PROCEDURE BuildLevelName (    Level     : LevelNumber;
                          VAR LevelName : LevelFileName);

VAR
  i       : INTEGER;
  divisor : LevelNumber;

BEGIN
  CASE CurrentMode OF
  | 0 : LevelName:="Levels/OnePlayer/Level";
  | 1 : LevelName:="Levels/TwoPlayer/Level";
  END;
  divisor:=100;
  FOR i:=22 TO 24 DO
    LevelName[i]:=CHAR(48+Level DIV divisor);
    Level:=Level MOD divisor;
    divisor:=divisor DIV 10;
  END;
  LevelName[25]:=0C;
END BuildLevelName;


PROCEDURE LoadLevel (    Current : LevelNumber;
                     VAR Data    : LevelFile);

VAR
  FileName : LevelFileName;

BEGIN
  BuildLevelName (Current,FileName);
  fh:=Open(ADR(FileName),readWrite);
  Assert (fh#NIL,ADR("Kann LevelFile nicht ffnen!"));
  Assert (Read(fh,ADR(Data),SIZE(LevelFile))=SIZE(LevelFile),
          ADR("Kann LevelFile nicht lesen!"));
  Close (fh);
  fh:=NIL;
END LoadLevel;


BEGIN
  newName:="                    ";
  WriteString ("LevelConvert 0.2, 18.10.91");WriteLn;
  WriteLn;
  FOR j:=0 TO 1 DO
    MaxLevel:=SetMode (j);
    CurrentMode:=j;
    FOR i:=0 TO MaxLevel DO
      LoadLevel (i,oldLevel);
      WITH oldLevel DO
        WITH newLevel DO
          mode:=oldMode;
          field:=oldField;
          man[0].x:=oldMan[0].x;
          man[0].y:=oldMan[0].y;
          man[1].x:=oldMan[1].x;
          man[1].y:=oldMan[1].y;
          dests:=oldDests;
          readyDests:=oldReadyDests;
          FOR x:=0 TO 4 DO
            top5[x].name:=newName;
            top5[x].moves:=9999;
            top5[x].mins:=99;
            top5[x].secs:=59;
          END;
        END;
      END;
      MaxLevel:=SaveLevel (i,newLevel);
    END;
  END;
  WriteString ("ready.");WriteLn;
CLOSE
  IF fh#NIL THEN
    Close (fh);
  END;
END LevelConvert.
