(******************************************************************************

    :Program.    SoundSupport.mod
    :Contents.   procedures to play sounds and music
    :Version.    0.1
    :Date.       18.10.91
    :Author.     Markus Uhlendahl    Peter Groth
    :Address.    Vorm Burgtor 16     Kleine Koppel 12
    :Address.    D-4408 Dlmen       D-4408 Dlmen
    :Phone.      02594/81540         02594/82375
    :Language.   Modula-2
    :Translator. M2Amiga 4.0d
    :History.    18.10.91 --- 0.1 --- created

******************************************************************************)
IMPLEMENTATION MODULE SoundSupport;


FROM AudioSupport IMPORT
  Channel,ChannelSet,CloseChannel,Filter,OpenChannel,PlaySound;

FROM Definitions IMPORT
  Modes;

FROM SYSTEM IMPORT
  ADDRESS,ASSEMBLE;


VAR
  chanAllocated : BOOLEAN;
  chan          : ARRAY Modes OF Channel;


PROCEDURE AllocChannels;

BEGIN
  Filter(FALSE);
  chan[0]:=OpenChannel(ChannelSet{left0,left1});
  chan[1]:=OpenChannel(ChannelSet{right0,right1});
  chanAllocated:=TRUE;
END AllocChannels;


PROCEDURE FreeChannels;

BEGIN
  IF chanAllocated THEN
    CloseChannel(chan[0]);
    CloseChannel(chan[1]);
    chanAllocated:=FALSE;
  END;
END FreeChannels;


PROCEDURE PlaySample(sample:Sample; player:Modes);

BEGIN
  IF chanAllocated THEN
    PlaySound(chan[player],sample.data,sample.length,sample.period,64,1);
  END;
END PlaySample;


PROCEDURE StartMusic;
(*$ EntryExitCode:=FALSE *)

BEGIN
  ASSEMBLE(XREF   modplayer_InitPlayer,modplayer_PlayModule
           XREF   Music_TheChase
           JSR    modplayer_InitPlayer
           LEA    Music_TheChase,A0
           JSR    modplayer_PlayModule
           RTS
           END);
END StartMusic;


PROCEDURE StopMusic;
(*$ EntryExitCode:=FALSE *)

BEGIN
  ASSEMBLE(XREF   modplayer_StopPlayer,modplayer_RemPlayer
           JSR    modplayer_StopPlayer
           JSR    modplayer_RemPlayer
           RTS
           END);
END StopMusic;


END SoundSupport.
