(*************************************************************************

:Program.       DispTest.mod
:Contents.      Test-Prg for DisplayIO
:Author.        Hartmut Goebel
:Language.      Oberon
:Translator.    Amiga Oberon 2.13
:History.       V1.0, 30 Jan 1992, Hartmut Goebel
:Date.          30 Jan 1992 11:35:19

*************************************************************************)

MODULE DispTest;

IMPORT
  Break, NoGuru, io,
  d: Dos,
  dpl: Display,
  dio: DisplayIO,
  e: Exec,
  es: ExecSupport,
  I: Intuition,
  s: SYSTEM;

VAR
  Win: dpl.WindowPtr;
  MyPort: e.MsgPortPtr;
  c: ARRAY 100 OF CHAR;
  i: LONGINT;

BEGIN
  NEW(Win);
  IF (Win=NIL) THEN
    io.WriteString("No Memory!!"); HALT(20); END;
  MyPort := es.CreatePort("",0);
  IF MyPort = NIL THEN
    io.WriteString("Can't open port!!"); HALT(20); END;
  IF NOT dpl.OpenWindow(Win,"Display-Test",0,0,640,100,NIL) THEN
    io.WriteString("Can't open window!!"); HALT(20); END;
  IF dio.AttachPort(Win,MyPort,LONGSET{I.vanillaKey}) THEN END;

  dpl.FrontPen(Win,1);
  dio.WriteString(Win,"Hallo Welt!"); dpl.WriteLn(Win);
  dio.WriteInt(Win,77,3); dpl.Write(Win,"  ");
  dio.WriteHex(Win,0F7H,3); dpl.WriteLn(Win);

  dpl.Write(Win,"Char>"); dio.Read(Win,c[0]); dpl.WriteLn(Win);
  dpl.Write(Win,"String>"); dio.ReadString(Win,c);
  dpl.Write(Win,"Int>"); IF dio.ReadInt(Win,i) THEN END;
  dpl.Write(Win,"Hex>"); IF dio.ReadHex(Win,i) THEN END;

  dpl.CursorOff(Win);
  dio.WriteString(Win,"Window will close in 10 sec."); dpl.WriteLn(Win);
  d.Delay(500);
  dio.DetachPort(Win);
  dpl.Close(Win);

CLOSE
  IF MyPort # NIL THEN es.DeletePort(MyPort); END;

END DispTest.


