(*------------------------------------------------------------------)
    :Program.    SimplePlayer
    :Author.     Philippe Gressly (PHILU)
    :Address.    Nfenhaus, CH-8926 Kappel a/Albis
    :History     V1.00 (25.12.91)
    :Update.
    :Copyright.  PD
    :Language.   Oberon
    :Translator. OBERON
    :Imports.
    :Support.
    :Bugs.
    :Contents.
    :Remark.
    :Usage.      (nur von CLI verwenden:)
    :Usage.      SimplePlayer ScoreName [InstrDir [rep]]
(------------------------------------------------------------------*)

MODULE SimplePlayer;

IMPORT e: Exec,
       sp: SmusPlayer,
       o: OberonLib,
       io,
       a: Arguments,
       s: SYSTEM,
       d: Dos;

VAR InstrDirName    : ARRAY 64 OF CHAR;
    ScoreFileName   : ARRAY 64 OF CHAR;
    MyFileName      : ARRAY 64 OF CHAR; (* Name of this program *)
    i: INTEGER;
    Note: INTEGER;
    spNote: sp.SPNote;
    signr: SHORTINT;
    sigmask: LONGSET;
    rep: LONGINT;
    ch: CHAR;

BEGIN
   IF (a.NumArgs() < 1) OR (a.NumArgs() > 3) THEN
      io.WriteString("Usage: \n");
      a.GetArg(0, MyFileName);
      io.WriteString(MyFileName);
      io.WriteString(" <score-name> [Instruments-directory-name  [rep]]\n");
   ELSE (* enough arguments *)
      IF a.NumArgs() = 3 THEN
         rep := 0
      ELSE
         rep := 1
      END;
      (* get them arguments *)
      a.GetArg(1, ScoreFileName);
      IF (a.NumArgs() = 1) THEN
         InstrDirName := "Instruments";
      ELSE
         a.GetArg(2, InstrDirName);
      END;
      IF o.wbStarted THEN
         io.WriteString("Please start from CLI\n");
         HALT(0);
      END;
      IF sp.LoadScore(s.ADR(ScoreFileName), s.ADR(InstrDirName))
         = sp.SpERROR
      THEN
         io.WriteString("Score not loaded.\n");
      ELSE
         IF sp.PlayScore(0,rep) = sp.SpERROR THEN
            io.WriteString("Play ERROR.\n")
         ELSE
            IF rep = 1 THEN
               (* wait to signal *);

               signr := e.AllocSignal(-1);
               IF signr < 0 THEN
                  io.WriteString("no free signals\n");
                  d.Delay(500);
               ELSE
                  sigmask := LONGSET{};
                  INCL(sigmask, signr);
                  sp.SetReturnSig(sigmask);
                  REPEAT
                  UNTIL signr IN e.Wait(sigmask);
                  d.Delay(110);
                  e.FreeSignal(signr)
               END;
            ELSE (* Wait until Return *)
               io.WriteString("Enter to stop:");
               io.Read(ch);
            END;
            sp.UnLoadScore();
               (* UnLoadScore is not necessary, because the
                * CloseLibrary(smus) automaticly calls it.
                *)
         END
      END
   END
END SimplePlayer.



