(*---------------------------------------------------------------------------
    :Program.     ARPFileReq.mod
    :Contents.	  Simple Benutzung des ARP Filerequesters
    :Author.      Bernd Preusing
    :Address.	  Gerhardstr. 16  D-2200 Elmshorn
    :Phone.	  04121/22486
    :Copyright.	  Public Domain
    :Language.	  Modula-2
    :Translator.  M2Amiga V4.0d
    :History.	  V1.0 09-Oct-89 Bernd Preusing
    :History.	  V1.0.1 [Frank Lmker] 13-Aug-91 M2A 4.0, Arp 1.3,
    :History.	                                  Parameter x,y
    :Imports.	  ARP library
---------------------------------------------------------------------------*)
IMPLEMENTATION MODULE ARPFileReq;

(*$ LargeVars:=FALSE StackParms:=FALSE RangeChk:=FALSE OverflowChk:=FALSE
    ReturnChk:=FALSE StackChk:=FALSE EntryClear:=FALSE *)

FROM SYSTEM	IMPORT	ADR, ADDRESS;
FROM ARP	IMPORT	FileRequest, FileRequester,
			ReqFlags, ReqFlagSet, ReqFlags2,ReqFlagSet2;
FROM String	IMPORT	Copy, LastPos, Length, Concat;

VAR
  FR:FileRequester;
  File, Dir: ARRAY[0..79] OF CHAR;

PROCEDURE GetPath(VAR f,d:ARRAY OF CHAR);
VAR pos,i:INTEGER;
BEGIN
  Copy(d,f);
  pos:=LastPos(f,10000,'/');
  IF pos<0 THEN
    pos:=LastPos(f,10000,':');
  END;
  IF pos>=0 THEN
    IF d[pos]=':' THEN d[pos+1]:=0C ELSE d[pos]:=0C END;
    INC(pos);
    FOR i:=pos TO Length(f) DO
      f[i-pos]:=f[i]
    END;
    f[i]:=0C;
  ELSE
    d[0]:=0C
  END;
END GetPath;

PROCEDURE FileReq(VAR FName:ARRAY OF CHAR; Window:ADDRESS; Title:ARRAY OF CHAR;
		  x,y:INTEGER; flag:BOOLEAN):	BOOLEAN;
BEGIN
  Copy(File,FName);
  GetPath(File,Dir);

  FR.hail:=ADR(Title);
  IF flag THEN
    FR.funcFlags:=ReqFlagSet{};
  ELSE
    FR.funcFlags:=ReqFlagSet{doColor};
  END;
  FR.file      := ADR(File);
  FR.dir       := ADR(Dir);
  FR.window    := Window;
  FR.flags2    := ReqFlagSet2{longPath};
  FR.function  := NIL;
  IF x<0 THEN x:=25; END;
  IF y<0 THEN y:=21; END;
  FR.leftEdge  :=x;
  FR.topEdge   :=y;

  IF FileRequest(ADR(FR))#NIL THEN
    IF (Length(Dir)>0) AND (Dir[Length(Dir)-1]#':') THEN
      Concat(Dir,'/');
    END;
    Concat(Dir,File);
    Copy(FName,Dir);
    RETURN TRUE
  ELSE
    RETURN FALSE;
  END;
END FileReq;

END ARPFileReq.mod
