MODULE KwikWindow;

IMPORT

   Strings,
   Icon,
   Dos,
   E   : Exec,
   I   : Intuition,
   S   : SYSTEM,
   GT  : GadTools,
   G   : Graphics,
   u   : Utility,
   ol  : OberonLib,   
   WB  : Workbench,
   Args: Arguments;

TYPE

   prBackType = ARRAY 3 OF E.STRPTR;
   prDriveType= ARRAY 5 OF E.STRPTR;
   rdvType    = ARRAY 4 OF E.STRPTR;
   menuType   = ARRAY 9 OF GT.NewMenu;
   pathType   = ARRAY 256 OF CHAR;
   
CONST

   title*    = "Kwikbackup 2.0  1992 Achim Siebert";
   kwik*     = "Kwikbackup";
   prBack    = prBackType(S.ADR("Backup -->"),S.ADR("Restore <--"),NIL);
   prDrive*  = prDriveType(S.ADR("df0:"),S.ADR("df1:"),S.ADR("df2:"),S.ADR("df3:"),NIL);
   archstr   = "Set _Archive Flag";
   hdstr     = "_Harddisk-Partition/Drawer:";
   drivestr  = "Backup-_Drive:";
   regardstr = "_Regard Archive Flag";
   rdvstr*   = rdvType(S.ADR("ready!"),S.ADR("reading..."),S.ADR("writing..."),S.ADR("verifying..."));
   patstr    = "File _Pattern:";
   diskstr   = "Disk #:";
   trackstr  = "Track #:";
   drawerstr = "Drawer:";
   filestr   = "File:";
   
   (* --- Gadget-IDs --- *)

   gStop*     = 1;
   gStart*    = 2;
   gBack*     = 3;
   gArch*     = 4;
   gRegard*   = 5;
   gHardd*    = 6;
   gPat*      = 7;
   gDrive*    = 8;
   gDisk      = 9;
   gTrack     = 10;
   gState     = 11;
   gDrawer    = 12;
   gFile      = 13;

   mDrawer   = "drMenu";
   mAbout    = "abMenu";

   myMenu    = menuType(
      GT.title, S.ADR("Project"),                NIL, {}, LONGSET{}, NIL,
      GT.item , S.ADR("Select Drawer..."),S.ADR("O"), {}, LONGSET{}, S.ADR(mDrawer),
      GT.item , S.VAL(E.STRPTR,GT.barLabel),     NIL, {}, LONGSET{}, NIL,
      GT.item , S.ADR("Zoom Window"),     S.ADR("Z"), {}, LONGSET{}, NIL,
      GT.item , S.VAL(E.STRPTR,GT.barLabel),     NIL, {}, LONGSET{}, NIL,
      GT.item , S.ADR("About..."),        S.ADR("A"), {}, LONGSET{}, S.ADR(mAbout),
      GT.item , S.VAL(E.STRPTR,GT.barLabel),     NIL, {}, LONGSET{}, NIL,
      GT.item , S.ADR("Quit"),            S.ADR("Q"), {}, LONGSET{}, NIL,
      GT.end  , NIL,                             NIL, {}, LONGSET{}, NIL);


VAR

   snakeMax*,
   gadgetheight,
   mininheight,
   mininwidth,
   topoffset,
   leftoffset,
   rightoffset,
   prBackwidth,
   archwidth,
   regardwidth,
   drivewidth,
   rdvwidth,
   diskwidth,
   trackwidth,
   drawerwidth,
   patwidth,
   trnumwidth        : INTEGER;

   ScP               : I.ScreenPtr;
   winP*             : I.WindowPtr;
   vi                : E.APTR;
   glist*,
   stopglist*,
   startGadget*,
   stopGadget*,
   backupGadget*,
   archGadget*,
   regardGadget*,
   driveGadget*,
   hdGadget*,
   diskGadget*,
   trackGadget*,
   stateGadget*,
   drawerGadget*,
   patGadget*,
   fileGadget*       : I.GadgetPtr;
   menu*             : I.MenuPtr;
   nextMenu*         : I.MenuItemPtr;
   
   partition*        : ARRAY 256 OF CHAR;
   pattern*          : ARRAY 126 OF CHAR;
   
   zoom              : ARRAY 4 OF INTEGER;

   drive*             : INTEGER;
   backup*            : BOOLEAN;
   setarchs*          : BOOLEAN;
   regardarchs*       : BOOLEAN;

   bigdone*,bigsearch*: pathType;


PROCEDURE GetDimensions();

CONST donestr   = "  all done  ";
      searchstr = "  searching  ";

VAR   width,width1: INTEGER;
      uscw,i : INTEGER;

   PROCEDURE MakeBigString(VAR bigstr:ARRAY OF CHAR; dstr:ARRAY OF CHAR);
   
   VAR anz,i: INTEGER;
   
   BEGIN
   
      anz := (mininwidth-drawerwidth-28-G.TextLength(S.ADR(ScP.rastPort),dstr,Strings.Length(dstr))) DIV
                       G.TextLength(S.ADR(ScP.rastPort),"-",1) DIV 2 - 2;
      bigstr := " ";
      FOR i := 0 TO anz DO
         bigstr[i+1] := "-";
      END;
      FOR i := 0 TO Strings.Length(dstr) DO
         bigstr[anz+2+i] := dstr[i];
      END;
      FOR i := 2 TO anz+2 DO
         width := anz+Strings.Length(dstr)+i;
         IF width < 256 THEN
            bigstr[width] := "-";
         END;
      END;
   
   END MakeBigString;


BEGIN

   topoffset      := ScP.wBorTop+ScP.font.ySize+1;
   leftoffset     := ScP.wBorLeft;
   rightoffset    := ScP.wBorRight;

   gadgetheight   := ScP.font.ySize+5;

   width := 0; width1 := 0; rdvwidth := 0;

   FOR i := 0 TO 3 DO
      width1 := G.TextLength(S.ADR(ScP.rastPort),rdvstr[i]^,Strings.Length(rdvstr[i]^));
      IF rdvwidth < width1 THEN rdvwidth := width1 END;
   END;

   uscw := G.TextLength(S.ADR(ScP.rastPort),"_",1);

   prBackwidth    := G.TextLength(S.ADR(ScP.rastPort),prBack[1]^,Strings.Length(prBack[1]^))+36;
   archwidth      := G.TextLength(S.ADR(ScP.rastPort),archstr,Strings.Length(archstr))+34-uscw;
   regardwidth    := G.TextLength(S.ADR(ScP.rastPort),regardstr,Strings.Length(regardstr))+34-uscw;
   drivewidth     := G.TextLength(S.ADR(ScP.rastPort),drivestr,Strings.Length(drivestr))+8-uscw;
   trnumwidth     := G.TextLength(S.ADR(ScP.rastPort),"55",2);
   diskwidth      := G.TextLength(S.ADR(ScP.rastPort),diskstr,Strings.Length(diskstr));
   trackwidth     := G.TextLength(S.ADR(ScP.rastPort),trackstr,Strings.Length(trackstr));
   drawerwidth    := G.TextLength(S.ADR(ScP.rastPort),drawerstr,Strings.Length(drawerstr));
   patwidth       := G.TextLength(S.ADR(ScP.rastPort),patstr,Strings.Length(patstr))-uscw;

   width := 2*prBackwidth+drivewidth+16;
   width1:= regardwidth+archwidth+16;
   IF width1 > width THEN width := width1 END;
   width1:= diskwidth+trackwidth+rdvwidth+2*trnumwidth+72;
   IF width1 > width THEN width := width1 END;
   width1:= 90+G.TextLength(S.ADR(ScP.rastPort),title,Strings.Length(title));
   IF width1 > width THEN width := width1 END;

   mininwidth := width + 16;

   snakeMax       := ((mininwidth-drawerwidth-28) DIV G.TextLength(S.ADR(ScP.rastPort)," ",1))+7;

   zoom[1]        := 0;
   zoom[2]        := width1;
   zoom[0]        := ScP.width-zoom[2]-23;
   zoom[3]        := topoffset;

   MakeBigString(bigdone,donestr);
   MakeBigString(bigsearch,searchstr);
   
END GetDimensions;


PROCEDURE CreateAllGadgets(): BOOLEAN;

VAR
   ng: GT.NewGadget;
   gad,stopgad: I.GadgetPtr;
   index: INTEGER;
   lbool,backbool: LONGINT;

BEGIN
   gad := GT.CreateContext(glist);
   stopgad := GT.CreateContext(stopglist);

   ng.leftEdge := leftoffset+8;
   ng.topEdge  := topoffset+4;
   ng.width    := mininwidth-16;
   ng.height   := gadgetheight;
   ng.gadgetText := S.ADR("_Start !");
   ng.textAttr := ScP.font;
   ng.gadgetID := gStart;
   ng.flags    := LONGSET{};
   ng.visualInfo := vi;
   gad := GT.CreateGadget(GT.buttonKind, gad, ng,
                          GT.underscore,ORD("_"),
                          u.done);
   startGadget := gad;

   ng.gadgetText := S.ADR("_STOP !");
   ng.gadgetID := gStop;
   stopgad := GT.CreateGadget(GT.buttonKind, stopgad, ng,
                              GT.underscore,ORD("_"),
                              u.done);
   stopGadget := stopgad;

   ng.gadgetText := NIL;
   ng.topEdge := ng.topEdge+gadgetheight+4;
   ng.width := prBackwidth;
   ng.gadgetID := gBack;
   index := 0; IF ~backup THEN INC(index) END;
   gad := GT.CreateGadget(GT.cycleKind, gad, ng,
                          GT.cyLabels, S.ADR(prBack),
                          GT.cyActive, index,
                          u.done);
   backupGadget := gad;

   ng.leftEdge := mininwidth+leftoffset-prBackwidth-8;
   INCL(ng.flags,GT.placeTextLeft);
   ng.gadgetText := S.ADR(drivestr);
   ng.gadgetID := gDrive;
   gad := GT.CreateGadget(GT.cycleKind, gad, ng,
                          GT.cyLabels, S.ADR(prDrive),
                          GT.cyActive, drive,
                          GT.underscore,ORD("_"),
                          u.done);
   driveGadget := gad;

   backbool := I.BoolToLong(~backup);
   ng.leftEdge := leftoffset+8;
   ng.topEdge := ng.topEdge+gadgetheight+4;
   EXCL(ng.flags,GT.placeTextLeft);
   INCL(ng.flags,GT.placeTextRight);
   ng.gadgetID := gRegard;
   ng.gadgetText := S.ADR(regardstr);
   lbool := I.BoolToLong(regardarchs);
   gad := GT.CreateGadget(GT.checkBoxKind, gad, ng,
                          GT.cbChecked, lbool,
                          I.gaDisabled, backbool,
                          GT.underscore,ORD("_"),
                          u.done);
   regardGadget := gad;

   ng.leftEdge := mininwidth-8-26+leftoffset;
   EXCL(ng.flags,GT.placeTextRight);
   INCL(ng.flags,GT.placeTextLeft);
   ng.gadgetID := gArch;
   ng.gadgetText := S.ADR(archstr);
   lbool := I.BoolToLong(setarchs);
   gad := GT.CreateGadget(GT.checkBoxKind, gad, ng,
                          GT.cbChecked, lbool,
                          I.gaDisabled, backbool,
                          GT.underscore,ORD("_"),
                          u.done);
   archGadget := gad;

   ng.leftEdge := leftoffset+8;
   ng.topEdge  := ng.topEdge+2*gadgetheight-1;
   ng.width    := mininwidth - 16;
   EXCL(ng.flags,GT.placeTextLeft);
   INCL(ng.flags,GT.placeTextAbove);
   ng.gadgetText := S.ADR(hdstr);
   ng.gadgetID := gHardd;
   gad := GT.CreateGadget(GT.stringKind, gad, ng,
                          GT.stMaxChars, 256,
                          GT.stString,S.ADR(partition),
                          GT.underscore,ORD("_"),
                          I.stringaJustification,LONGSET{I.stringCenter},
                          u.done);
   hdGadget := gad;

   ng.leftEdge := leftoffset+16+patwidth;
   ng.topEdge  := ng.topEdge+gadgetheight+4;
   ng.width    := mininwidth-ng.leftEdge-4;
   EXCL(ng.flags,GT.placeTextAbove);
   INCL(ng.flags,GT.placeTextLeft);
   ng.gadgetText := S.ADR(patstr);
   ng.gadgetID := gPat;
   gad := GT.CreateGadget(GT.stringKind, gad, ng,
                          GT.stMaxChars, 126,
                          GT.stString,S.ADR(pattern),
                          GT.underscore,ORD("_"),
                          I.stringaJustification,LONGSET{I.stringCenter},
                          u.done);
   patGadget := gad;

   ng.width    := trnumwidth+4;
   ng.topEdge  := ng.topEdge+gadgetheight+4;
   ng.leftEdge := leftoffset+diskwidth+16;
   ng.gadgetText := S.ADR(diskstr);
   ng.gadgetID := gDisk;
   gad := GT.CreateGadget(GT.numberKind, gad, ng,
                          GT.nmBorder, I.LFALSE,
                          GT.nmNumber,0,
                          u.done);
   diskGadget := gad;

   ng.leftEdge := leftoffset+(mininwidth DIV 2)-((trackwidth+8+trnumwidth) DIV 2)+trackwidth+8;
   ng.gadgetText := S.ADR(trackstr);
   ng.gadgetID := gTrack;
   gad := GT.CreateGadget(GT.numberKind, gad, ng,
                          GT.nmBorder, I.LFALSE,
                          GT.nmNumber,0,
                          u.done);
   trackGadget := gad;

   ng.leftEdge := mininwidth+leftoffset-8-rdvwidth;
   ng.width    := rdvwidth;
   ng.gadgetText := NIL;
   ng.gadgetID := gState;
   gad := GT.CreateGadget(GT.textKind, gad, ng,
                          GT.txText,rdvstr[0],
                          u.done);
   stateGadget := gad;

   ng.topEdge  := ng.topEdge+gadgetheight+4;
   ng.width    := mininwidth-drawerwidth-24;
   ng.leftEdge := leftoffset+drawerwidth+16;
   ng.gadgetText := S.ADR(drawerstr);
   ng.gadgetID := gDrawer;
   gad := GT.CreateGadget(GT.textKind, gad, ng,
                          GT.txText,NIL,
                          GT.txBorder,I.LTRUE,
                          u.done);
   drawerGadget := gad;

   ng.topEdge    := ng.topEdge+gadgetheight+4;
   ng.gadgetText := S.ADR(filestr);
   ng.gadgetID   := gFile;
   gad := GT.CreateGadget(GT.textKind, gad, ng,
                          GT.txText,NIL,
                          GT.txBorder,I.LTRUE,
                          u.done);
   fileGadget := gad;

   mininheight := ng.topEdge-topoffset+gadgetheight+4;

   RETURN (gad#NIL) AND (stopgad#NIL);

END CreateAllGadgets;


PROCEDURE OpenWindow();

VAR

  myNewWin: I.NewWindow;
  leftEdge,topEdge: INTEGER;

CONST
   myNewWinConst = I.NewWindow(
       0, 0,               (*  LeftEdge, TopEdge *)
       0, 0,               (*  Width, Height *)
       -1, -1,             (*  DetailPen, BlockPen *)
       LONGSET{I.gadgetUp,I.closeWindow,I.changeWindow,I.refreshWindow,I.vanillaKey,I.menuPick}; (*  IDCMPFlags *)
       LONGSET{I.activate,I.windowDrag,I.windowDepth,I.windowClose}, (* Flags *)
       NIL,                (*  FirstGadget *)
       NIL,                (*  CheckMark *)
       S.ADR(title),       (*  Title *)
       NIL,                (*  Screen *)
       NIL,                (*  BitMap *)
       0, 0,               (*  MinWidth, MinHeight *)
       -1, -1,             (*  MaxWidth, MaxHeight *)
       {I.wbenchScreen});  (*  Type *)

BEGIN

   ScP := I.LockPubScreen(NIL);
   IF ScP=NIL THEN HALT(20) END;

   vi := GT.GetVisualInfo(ScP,u.done);
   IF vi=NIL THEN HALT(20) END;

   GetDimensions();

   IF ~ CreateAllGadgets() THEN
      HALT(20);
   END;

   menu := GT.CreateMenus(myMenu,GT.fullMenu,I.LTRUE,u.done);
   IF menu = NIL THEN HALT(20) END;

   IF ~ GT.LayoutMenus(menu, vi,u.done) THEN HALT(20) END;

   myNewWin := myNewWinConst;
   myNewWin.firstGadget := glist;

   leftEdge := ScP.mouseX +leftoffset - mininwidth DIV 2;
   topEdge  := ScP.mouseY-topoffset-4-gadgetheight DIV 2;

   winP := I.OpenWindowTags(myNewWin,
                            I.waInnerHeight,mininheight,
                            I.waInnerWidth,mininwidth,
                            I.waMinHeight,mininheight,
                            I.waMinWidth,mininwidth,
                            I.waScreenTitle,S.ADR(title),
                            I.waZoom,S.ADR(zoom),
                            I.waAutoAdjust,I.LTRUE,
                            I.waLeft,leftEdge,
                            I.waTop,topEdge,
                            I.waPubScreen, ScP,
                            u.done);
   IF winP = NIL THEN HALT(20) END;

   IF ScP#NIL THEN
      I.UnlockPubScreen(NIL, ScP);
      ScP := NIL;
   END;

   IF ~ I.SetMenuStrip(winP,menu^) THEN HALT(20) END;

   GT.RefreshWindow(winP, NIL);

END OpenWindow;


PROCEDURE StopGads*();

BEGIN

   GT.SetGadgetAttrs(startGadget^,winP,NIL,I.gaDisabled,I.LTRUE,u.done);
   GT.SetGadgetAttrs(backupGadget^,winP,NIL,I.gaDisabled,I.LTRUE,u.done);
   GT.SetGadgetAttrs(archGadget^,winP,NIL,I.gaDisabled,I.LTRUE,u.done);
   GT.SetGadgetAttrs(regardGadget^,winP,NIL,I.gaDisabled,I.LTRUE,u.done);
   GT.SetGadgetAttrs(hdGadget^,winP,NIL,I.gaDisabled,I.LTRUE,u.done);
   GT.SetGadgetAttrs(patGadget^,winP,NIL,I.gaDisabled,I.LTRUE,u.done);
   GT.SetGadgetAttrs(driveGadget^,winP,NIL,I.gaDisabled,I.LTRUE,u.done);

   nextMenu := winP.menuStrip.firstItem;
   WHILE nextMenu # NIL DO
      IF (GT.MenuItemUserData(nextMenu)=S.ADR(mDrawer)) OR (GT.MenuItemUserData(nextMenu)=S.ADR(mAbout)) THEN
         EXCL(nextMenu.flags,I.itemEnabled);
      END;
      nextMenu := nextMenu.nextItem;
   END;

END StopGads;


PROCEDURE RunGads*();

BEGIN

   GT.SetGadgetAttrs(startGadget^,winP,NIL,I.gaDisabled,I.LFALSE,u.done);
   GT.SetGadgetAttrs(backupGadget^,winP,NIL,I.gaDisabled,I.LFALSE,u.done);
   IF backup THEN
      GT.SetGadgetAttrs(archGadget^,winP,NIL,I.gaDisabled,I.LFALSE,u.done);
      GT.SetGadgetAttrs(regardGadget^,winP,NIL,I.gaDisabled,I.LFALSE,u.done);
   END;
   GT.SetGadgetAttrs(hdGadget^,winP,NIL,I.gaDisabled,I.LFALSE,u.done);
   GT.SetGadgetAttrs(patGadget^,winP,NIL,I.gaDisabled,I.LFALSE,u.done);
   GT.SetGadgetAttrs(driveGadget^,winP,NIL,I.gaDisabled,I.LFALSE,u.done);

   nextMenu := winP.menuStrip.firstItem;
   WHILE nextMenu # NIL DO
      IF (GT.MenuItemUserData(nextMenu)=S.ADR(mDrawer)) OR (GT.MenuItemUserData(nextMenu)=S.ADR(mAbout)) THEN
         INCL(nextMenu.flags,I.itemEnabled);
      END;
      nextMenu := nextMenu.nextItem;
   END;

END RunGads;


PROCEDURE GetArgs();

VAR
   string       : E.STRPTR;
   qstring      : ARRAY 20 OF CHAR;
   rdargs       : Dos.RDArgsPtr;
   argarray     : ARRAY 6 OF LONGINT;
   
   PROCEDURE ShowUsage();

   BEGIN
   
      Dos.PrintF("\nUSAGE: P=PARTITION/K : Harddisk partition or drawer,      default: dh0:\n"
                 "       D=DRIVE/K :     Backup-drive (df0:,...,df3:),      default: df0:\n"
                 "       PATTERN/K :     Pattern to use for backup/restore, default: #?\n"
                 "       RESTORE/S :     Restore mode; default: backup mode\n"
                 "       SETFLAG/S :     Set archive flag\n"
                 "       REGARDFLAG/S :  Backup files not archived yet\n\n");

   END ShowUsage;

BEGIN
   
   IF Args.NumArgs()=1 THEN
      Args.GetArg(1,qstring);
      IF (qstring="?") OR (qstring="-?") OR (qstring="HELP") THEN ShowUsage END;
   END;   
   
   rdargs := Dos.ReadArgs("P=PARTITION/K,D=DRIVE/K,PATTERN/K,RESTORE/S,SETFLAG/S,REGARDFLAG/S",argarray,NIL);
   
   IF rdargs=NIL THEN ShowUsage END;
   
   IF argarray[0]#0 THEN
      string := S.VAL(E.STRPTR,argarray[0]);
      COPY(string^,partition);
   END;
   IF (argarray[1]#0) THEN
      string := S.VAL(E.STRPTR,argarray[1]);
      Strings.Upper(string^);
      IF    string^="DF1:" THEN drive := 1;
      ELSIF string^="DF2:" THEN drive := 2;
      ELSIF string^="DF3:" THEN drive := 3;
      END;
   END;
   IF argarray[2]#0 THEN
      string := S.VAL(E.STRPTR,argarray[2]);
      COPY(string^,pattern);
      IF pattern="" THEN pattern := "#?" END;
   END;
   backup := argarray[3]=0;
   setarchs    := argarray[4]#0;
   regardarchs := argarray[5]#0;

   IF rdargs # NIL THEN Dos.FreeArgs(rdargs) END;

END GetArgs;


PROCEDURE GetTools();

VAR string : E.STRPTR;
    int    : LONGINT;
    MyName : ARRAY 32 OF CHAR;
    wbdop  : WB.DiskObjectPtr;
    
    
   PROCEDURE FindTool(findstr: ARRAY OF CHAR):BOOLEAN;
   
   BEGIN

     string := Icon.FindToolType(wbdop.toolTypes,findstr);
     IF string # NIL THEN RETURN TRUE END;
     RETURN FALSE;

   END FindTool;


BEGIN

  Args.GetArg(0,MyName);
  IF MyName # "" THEN
     wbdop := Icon.GetDiskObject(MyName);
     IF wbdop # NIL THEN
        IF FindTool("PARTITION") THEN
           COPY(string^,partition);
        END;
        IF FindTool("DRIVE") THEN
           Strings.Upper(string^);
           IF    string^="DF1:" THEN drive := 1;
           ELSIF string^="DF2:" THEN drive := 2;
           ELSIF string^="DF3:" THEN drive := 3;
           END;
        END;
        IF FindTool("PATTERN") THEN
           COPY(string^,pattern);
           IF pattern="" THEN pattern := "#?" END;
        END;
        IF FindTool("RESTORE") THEN
           Strings.Upper(string^);
           backup := ~(string^="ON");
        END;
        IF FindTool("SETFLAG") THEN
           Strings.Upper(string^);
           setarchs := string^="ON";
        END;
        IF FindTool("REGARDFLAG") THEN
           Strings.Upper(string^);
           regardarchs := string^="ON";
        END;
        Icon.FreeDiskObject(wbdop);
     END;
  END;

END GetTools;


BEGIN

   backup := TRUE; setarchs := FALSE; regardarchs := FALSE;
   partition   := "DH0:"; drive := 0;
   pattern     := "#?";
   
   IF ol.wbStarted THEN
      GetTools();
   ELSE
      GetArgs();
   END;

   OpenWindow();

CLOSE

   IF winP  # NIL THEN I.ClearMenuStrip(winP);I.CloseWindow(winP) END;
   GT.FreeMenus(menu);
   GT.FreeGadgets(glist);
   GT.FreeGadgets(stopglist);
   GT.FreeVisualInfo(vi);

END KwikWindow.
