(*************************************************************************

:Program.    PL0.mod
:Contents.   Compiler for simple-demo-prog-lang PL0
:Author.     N. With, ported to Oberon by hartmut Goebel
:Language.   Oberon
:Translator. Amiga Oberon

:Imports.    TextWindows (hartmut Goebel)
:Imports.    MultiMem (hartmut Goebel) - not here, but in used modules

*************************************************************************)

MODULE PL0;

IMPORT
  io,
  scan: PL0Scanner, Break,
  int: PL0Interpreter,
  gen: PL0Generator,
  prs: PL0Parser,
  fs: FileSystem;

VAR
  Filename: ARRAY 80 OF CHAR;

BEGIN
 LOOP
   io.WriteString("in >");
   io.ReadString(Filename);
   IF Filename = "" THEN EXIT; END;
   IF fs.Open(scan.source,Filename,FALSE) THEN
     scan.InitScanner;
     gen.InitGenerator;
     prs.Parse;
     IF fs.Close(scan.source) THEN END;
     IF prs.noerr THEN
       io.WriteString("-> interpreting\n");
       int.Interpret;
     ELSE
       io.WriteString("-> incorrect\n");
     END;
   END;
 END;
END PL0.


