(*****************************************************************************
**									    **
**   #####  ###### ##   ## ##### #####   ##### ####       written by:       **
**   ##  ## ##     ##   ## ##    ##  ## ##      ##      Robert Brandner     **
**   #####  ####    ## ##  ####  #####   ####   ##   	Schillerstr. 3      **
**   ##  ## ##      ## ##  ##    ##  ##     ##  ##   	A-8280 Frstenfeld  **
**   ##  ## ######   ###   ##### ##  ## #####  ####  	AUSTRIA/EUROPE      **
**									    **
**   This program is written in Modula-II using the compiler M2Amiga V3.3d  **
**									    **
*****************************************************************************)

MODULE Reversi;

FROM IntuitionD IMPORT
  NewScreen, ScreenPtr, NewWindow, WindowPtr,
  WindowFlags,WindowFlagSet,customScreen,IDCMPFlagSet;
FROM IntuitionL IMPORT
  OpenScreen, CloseScreen,
  OpenWindow, CloseWindow;
FROM SYSTEM IMPORT ADR, ADDRESS, ASSEMBLE, CAST;
FROM GraphicsD IMPORT
  RastPortPtr,
  jam1, jam2, BitMap, normalFont,
  TextFontPtr, TextAttr,
  FontFlags, FontFlagSet, ViewModeSet;
FROM GraphicsL IMPORT
  RectFill, SetAPen, LoadRGB4, Text, Move, Draw, SetRast,
  SetDrMd, InitBitMap, BltBitMapRastPort,
  AllocRaster, FreeRaster, SetFont, CloseFont, SetRGB4,
  TextLength, OpenFont, ReadPixel;
FROM GfxMacros IMPORT RasSize;
FROM Arts IMPORT Assert;
FROM DosL IMPORT Delay;
FROM Hardware IMPORT gamePort0, ciaa;
FROM ExecL IMPORT CopyMem;
FROM RandomNumber IMPORT RND;

CONST GROSS = 8;
      SCHWARZ = 0; WEISS = 1; LEER = 2;
      MENSCH = 0; AMIGA = 1; PAUSE = 2; KEIN = 3;
      BREAK = -30000;

TYPE Brett = ARRAY [0..GROSS-1],[0..GROSS-1] OF INTEGER;

VAR SCHWSP, WEISSP, STIEF, WTIEF : INTEGER;
    memptr : ARRAY[1..4] OF ADDRESS;
    ns : NewScreen;
    nw : NewWindow;
    scr : ScreenPtr;
    win : WindowPtr;
    rp : RastPortPtr;
    maxzug, amzug, zugnum, mx, my, x, y, zx, zy : INTEGER;
    i : CARDINAL;
    anz : ARRAY[0..2] OF INTEGER;
    brett, wert : Brett;
    memory : ARRAY[0..GROSS*GROSS-1] OF
             RECORD
               b : Brett;
               sp : INTEGER;
             END;
    forward, back, paused, force, restart, quit, sZieh, wZieh : BOOLEAN;
    bm : BitMap;
    pl : ADDRESS;
    ch : ARRAY[0..0] OF CHAR;
    topaz : TextFontPtr;
    ta : TextAttr;

PROCEDURE Graphics; (*$EntryExitCode:=FALSE *)
BEGIN
  ASSEMBLE(
   DC.W  $FFFF,$FFFF,$FFFE,$03F0,$0000,$0000,$0FFF,$FFE0,$C000,
         $FC07,$FFC0,$7FFB,$FCF7,$FFFF,$FFFF,$EC1F,$F7FE,$4000,$F001,
         $FF00,$1FFF,$FF72,$ABAE,$BEAA,$E80F,$83FF,$0000,$E000,$FE00,
         $0FFF,$FFB3,$AAAA,$E6EF,$E405,$01BF,$8000,$E000,$7E00,$07DF,
         $FFD3,$BBAA,$F6EA,$A404,$00BF,$8000,$8000,$3800,$03FF,$FFD0,
         $89AA,$3E2E,$A404,$00BF,$8000,$C000,$3C00,$03BF,$FFE7,$48C4,
         $2516,$A604,$009F,$8000,$4000,$1400,$01BF,$FFE4,$0000,$0000,
         $0304,$01CF,$C000,$4000,$1400,$01BF,$FFE0,$0048,$2763,$09EE,
         $03E1,$C000,$4000,$1400,$01BF,$FFE0,$6B1E,$CD96,$2C1F,$07FF,
         $C000,$4000,$1400,$01BF,$FFE2,$1144,$8D06,$2FFF,$FF00,$0000,
         $4000,$1400,$01BF,$FFE0,$3948,$9924,$0C1D,$FF00,$0000,$6000,
         $1600,$01BF,$FFE0,$9482,$F657,$080D,$FF00,$0000,$2000,$1200,
         $01DF,$FFF1,$0000,$0000,$0405,$FF00,$0000,$B000,$3B00,$03DF,
         $FFD0,$0440,$A11B,$A405,$FF00,$0000,$9800,$3980,$03EF,$FFF0,
         $0000,$0000,$0405,$FF00,$0000,$CC00,$7CC0,$07F7,$FFF0,$0000,
         $0000,$0605,$FF00,$0000,$E701,$FE70,$1FF9,$FEF0,$0000,$0000,
         $0305,$FF00,$0000,$F1FD,$FF1F,$DFFE,$03F0,$0000,$0000,$09ED,
         $FF00,$0000,$FC07,$FFC0,$7FFF,$FFF0,$0000,$0000,$0C1C,$0100,
         $0000,$FE03,$FFFF,$FFFE,$03F7,$FFFF,$FFFF,$FE0F,$FFE0,$C000,
         $FBF8,$FFC0,$7FFB,$FCF7,$FFFF,$FFFF,$FFE7,$FFFE,$4000,$FFFE,
         $7F00,$1FFF,$FF72,$ABAE,$BEAA,$FFF3,$FFFF,$0000,$FFFF,$3E00,
         $0FFF,$FFB3,$AAAA,$E6EF,$F7F9,$FFFF,$8000,$FFFF,$9C00,$07FF,
         $FFD3,$BBAA,$F6EA,$B7F9,$FFFF,$8000,$BFFF,$D800,$03FF,$FFD0,
         $89AA,$3E2E,$B7F9,$FFFF,$8000,$FFFF,$C800,$03FF,$FFE7,$48C4,
         $2516,$B7F9,$BBFF,$8000,$7FFF,$E000,$01FF,$FFE4,$0000,$0000,
         $13FC,$C7FF,$C000,$7FFF,$E000,$01FF,$FFE0,$0048,$2763,$19FE,
         $7FFF,$C000,$7FFF,$E000,$01FF,$FFE0,$6B1E,$CD96,$3C1F,$07FF,
         $C000,$7FFF,$E000,$01FF,$FFE2,$1144,$8D06,$3FFE,$0000,$0000,
         $7FFF,$E000,$01FF,$FFE0,$3948,$9924,$1C1C,$0000,$0000,$7FFF,
         $E000,$01FF,$FFE0,$9482,$F657,$180C,$0000,$0000,$3FFF,$F000,
         $01FF,$FFF1,$0000,$0000,$1004,$0000,$0000,$BFFF,$D800,$03FF,
         $FFD0,$0440,$A11B,$B004,$0000,$0000,$9FFF,$F800,$03FF,$FFF0,
         $0000,$0000,$1004,$0000,$0000,$CFFF,$FC00,$07FF,$FFF0,$0000,
         $0000,$0004,$0000,$0000,$E7FF,$FE00,$0FFF,$FFF0,$0000,$0000,
         $0004,$0000,$0000,$F1FD,$FF00,$1FFF,$FFF0,$0000,$0000,$080C,
         $0000,$0000,$FC07,$FFC0,$7FFF,$FFF0,$0000,$0000,$0C1C,$0100,
         $0000,$01FC,$001F,$C001,$FC08,$0000,$0000,$01F0,$6C1F,$0000,
         $07FF,$0040,$7004,$030B,$BB2C,$E4EE,$A3F8,$FE01,$8000,$0FFF,
         $8000,$1800,$008F,$7EFB,$CFDD,$47FD,$FF00,$C000,$1FFF,$C000,
         $0C00,$004E,$7FFF,$BDBE,$AFFF,$FF00,$4000,$3FFF,$E000,$0600,
         $002F,$FF7F,$E9FD,$EFFF,$FF00,$4000,$7FFF,$E400,$0200,$002F,
         $7655,$C1D1,$4FFF,$FF00,$4000,$7FFF,$F000,$0300,$0019,$48C4,
         $2516,$8FFF,$FF00,$4000,$FFFF,$F800,$0100,$0018,$FFFF,$FFFF,
         $8FFB,$FE00,$0000,$FFFF,$F800,$0100,$001D,$C8DA,$3FFB,$C7F1,
         $FC00,$0000,$FFFF,$F800,$0100,$001D,$EFBF,$FFDF,$E3E0,$F800,
         $0000,$FFFF,$F800,$0100,$001F,$B5ED,$BF57,$E1F1,$FF00,$0000,
         $FFFF,$F800,$0100,$001D,$BD69,$BB7D,$C01B,$FF00,$0000,$FFFF,
         $F800,$0100,$001D,$B4CA,$FEDF,$C00F,$BB00,$0000,$FFFF,$EC00,
         $0000,$000D,$FFFF,$FFFF,$8807,$EF00,$0000,$7FFF,$E400,$0200,
         $002E,$0440,$A11B,$8807,$EF00,$0000,$7FFF,$C600,$0000,$000F,
         $FFFF,$FFFF,$E807,$BB00,$0000,$3FFF,$8300,$0000,$0000,$0000,
         $0000,$0807,$C700,$0000,$1FFF,$0180,$0000,$0000,$0000,$0000,
         $0C03,$FF00,$0000,$0FFE,$00E0,$2000,$0000,$0000,$0000,$0603,
         $FF00,$0000,$03F8,$003F,$8000,$0000,$0000,$0000,$03E3,$FE00,
         $0000,$FFFF,$FFE0,$3FFF,$FFFF,$FFFF,$FFFF,$FFFF,$93FF,$C000,
         $FFFF,$FFBF,$8FFF,$FFFF,$FFFF,$FFFF,$FFFF,$01FF,$C000,$FFFF,
         $FFFF,$E7FF,$FFFF,$FFFF,$FFFF,$FFFE,$00FF,$C000,$FFFF,$FFFF,
         $F3FF,$FFFF,$FFFF,$FFFF,$FFFE,$44FF,$C000,$FFFF,$FFFF,$F9FF,
         $FFFF,$FFFF,$FFFF,$FFFE,$00FF,$C000,$FFFF,$FFFF,$FDFF,$FFFF,
         $FFFF,$FFFF,$FFFE,$00FF,$C000,$FFFF,$FFFF,$FCFF,$FFFE,$B73B,
         $DAE9,$7FFE,$00FF,$C000,$FFFF,$FFFF,$FEFF,$FFFF,$0000,$0000,
         $7FFF,$01FF,$C000,$FFFF,$FFFF,$FEFF,$FFFE,$3725,$C004,$3FFF,
         $83FF,$C000,$FFFF,$FFFF,$FEFF,$FFFE,$1040,$0020,$1FFF,$FFFF,
         $C000,$FFFF,$FFFF,$FEFF,$FFFC,$4A12,$40A8,$1E0E,$0000,$0000,
         $FFFF,$FFFF,$FEFF,$FFFE,$4296,$4482,$3FE6,$FE00,$0000,$FFFF,
         $FFFF,$FEFF,$FFFE,$4B35,$0120,$3FF2,$BA00,$0000,$FFFF,$FFFF,
         $FFFF,$FFFE,$0000,$0000,$7FFA,$EE00,$0000,$FFFF,$FFFF,$FDFF,
         $FFFF,$FBBF,$5EE4,$7FFA,$EE00,$0000,$FFFF,$FFFF,$FFFF,$FFFF,
         $FFFF,$FFFF,$FFFA,$BA00,$0000,$FFFF,$FFFF,$FFFF,$FFF0,$0000,
         $0000,$0FFA,$C600,$0000,$FFFF,$FFFF,$FFFF,$FFF0,$0000,$0000,
         $0FFE,$FE00,$0000,$FFFF,$FFFF,$FFFF,$FFF0,$0000,$0000,$0FFE,
         $0000,$0000,$FFFF,$FFFF,$FFFF,$FFF0,$0000,$0000,$0FFF,$FF00,
         $0000
      END
     );
END Graphics;

PROCEDURE Colors; (*$EntryExitCode:=FALSE *)
BEGIN
  ASSEMBLE(
   DC.W $000,$EEE,$F00,$00F,$C03,$ECA,$E84,$FE0,
        $FC0,$CA0,$CCC,$AAA,$888,$45D,$40C,$208
   END
  );
END Colors;

PROCEDURE Werte; (*$EntryExitCode:=FALSE *)
BEGIN
 ASSEMBLE(
  DC.W 700,-10,100,100,100,100,-10,700
  DC.W -10,-10, -7, -7, -7, -7,-10,-10
  DC.W 100, -7,  2,  2,  2,  2, -7,100
  DC.W 100, -7,  2,  1,  1,  2, -7,100
  DC.W 100, -7,  2,  1,  1,  2, -7,100
  DC.W 100, -7,  2,  2,  2,  2, -7,100
  DC.W -10,-10, -7, -7, -7, -7,-10,-10
  DC.W 700,-10,100,100,100,100,-10,700
  END
 );
END Werte;

PROCEDURE Quad(x0, y0, x1, y1:INTEGER);
BEGIN
  SetAPen(rp, 11); RectFill(rp, x0, y0, x1, y1);
  SetAPen(rp, 10); Move(rp, x0, y0); Draw(rp, x1, y0); Draw(rp, x1, y1);
  SetAPen(rp, 12); Move(rp, x0, y0+1); Draw(rp, x0, y1); Draw(rp, x1, y1);
END Quad;

PROCEDURE SchreibSchatt(txt : ARRAY OF CHAR; l, x, y, w, c : INTEGER);
VAR xx : INTEGER;
BEGIN
  SetDrMd(rp, jam1);
  xx := x+(w-TextLength(rp, ADR(txt), l))/2;
  SetAPen(rp, 12); Move(rp, xx-1, y+1+INTEGER(rp^.txBaseline));
  Text(rp, ADR(txt), l);
  SetAPen(rp, c); Move(rp, xx, y+INTEGER(rp^.txBaseline));
  Text(rp, ADR(txt), l);
END SchreibSchatt;

PROCEDURE Schreib(txt : ARRAY OF CHAR; la, farb : INTEGER);
BEGIN
  Quad(32, 32+(1-farb)*32, 87, 55+(1-farb)*32);
  SchreibSchatt(txt, la, 32, 40+(1-farb)*32, 56, 1);
END Schreib;

PROCEDURE Blit(xoffset, yoffset, dx, dy, w, h : INTEGER);
BEGIN
  BltBitMapRastPort(ADR(bm), xoffset, yoffset, rp, dx, dy, w, h, 0C0H);
END Blit;

PROCEDURE Titel;
VAR i, j : INTEGER;
BEGIN
  FOR i := 0 TO 15 DO SetRGB4(ADR(scr^.viewPort), i, 0, 0, 0) END;
  SetAPen(rp, 1);
  Move(rp, 0, 200+rp^.txBaseline); Text(rp, ADR("REVERSI 1.0"), 11);
  FOR i := 87 TO 0 BY -1 DO
    FOR j := 0 TO 7 DO
      IF ReadPixel(rp, i, 200+j)=1 THEN
        SetAPen(rp, 12); RectFill(rp, 28+i*3, 18+j*4, 31+i*3, 21+j*4);
        SetAPen(rp, 4);
        RectFill(rp, 29+i*3, 17+j*4, 32+i*3, 20+j*4);
      END
    END
  END;
  SetAPen(rp, 0); RectFill(rp, 0, 200, 100, 209);
  SchreibSchatt("written by Robert Brandner", 26, 0, 55, 320, 1);
  SchreibSchatt("This program is public domain!", 30, 0, 70, 320, 4);
  FOR i := 0 TO 4 DO
    FOR j := 0 TO 4 DO
      IF RND(4)<2 THEN
        IF RND(2)=0 THEN
          Blit(0, 0, 110+i*20, 90+j*20, 20, 20)
        ELSE
          Blit(20, 0, 110+i*20, 90+j*20, 20, 20)
        END
      END
    END
  END;
  LoadRGB4(ADR(scr^.viewPort), ADR(Colors), 16);
  SetRGB4(ADR(scr^.viewPort),11,0,0,0);
  SetRGB4(ADR(scr^.viewPort),12,0,0,0);
  REPEAT UNTIL NOT (gamePort0 IN ciaa.pra);
  REPEAT UNTIL gamePort0 IN ciaa.pra;
  FOR i := 0 TO 15 DO SetRGB4(ADR(scr^.viewPort), i, 0, 0, 0) END;
  SetRast(rp, 0);
END Titel;

PROCEDURE Start;
BEGIN
  WITH ns DO
    leftEdge:=0; topEdge:=0; width:=320; height:=210; depth:=4;
    detailPen:=0; blockPen:=1; viewModes:=ViewModeSet{};
    type:=customScreen; font:=ADR(ta); defaultTitle:=NIL;
    gadgets:=NIL; customBitMap:=NIL;
  END;
  scr := OpenScreen(ns);
  Assert(scr#NIL, ADR("Kein Screen!"));
  WITH nw DO
    leftEdge:=0; topEdge:=0; width:=320; height:=210; detailPen:=0;
    blockPen:=1; idcmpFlags:=IDCMPFlagSet{};
    flags:=WindowFlagSet{reportMouse,borderless,activate,rmbTrap,simpleRefresh};
    firstGadget:=NIL; checkMark:=NIL; title:=NIL;
    screen:=scr; bitMap:=NIL;type:=customScreen;
  END;
  win := OpenWindow(nw);
  Assert(win#NIL, ADR("Kein Window!"));
  rp := win^.rPort;
  SetRast(rp, 0);
  quit := FALSE;
  CopyMem(ADR(Werte), ADR(wert), SIZE(wert));
  InitBitMap(bm, 4, 130, 20);
  FOR i := 0 TO 3 DO
    pl := AllocRaster(130, 20);
    Assert(pl#NIL, ADR("Kein Speicher fr Graphik"));
    bm.planes[i] := pl;
    CopyMem(ADR(Graphics)+LONGINT(i*RasSize(130, 20)), pl, RasSize(130, 20));
  END;
  Titel;
  SetAPen(rp, 11);
  RectFill(rp, 0, 0, 319, 207);
  FOR i := 0 TO 25 DO
    SetAPen(rp, 10); Move(rp, 0, i*8); Draw(rp, 319, i*8);
    SetAPen(rp, 12); Move(rp, 0, i*8+7); Draw(rp, 319, i*8+7);
  END;
  FOR i := 0 TO 39 DO
    SetAPen(rp, 12); Move(rp, i*8, 0); Draw(rp, i*8, 207);
    SetAPen(rp, 10); Move(rp, i*8+7, 0); Draw(rp, i*8+7, 207);
  END;
  Quad(120, 8, 311, 199);
  FOR i := 0 TO GROSS-1 DO
    ch[0] := CHAR(INTEGER("8")-i);
    SchreibSchatt(ch, 1, 125, 30+i*20, 8, 1);
    ch[0] := CHAR(INTEGER("A")+i);
    SchreibSchatt(ch, 1, 143+i*20, 188, 8, 1);
  END;
  Quad(8, 8, 71, 23);
  SchreibSchatt("REVERSI", 7, 8, 12, 63, 4);
  Blit(60, 0, 72, 8, 40, 16);
  FOR i := 0 TO 1 DO
    Quad(8, 32+i*32, 31, 55+i*32); Quad(32, 32+i*32, 87, 55+i*32);
    Quad(88, 32+i*32, 111, 55+i*32);
  END;
  Blit(20, 0, 10, 34, 20, 20); Blit(0, 0, 10, 66, 20, 20);
  Quad(8, 96, 111, 135);
  Blit(110, 0, 10, 111, 10, 10);
  FOR i := 1 TO 9 DO Blit(110, 10, 10+i*10, 111, 10, 10) END;
  LoadRGB4(ADR(scr^.viewPort), ADR(Colors), 16);
END Start;

PROCEDURE ZeigWahl;
BEGIN
  FOR i := 0 TO 9 DO Blit(120, 0, 10+i*10, 98, 10, 10) END;
  FOR i := 0 TO 9 DO Blit(120, 0, 10+i*10, 124, 10, 10) END;
  IF WEISSP = MENSCH THEN
    Blit(100, 10, 10, 98, 10, 10)
  ELSE
    FOR i := 1 TO WTIEF DO Blit(100, 10, 10+i*10, 98, 10, 10) END;
  END;
  IF SCHWSP = MENSCH THEN
    Blit(100, 0, 10, 124, 10, 10)
  ELSE
    FOR i := 1 TO STIEF DO Blit(100, 0, 10+i*10, 124, 10, 10) END;
  END;
END ZeigWahl;

PROCEDURE ZeigBrett(brett : Brett);
VAR y, x : INTEGER;
    num : ARRAY[0..1] OF CHAR;
BEGIN
  anz[0] := 0; anz[1] := 0; anz[2] := 0;
  FOR y := 0 TO GROSS-1 DO
    FOR x := 0 TO GROSS-1 DO
      Blit(brett[y,x]*20, 0, 136+x*20, 24+y*20, 20, 20);
      INC(anz[brett[y,x]]);
    END
  END;
  num[0] := CHAR(INTEGER("0")+anz[WEISS] DIV 10);
  num[1] := CHAR(INTEGER("0")+anz[WEISS] MOD 10);
  Quad(88, 32, 111, 55);
  SchreibSchatt(num, 2, 88, 40, 24, 1);
  num[0] := CHAR(INTEGER("0")+anz[SCHWARZ] DIV 10);
  num[1] := CHAR(INTEGER("0")+anz[SCHWARZ] MOD 10);
  Quad(88, 64, 111, 87);
  SchreibSchatt(num, 2, 88, 72, 24, 1);
END ZeigBrett;

PROCEDURE MachAnfang;
BEGIN
  SCHWSP := AMIGA; WEISSP := MENSCH; STIEF := 1; WTIEF := 1;
  restart := FALSE; back := FALSE; zugnum := 0; maxzug := 0;
  amzug := WEISS; paused := FALSE;
  FOR y := 0 TO GROSS-1 DO
    FOR x := 0 TO GROSS-1 DO
      brett[y, x] := LEER;
    END
  END;
  brett[3,4] := SCHWARZ; brett[3,3] := WEISS;
  brett[4,4] := SCHWARZ; brett[4,3] := WEISS;
  ZeigBrett(brett); memory[zugnum].b := brett; memory[zugnum].sp := WEISS;
  Quad(32, 32, 87, 55);
  Quad(32, 64, 87, 87);
  Quad(8, 152, 111, 167); SchreibSchatt("Force Move", 10, 8, 156, 103, 1);
  Quad(8, 168, 47, 183);
  FOR i := 0 TO 1 DO
    SetAPen(rp, 10); Move(rp, 12+i*16, 175); Draw(rp, 24+i*16, 170);
    Draw(rp, 24+i*16, 181); SetAPen(rp, 12); Draw(rp, 12+i*16, 175);
  END;
  Quad(48, 168, 71, 183); Quad(52, 170, 58, 181); Quad(62, 170, 68, 181);
  Quad(72, 168, 111, 183);
  FOR i := 0 TO 1 DO
    SetAPen(rp, 10); Move(rp, 80+i*16, 170); Draw(rp, 92+i*16, 175);
    SetAPen(rp, 12); Draw(rp, 80+i*16, 181); Draw(rp, 80+i*16, 170);
  END;
  Quad(8, 184, 63, 199); SchreibSchatt("New", 3, 8, 188, 55, 1);
  Quad(64, 184, 111, 199); SchreibSchatt("Quit", 4, 64, 188, 47, 1);
  ZeigWahl;
END MachAnfang;

PROCEDURE MachZug(y, x, farb : INTEGER; VAR brett : Brett);
VAR dx, dy, px, py, xx, yy : INTEGER;
    moegl : BOOLEAN;
BEGIN
  brett[y, x] := farb;
  FOR dx := -1 TO 1 DO
    FOR dy := -1 TO 1 DO
      moegl := FALSE;
      IF (dx # 0) OR (dy # 0) THEN
        px := x + dx; py := y + dy;
        WHILE (px>=0) & (px<GROSS) & (py>=0) & (py<GROSS) &
              (brett[py, px] = (1-farb)) DO
          px := px + dx; py := py + dy;
          moegl := TRUE;
        END;
        IF moegl & (px>=0) & (px<GROSS) & (py>=0) & (py<GROSS) &
           (brett[py,px] = farb) THEN
          xx := x + dx; yy := y + dy;
          WHILE NOT ((xx = px) AND (yy = py)) DO
            brett[yy,xx] := farb;
            xx := xx + dx; yy := yy + dy;
          END
        END
      END
    END
  END;
END MachZug;

PROCEDURE ZeigZug(y, x, farb:INTEGER; VAR brett : Brett);
VAR dx, dy, px, py, xx, yy : INTEGER;
    moegl : BOOLEAN;
BEGIN
  FOR i := 0 TO 2 DO
    BltBitMapRastPort(ADR(bm), farb*20, 0, rp,
                        136+x*20, 24+y*20, 20, 20, 0C0H);
    Delay(4);
    BltBitMapRastPort(ADR(bm), 40, 0, rp,
                      136+x*20, 24+y*20, 20, 20, 0C0H);
    Delay(2);
  END;
  MachZug(y, x, farb, brett);
  ZeigBrett(brett);
  INC(zugnum); memory[zugnum].b:=brett; memory[zugnum].sp := 1-farb;
  maxzug := zugnum;
END ZeigZug;

PROCEDURE TestZug(y, x, farb : INTEGER; b : Brett) : BOOLEAN;
VAR dx, dy, px, py, xx, yy : INTEGER;
    moegl : BOOLEAN;
BEGIN
  IF b[y, x] # LEER THEN RETURN FALSE END;
  FOR dx := -1 TO 1 DO
    FOR dy := -1 TO 1 DO
      IF (dx # 0) OR (dy # 0) THEN
        px := x + dx; py := y + dy; moegl := FALSE;
        WHILE (px>=0) & (px<GROSS) & (py>=0) & (py<GROSS) &
              (b[py,px] = (1-farb)) DO
          moegl := TRUE;
          px := px + dx; py := py + dy;
        END;
        IF moegl & (px>=0) & (px<GROSS) & (py>=0) &
           (py<GROSS) & (b[py, px] = farb) THEN
          RETURN TRUE
        END
      END
    END
  END;
  RETURN FALSE
END TestZug;

PROCEDURE TestBrett(farb : INTEGER) : BOOLEAN;
VAR y, x : INTEGER;
BEGIN
  FOR y := 0 TO GROSS-1 DO
    FOR x := 0 TO GROSS-1 DO
      IF TestZug(y, x, farb, brett) THEN
        RETURN TRUE;
      END
    END
  END;
  RETURN FALSE;
END TestBrett;

PROCEDURE Bewertung(b : Brett; farb : INTEGER) : INTEGER;
VAR y, x, erg : INTEGER;
BEGIN
  erg := 0;
  FOR y := 0 TO GROSS-1 DO
    FOR x := 0 TO GROSS-1 DO
      IF b[y, x] = farb THEN INC(erg, wert[y, x])
      ELSIF b[y, x] = 1-farb THEN DEC(erg, wert[y, x])
      END;
    END
  END;
  RETURN erg;
END Bewertung;

PROCEDURE TestMaus(typ : INTEGER);
BEGIN
  IF NOT (gamePort0 IN ciaa.pra) THEN
    mx := scr^.mouseX; my := scr^.mouseY;
    IF (typ = AMIGA) & (mx>8) & (mx<111) & (my>152) & (my<167) THEN
      SetAPen(rp, 11); Move(rp, 8, 152); Draw(rp, 111, 152);
      Draw(rp, 111, 167); Draw(rp, 8, 167); Draw(rp, 8, 152);
      force := TRUE;
    ELSIF (mx>48) & (mx<71) & (my>168) & (my<183) & NOT paused THEN
      SetAPen(rp, 11); Move(rp, 48, 168); Draw(rp, 71, 168);
      Draw(rp, 71, 183); Draw(rp, 48, 183); Draw(rp, 48, 168);
      paused := TRUE;
    ELSIF paused THEN
      IF (mx>48) & (mx<71) & (my>168) & (my<183) THEN
        SetAPen(rp, 10); Move(rp, 48, 168); Draw(rp, 71, 168);
        Draw(rp, 71, 183); SetAPen(rp, 12); Move(rp, 48, 169);
        Draw(rp, 48, 183); Draw(rp, 71, 183);
        paused := FALSE;
      ELSIF (mx>8) & (mx<47) & (my>168) & (my<183) & (zugnum>0)
      THEN back := TRUE;
        SetAPen(rp, 11); Move(rp, 8, 168); Draw(rp, 47, 168);
        Draw(rp, 47, 183); Draw(rp, 8, 183); Draw(rp, 8, 168);
        DEC(zugnum); brett := memory[zugnum].b;
      ELSIF (mx>72) & (mx<111) & (my>168) & (my<183) & (zugnum<maxzug)
      THEN forward := TRUE;
        SetAPen(rp, 11); Move(rp, 72, 168); Draw(rp, 111, 168);
        Draw(rp, 111, 183); Draw(rp, 72, 183); Draw(rp, 72, 168);
        INC(zugnum); brett := memory[zugnum].b;
      ELSIF (mx>8) & (mx<63) & (my>184) & (my<199) THEN
        SetAPen(rp, 11); Move(rp, 8, 184); Draw(rp, 63, 184);
        Draw(rp, 63, 199); Draw(rp, 8, 199); Draw(rp, 8, 184);
        restart := TRUE;
      ELSIF (mx>64) & (mx<111) & (my>184) & (my<199) THEN
        SetAPen(rp, 11); Move(rp, 64, 184); Draw(rp, 111, 184);
        Draw(rp, 111, 199); Draw(rp, 64, 199); Draw(rp, 64, 184);
        quit := TRUE;
      ELSIF (mx>9) & (mx<19) & (my>98) & (my<108) THEN
        WEISSP := MENSCH; ZeigWahl;
      ELSIF (mx>9) & (mx<19) & (my>124) & (my<134) THEN
        SCHWSP := MENSCH; ZeigWahl;
      ELSIF (mx>19) & (mx<111) & (my>98) & (my<108) THEN
        WEISSP := AMIGA; WTIEF := (mx-9) DIV 10; ZeigWahl;
      ELSIF (mx>19) & (mx<111) & (my>124) & (my<134) THEN
        SCHWSP := AMIGA; STIEF := (mx-9) DIV 10; ZeigWahl;
      END;
    END;
    REPEAT UNTIL gamePort0 IN ciaa.pra;
  END
END TestMaus;

PROCEDURE MiniMax(farb, aktfarb, tief, alpha, beta : INTEGER;
                  br : Brett) : INTEGER;
VAR max, min, w, px, py : INTEGER;
    b :Brett;
BEGIN
  IF tief = 0 THEN RETURN Bewertung(br, farb) END;
  max := -10000; min := 10000;
  FOR py := 0 TO GROSS-1 DO
    FOR px := 0 TO GROSS-1 DO
      IF TestZug(py, px, aktfarb, br) THEN
        IF farb = aktfarb THEN
          IF max <= beta THEN
            b := br;
            MachZug(py, px, aktfarb, b);
            w := MiniMax(farb, 1-aktfarb, tief-1, max, 0, b);
            IF w>max THEN max := w END;
          END;
        ELSE
          IF min > alpha THEN
            b := br;
            MachZug(py, px, aktfarb, b);
            w := MiniMax(farb, 1-aktfarb, tief-1, 0, min, b);
            IF w<min THEN min := w END;
          END
        END;
        TestMaus(AMIGA);
        IF quit OR restart OR paused OR
           ((farb = WEISS) & (WEISSP # AMIGA)) OR
           ((farb = SCHWARZ ) & (SCHWSP # AMIGA)) THEN
          RETURN BREAK
        END;
        IF force THEN
          IF farb = aktfarb THEN RETURN max ELSE RETURN min END;
        END;
      END
    END
  END;
  IF farb = aktfarb THEN RETURN max ELSE RETURN min END;
END MiniMax;

PROCEDURE ComputerZug(farb, tiefe : INTEGER; VAR y, x : INTEGER);
VAR max, w, px, py : INTEGER;
    b : Brett;
BEGIN
  max := -10000; x := -1;
  FOR py := 0 TO GROSS-1 DO
    FOR px := 0 TO GROSS-1 DO
      IF TestZug(py, px, farb, brett) THEN
        b := brett;
        MachZug(py, px, farb, b);
        w := MiniMax(farb, 1-farb, tiefe-1, max, 0, b);
        IF w = BREAK THEN x := -1; RETURN END;
        IF (w>max) OR (x = -1) THEN max := w; x := px; y := py; END;
        TestMaus(AMIGA);
        IF restart OR quit OR paused OR ((farb = WEISS) & (WEISSP # AMIGA)) OR
           ((farb = SCHWARZ ) & (SCHWSP # AMIGA)) THEN RETURN END;
        IF force THEN
          SetAPen(rp, 10); Move(rp, 8, 152); Draw(rp, 111, 152);
          Draw(rp, 111, 167);
          SetAPen(rp, 12); Move(rp, 8, 153); Draw(rp, 8, 167);
          Draw(rp, 111, 167);
          force := FALSE; RETURN
        END;
      END
    END
  END;
END ComputerZug;

PROCEDURE MenschZug(farb : INTEGER; VAR y, x : INTEGER) : BOOLEAN;
BEGIN
  x := (mx-136) DIV 20;
  y := (my-24) DIV 20;
  IF (x >= 0) & (x < GROSS) & (y >= 0) & (y < GROSS) THEN
    IF TestZug(y, x, farb, brett) THEN
      RETURN TRUE
    ELSE
      SetRGB4(ADR(scr^.viewPort), 0, 15, 15, 15);
      Delay(1);
      SetRGB4(ADR(scr^.viewPort), 0, 0, 0, 0);
      RETURN FALSE;
    END
  END;
  RETURN FALSE;
END MenschZug;

PROCEDURE SpielEnde;
BEGIN
  IF anz[WEISS] > anz[SCHWARZ] THEN
    Schreib("Wins!", 5, WEISS); Schreib("Looses", 6, SCHWARZ);
  ELSIF anz[WEISS] < anz[SCHWARZ] THEN
    Schreib("Wins!", 5, SCHWARZ); Schreib("Looses", 6, WEISS);
  ELSE
    Schreib("Drawn", 5, SCHWARZ); Schreib("Drawn", 5, WEISS);
  END
END SpielEnde;

PROCEDURE TheEnd;
BEGIN
  IF win#NIL THEN CloseWindow(win) END;
  IF scr#NIL THEN CloseScreen(scr) END;
  FOR i := 0 TO 3 DO
    IF bm.planes[i] # NIL THEN
      FreeRaster(bm.planes[i], 130, 20)
    END
  END;
  IF topaz#NIL THEN CloseFont(topaz) END;
END TheEnd;

PROCEDURE Spiel;
BEGIN
  MachAnfang;
  LOOP
    WHILE paused DO
      TestMaus(PAUSE);
      IF back OR forward THEN
        amzug := memory[zugnum].sp;
        back := FALSE; forward := FALSE;
        IF amzug # KEIN
          THEN Schreib("Move", 4, amzug); Schreib("", 0, 1-amzug);
        ELSE
          SpielEnde;
        END;
        SetAPen(rp, 10); Move(rp, 8, 168); Draw(rp, 47, 168); Draw(rp, 47, 183);
        SetAPen(rp, 12); Move(rp, 8, 169); Draw(rp, 8, 183); Draw(rp, 47, 183);
        SetAPen(rp, 10); Move(rp, 72, 168); Draw(rp, 111, 168);
        Draw(rp, 111, 183); SetAPen(rp, 12); Move(rp, 72, 169);
        Draw(rp, 72, 183); Draw(rp, 111, 183);
        ZeigBrett(brett);
      END;
      IF restart OR quit THEN RETURN END;
    END;
    LOOP
      IF amzug = WEISS THEN
        wZieh := TestBrett(WEISS);
        IF NOT (wZieh OR sZieh) THEN
          SpielEnde; paused := TRUE; memory[zugnum].sp := KEIN;
          SetAPen(rp, 11); Move(rp, 48, 168); Draw(rp, 71, 168);
          Draw(rp, 71, 183); Draw(rp, 48, 183); Draw(rp, 48, 168);
          EXIT
        END;
        IF NOT wZieh THEN
          Schreib("Can't", 5, WEISS);
        ELSE
          Schreib("Move", 4, WEISS);
          LOOP
            IF WEISSP = MENSCH THEN
              LOOP
                WHILE gamePort0 IN ciaa.pra DO END;
                mx := scr^.mouseX; my := scr^.mouseY;
                TestMaus(MENSCH);
                IF paused THEN EXIT END;
                IF WEISSP # MENSCH THEN EXIT END;
                IF MenschZug(WEISS, zy, zx) THEN EXIT END;
              END;
            END;
            IF (WEISSP = AMIGA) THEN
              ComputerZug(WEISS, WTIEF, zy, zx);
            END;
            IF (zx # -1) OR paused THEN EXIT END;
          END;
          IF paused THEN EXIT END;
          ZeigZug(zy, zx, WEISS, brett);
          Schreib("", 0, WEISS);
        END;
        amzug := SCHWARZ;
      END;
      IF amzug=SCHWARZ THEN
        sZieh := TestBrett(SCHWARZ);
        IF NOT (sZieh OR wZieh) THEN
          SpielEnde; paused := TRUE; memory[zugnum].sp := KEIN;
          SetAPen(rp, 11); Move(rp, 48, 168); Draw(rp, 71, 168);
          Draw(rp, 71, 183); Draw(rp, 48, 183); Draw(rp, 48, 168);
          EXIT
        END;
        IF NOT sZieh THEN
          Schreib("Can't", 5, SCHWARZ);
        ELSE
          Schreib("Move", 4, SCHWARZ);
          LOOP
            IF SCHWSP = MENSCH THEN
              LOOP
                WHILE gamePort0 IN ciaa.pra DO END;
                mx := scr^.mouseX; my := scr^.mouseY;
                TestMaus(MENSCH);
                IF paused THEN EXIT END;
                IF SCHWSP # MENSCH THEN EXIT END;
                IF MenschZug(SCHWARZ, zy, zx) THEN EXIT END;
              END;
            END;
            IF SCHWSP = AMIGA THEN
              ComputerZug(SCHWARZ, STIEF, zy, zx);
            END;
            IF (zx # -1) OR paused THEN EXIT END;
          END;
          IF paused THEN EXIT END;
          ZeigZug(zy, zx, SCHWARZ, brett);
          Schreib("", 0, SCHWARZ);
        END;
        amzug := WEISS;
      END;
    END;
  END;
END Spiel;

BEGIN
  WITH ta DO
    name :=ADR("topaz.font"); ySize:=8; style:=normalFont;
    flags:=FontFlagSet{romFont,designed};
  END;
  topaz:=OpenFont(ADR(ta));
  Assert(topaz#NIL, ADR("Kein topaz.font"));
  Start;
  LOOP
    Spiel;
    IF quit THEN EXIT END;
  END;
CLOSE
 TheEnd
END Reversi.
